// *****************************************************************************
// outputAudio class
// *****************************************************************************
#ifndef outputAudio_h
#define outputAudio_h

#define MAX_AUDIO_OUTPUT_BUFFERS 700+1
class outputAudioClass 
{

	public:
									outputAudioClass();
									~outputAudioClass();
			bool					setAudioInputFormat(int channels, int sampleRate);
			bool					outputAudio(AUDIODATA * samples);
			void static CALLBACK	waveOutProc( HWAVEOUT hwo, UINT uMsg, DWORD dwInstance, DWORD dwParam1, DWORD dwParam2);
			void					waveOutProc1( HWAVEOUT hwo, UINT uMsg, DWORD dwInstance, DWORD dwParam1, DWORD dwParam2);
			bool					bufferStatus();
			bool					preBufferEnough();
			void					pause();
			void					play();
			void					stop();
			void					end();
			double					getOutputTimer();
			void					setVolume(int volume );
			int						getVolume();
			void					setMaxAudioBuffers(int max);



	private:
			WAVEFORMATEX			audioFormatIn;
			int						inputSampleRate;
			int						inputChannels;
			HWAVEOUT				outputHandle;
			WAVEHDR					audioBufferHeader[MAX_AUDIO_OUTPUT_BUFFERS];
			AUDIODATA *				audioBuffer[MAX_AUDIO_OUTPUT_BUFFERS];
			int						audioStatus[MAX_AUDIO_OUTPUT_BUFFERS];
			int						outputBufferLen;
			int						currentBuffer;
			bool					unprepare;
			int						maxAudioBuffers;
			DWORD					currentVolume;

};



#endif