// *****************************************************************************
// jobSubmit class
// *****************************************************************************
#ifndef jobserver_h
#define jobserver_h

// Status Values
//Slave's network status
enum {
	JOB_SERVER_NOT_CONNECTED =0,
	JOB_SERVER_CONNECTING,
	JOB_SERVER_CONNECTED,
	JOB_SERVER_FAILED,
};

#define JOB_SERVER_PORT_NUMBER 9985

#define makeJobServerFOURCC( ch0, ch1, ch2, ch3 ) \
	( (DWORD)(BYTE)(ch0) | ( (DWORD)(BYTE)(ch1) << 8 ) |	\
	( (DWORD)(BYTE)(ch2) << 16 ) | ( (DWORD)(BYTE)(ch3) << 24 ) )


// This must be a flat structure
typedef struct {
	DWORD			command;		// FourCC command
	int				size;			// number of bytes that follow
  } JOBSERVERHEADER;

// This must be a flat structure
typedef struct {
	int				jobNumber;
	char			jobName[MAX_PATH];
  } JOBSERVERQUEUEENTRY;

// This must be a flat structure
typedef struct {
	int						numJobsBeingProcessed;
	int						numJobsInQueue;
	int						numSlavesAvailable;
	JOBSERVERQUEUEENTRY		jobQueue[16];
	int						numStatsThatFollow;
	CONVERSIONSTATS	stats[1];
  } JOBSERVERSTATS;

#define jobServerSubmit				makeJobServerFOURCC('S', 'J', 'O', 'B')
#define jobServerStatus				makeJobServerFOURCC('S', 'T', 'A', 'T')
#define jobServerStatusReturn		makeJobServerFOURCC('S', 'T', 'R', 'T')
#define jobServerKill				makeJobServerFOURCC('K', 'I', 'L', 'L')
#define jobServerClose				makeJobServerFOURCC('C', 'L', 'O', 'S')

   class jobServerClass {

	public:
									jobServerClass();
									~jobServerClass();
#ifdef ENCODERSERVER
			int						processCommand(tcpClass * myTcp, SOCKET myRSocket);
			bool					receiveJob(tcpClass * myTcp, SOCKET myRSocket, int size);
			bool					sendStatus(tcpClass * myTcp, SOCKET myRSocket, int size);
#endif

#ifdef ENCODER
			bool					connectJobServer(char * networkName);
			bool					sendJob(FLATJOBENTRY * jobEntry);
			void					disconnectJobServer();
			bool					sendClose();
			JOBSERVERSTATS *		getStatus();

#endif ENCODER

	protected:
		tcpClass *					tcp;
		int							connectionStatus;
		SOCKET						commSocket;

};

#endif