#ifndef netcommands_h
#define netcommands_h

// This file has all the shared master / slave communication defines

#define PORT_NUMBER 9984

#define makeNetFOURCC( ch0, ch1, ch2, ch3 ) \
	( (DWORD)(BYTE)(ch0) | ( (DWORD)(BYTE)(ch1) << 8 ) |	\
	( (DWORD)(BYTE)(ch2) << 16 ) | ( (DWORD)(BYTE)(ch3) << 24 ) )

#define netStartConversion			makeNetFOURCC('C', 'O', 'N', 'V')
#define netStatus					makeNetFOURCC('S', 'T', 'A', 'T')
#define netClose					makeNetFOURCC('C', 'L', 'O', 'S')
#define netError					makeNetFOURCC('E', 'R', 'O', 'R')
#define netAbort					makeNetFOURCC('A', 'B', 'R', 'T')
#define netPause					makeNetFOURCC('P', 'A', 'U', 'S')
#define netResume					makeNetFOURCC('R', 'S', 'U', 'M')
#define netSleep					makeNetFOURCC('S', 'L', 'E', 'P')
#define netShutdown					makeNetFOURCC('S', 'H', 'D', 'N')
#define netThreadPriority			makeNetFOURCC('T', 'P', 'R', 'I')

#define NET_COMMAND_HEADER_SIZE 8

#define MAX_NET_ERROR_RETRIES 2
#define MAX_NET_SLAVE_DROP_RETRIES 5
//#define MAX_NET_DEAD_TEST (1000*60*60)
#define MAX_NET_DEAD_TEST (1000*60*10)

// Status Values
enum {
	netConversionStatusCommandFailed=0,
	netConversionStatusIdle,
	netConversionStatusWorking,
	netConversionStatusError,
	netConversionStatusDone,
	netConversionStatusSlaveDied,
	netConversionStatusVersionMismatch

} ;

// This must be a flat structure
typedef struct {
	DWORD			command;		// FourCC command
	int				size;			// number of bytes that follow
	FLATJOBENTRY	flatJob;
  } NETSTARTCONVERSION;

typedef struct {
	int				status;
} NETSTARTCONVERSIONRETURN;

typedef struct {
	DWORD			command;		// FourCC command
	int				size;			// number of bytes that follow
} NETSTATUS;

typedef struct {
	int				status;
	CONVERSIONSTATS	conversionStats;
} NETSTATUSRETURN;

typedef struct {
	DWORD			command;		// FourCC command
	int				size;			// number of bytes that follow
} NETERROR;

typedef struct {
	char			errorText[8192];
} NETERRORRETURN;

typedef struct {
	DWORD			command;		// FourCC command
	int				size;			// number of bytes that follow
} NETABORT;

typedef struct {
	DWORD			command;		// FourCC command
	int				size;			// number of bytes that follow
} NETPAUSE;

typedef struct {
	DWORD			command;		// FourCC command
	int				size;			// number of bytes that follow
} NETRESUME;

typedef struct {
	DWORD			command;		// FourCC command
	int				size;			// number of bytes that follow
	int				sleepValue;
} NETSLEEP;

typedef struct {
	DWORD			command;		// FourCC command
	int				size;			// number of bytes that follow
	bool			shutdown;
} NETSHUTDOWN;

typedef struct {
	DWORD			command;		// FourCC command
	int				size;			// number of bytes that follow
	int				threadPriority;
} NETTHREADPRIORITY;

typedef struct {
	DWORD			command;		// FourCC command
	int				size;			// number of bytes that follow
} NETCLOSE;

#endif