// *****************************************************************************
//	Vidomi - Video Encoder
//
//	Copyright (C) 2001 Vidomi, Inc.
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

// *****************************************************************************
// *****************************************************************************
// audiopostprocess class
// *****************************************************************************
#ifndef audiopostprocess_h
#define audiopostprocess_h

extern void dvd2AviResampleInit();
extern int dvd2AviResample(unsigned char * source, unsigned char * dest, int size);

#define AUDIO_BUFFER_SIZE 512000
#define NORMALIZE_NONE 0
#define NORMALIZE_ONE_PASS 1
#define NORMALIZE_TWO_PASS 2

class audioPostProcessClass 
{

	public:
									audioPostProcessClass();
									~audioPostProcessClass();
			bool					begin(int sampleRate, int channels);
			void					setResample(bool setOn);
			void					setStreamCopy(bool setOn);
			void					setNormalize(int normType, int level,short normalizeMin, short normalizeMax);
			void					getNormalizeMinMax(short * min, short * max);
			void					processForMinMax(AUDIODATA * inputSamples);
			AUDIODATA *				processSamples(AUDIODATA * inputSamples);
			void					getOutputRate(int * sampleRate, int * channels);
			void					end();
			void					resetAudioPts();
			bool					init();
			AUDIODATA *				normalizeSamples(AUDIODATA * inputSamples);
			void					computeNormalizeRatio(short minSamp, short maxSamp);
	


	private:
			bool					resample;
			bool					resampleWork;
			int						outputSampleRate;
			int						outputChannels;
			AUDIODATA *				processBuffer[2];
			DVD2AVIRESAMPLEINIT		dvd2AviResampleInit;
			DVD2AVIRESAMPLE			dvd2AviResample;
			HINSTANCE				d2aDll;	
			char *					pathToDll;
			bool					firstTime;
			int						audioPts;
			double					errorAccum;
			int						normalize;
			int						normalizeLevel;
			short					normalizeMin;
			short					normalizeMax;
			short					normalizeMinFound;
			short					normalizeMaxFound;
			double					normalizeRatio;
			bool					streamCopy;




};

#endif