// *****************************************************************************
//	Vidomi - Video Encoder
//
//	Copyright (C) 2001 Vidomi, Inc.
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

// *****************************************************************************
// *****************************************************************************
// avRead class - This is a wrapper for all read* functions
// *****************************************************************************
#ifndef avread_h
#define avread_h

class avReadClass 
{

	public:
			virtual void			addInput(char * inputFilename) = NULL;
			virtual bool			begin(int mode) = NULL;
			virtual void			setIdct(int idctType) = NULL;
			virtual void			clearInput() = NULL;
			virtual bool			init() = NULL;
			virtual void			end() =NULL;
			virtual bool			checkEnd() = NULL;
			virtual int				decodeFrame() = NULL;

			virtual FRAMEDATA *		getFrameData() = NULL;
			virtual void			getDimentions(int * width, int * height, double * aspectRatio) = NULL;
			virtual void			getAudioOutput(int channelIndex, int * outChannels, int * outSampleRate) = NULL;
			virtual float			getFramerate() = NULL;
			virtual void			setFilm(bool film) = NULL;
			virtual AUDIODATA *		getAudioData(int channelIndex) = NULL;
			virtual void			setAudio(bool audio, int channelIndex, int audioType, int audioTrack, int streamCopy) = NULL;
			virtual __int64			getLength(void) = NULL;
			virtual __int64			getCurPos(void) = NULL;
			virtual bool			seekPos(__int64) = NULL;
			virtual long			getNextKeyframe(void) = NULL;
			virtual long			getPrevKeyframe(void) = NULL;
			virtual bool			seekFramePos(long frame) = NULL;
			virtual long			getFramePos() = NULL;
			virtual int				skipFrame() = NULL;
			virtual	void			setDecodeMode(int mode) = NULL;
			virtual long			getClosestKeyframe(int seekFrame) = NULL;
			virtual SUBTITLEDATA *	getSubtitleData(int channelIndex) = NULL;
			virtual void			setSubtitle(bool subEnabled,int channelIndex, int subtitleTrack) = NULL;
			virtual int				getFrameType(void) = NULL;


};



#endif