// *****************************************************************************
//	Vidomi - Video Encoder
//
//	Copyright (C) 2001 Vidomi, Inc.
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

// *****************************************************************************
// *****************************************************************************
//
//
// conversion.cpp
// 
//
// *****************************************************************************

#include "en.h"

extern GLOBALS * globals;

// *****************************************************************************
// conversionMpegClass::conversionMpegClass()
//
// conversionMpeg class constructor
// *****************************************************************************
conversionMpegClass::conversionMpegClass()
{

}

// *****************************************************************************
// conversionMpegClass::~conversionMpegClass()
//
// conversionMpeg class destructor
// *****************************************************************************
conversionMpegClass::~conversionMpegClass()
{


}

// *****************************************************************************
// conversionMpegClass::startSingleConversion()
//
// Returns TRUE if success
// *****************************************************************************
bool conversionMpegClass::startSingleConversion(CONVERTCONFIG * convertConfig, GATHERRESULTS * gatherResults)
{
	int sourceHandle;
	int destHandle;
	__int64 copyBytes;
	unsigned char * copyBuffer;
	int bufferSize;
	int bytesRead;
	int bytesToCopy;
	bool error;
	bool foundPackStart;
	__int64 pos;
	__int64 packStart;

	unsigned char * bufferPos;
	unsigned char byte1,byte2,byte3,byte4,byte5,byte6;
	unsigned char frameType;
	int i;
	char outputName[MAX_PATH];

	settings = convertConfig;
	inputInfo = gatherResults;

	sourceHandle = _open(settings->inputFilenames[0],_O_BINARY | _O_RDONLY);
	if(sourceHandle==-1)
		{
		return(false);
		}

	copyBytes = settings->rangelist[0].endingFilePos - settings->rangelist[0].startingFilePos;
	bufferSize = 1024000;
	foundPackStart = false;

	copyBuffer = new unsigned char [bufferSize];
	
	pos = settings->rangelist[0].startingFilePos;

	foundPackStart = false;

	for(;;)
		{
		_lseeki64(sourceHandle,pos,SEEK_SET);
		bytesRead = _read(sourceHandle,copyBuffer,bufferSize);

		if(bytesRead != bufferSize)
			{
			delete [] copyBuffer;
			_close(sourceHandle);
			return(false);
			}
		bufferPos = copyBuffer;
		for(i=0;i<bufferSize-8;i++)
			{
			byte1 = *bufferPos;
			byte2 = *(bufferPos+1);
			byte3 = *(bufferPos+2);
			byte4 = *(bufferPos+3);
			byte5 = *(bufferPos+4);
			byte6 = *(bufferPos+5);

			// Find the first pack code
			
			if((byte1 ==0) && (byte2 == 0) && (byte3 ==1) && (byte4==0xba))
				{
				packStart = pos;
				}
			
			if((byte1 ==0) && (byte2 == 0) && (byte3 ==1) && (byte4==0x00))
				{
				frameType = (byte6&0x38)>>3;

				if(frameType == 1)
					{
					foundPackStart = true;
					break;
					}
				}
			
			pos++;
			bufferPos++;
			}

		if(foundPackStart)
			break;
		}

	copyBytes = settings->rangelist[0].endingFilePos - packStart;
	_lseeki64(sourceHandle,packStart,SEEK_SET);

	strcpy(outputName,settings->outputFilename);
	strcat(outputName,".mpg");

	destHandle = _open(outputName,O_BINARY | _O_CREAT | _O_WRONLY);
	if(destHandle==-1)
		{
		_close(sourceHandle);
		return(false);
		}
	_lseeki64(destHandle,0,SEEK_SET);


	error = false;
	
	for(;;)
		{
		bytesToCopy = bufferSize;

		if(bytesToCopy>copyBytes)
			{
			bytesToCopy = (int) copyBytes;
			}

		bytesRead = _read(sourceHandle,copyBuffer,bytesToCopy);
		if(!bytesRead)
			{
			error = true;
			break;
			}
		if(_write(destHandle,copyBuffer,bytesRead)!=bytesRead)
			{
			error = true;
			break;			
			}
		copyBytes-=bytesRead;
		if(!copyBytes)
			break;
		}
	_close(sourceHandle);
	_close(destHandle);
	delete [] copyBuffer;
	return(!error);

}