// *****************************************************************************
//	Vidomi - Video Encoder
//
//	Copyright (C) 2001 Vidomi, Inc.
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

// *****************************************************************************
// *****************************************************************************
// decodeVideo class
// *****************************************************************************
#ifndef decodevideo_h
#define decodevideo_h

class decodeVideoClass 
{

	public:
									decodeVideoClass();
									~decodeVideoClass();
			bool					init();

			bool					setVideoOutputFormat(int width, int height);
			bool					setVideoInputFormat(BITMAPINFOHEADER * formatIn);
			bool					startDecoder();
			FRAMEDATA *				decode(FRAMEDATA * frameIn);
			bool					endDecoder();
			int						delta(FRAMEDATA * image1, FRAMEDATA * image2);
			bool					detectSceneChange(FRAMEDATA * image1);
			bool					detectSceneChangeInit(int min, int max);
			double					computeLumananceValue(FRAMEDATA * image);
			double					computeLumananceValueRgb32(FRAMEDATA * image);
			double					computeLumananceValueYv12(FRAMEDATA * image);
			bool					detectSceneChangeRgb32(FRAMEDATA * image1);
			bool					detectSceneChangeYv12(FRAMEDATA * image1);

	private:
			BITMAPINFOHEADER		bitmapFormatIn;
			BITMAPINFOHEADER		bitmapFormatOut;
			FRAMEDATA *				frameOut;
			int						videoWidth;
			int						videoHeight;
			HIC						videoHic;
			int						histogram[50][64];
			int						histCur;
			int						histPrev;
			int						sceneDetectFrame;
			int						minKeyFrame;
			int						maxKeyFrame;
};


#endif