// *****************************************************************************
//	Vidomi - Video Encoder
//
//	Copyright (C) 2001 Vidomi, Inc.
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

// *****************************************************************************
// *****************************************************************************
// deepScan class
// *****************************************************************************
#ifndef deepscan_h
#define deepscan_h

#define DEEPSCAN_BUFFER_SIZE 1024000
#define SEQUENCE_EXTENSION 1

#define PICTURE_HEADER 0x100
#define SEQUENCE_HEADER 0x01b3
#define EXTENSION_HEADER 0x01b5
#define GOP_HEADER 0x1b8
#define PACK_START 0x01ba
#define SYSTEM_START_CODE 0x1BB
#define PRIVATE_STREAM 0x01BD
#define PADDING_STREAM 0x1BE
#define PRIVATE_STREAM2 0x1BF
#define MPEG_STREAM7 0x1C7
#define MPEG_STREAM6 0x1C6
#define MPEG_STREAM5 0x1C5
#define MPEG_STREAM4 0x1C4
#define MPEG_STREAM3 0x1C3
#define MPEG_STREAM2 0x1C2
#define MPEG_STREAM1 0x1C1
#define MPEG_STREAM0 0x1C0
#define VIDEO_ELEMENTARY 0x1E0
#define PROGRAM_DIRECTORY 0x1FF

#define IFRAME 1
#define PFRAME 2
#define BFRAME 3

typedef struct {
	__int64		pos;
	int			type;
} DEEPSCANFRAMEENTRY;

typedef struct {
	DEEPSCANFRAMEENTRY	frame[1];
} DEEPSCANFRAMES;
class deepScanClass 
{

	public:
									deepScanClass();
									~deepScanClass();
		bool						deepScan(CONVERTCONFIG * settings,GATHERRESULTS * fileInfo);

	private:
		bool						scan();
		bool						setPos(__int64 pos);
		unsigned long				getBits(int numBits);
		void						alignFrame(void);
		unsigned long				peekBits(int numBits);
		void						flushBits(int numBits);
		unsigned char				getByte();



		unsigned char *				readBuffer;
		int							numFiles;
		int							curFile;
		int							inFiles[128];
		__int64						inSize[128];
		__int64						inStart[128];
		__int64						inEnd[128];
		__int64						totalSize;
		__int64						scanSize;
		__int64						bufferStart;
		__int64						bufferEnd;
		int							bufferPos;
		int							bitsRemaining;
		bool						reachedEnd;
		DEEPSCANFRAMES *			scanFrames;
		int							scanFramesPos;
		int							scanFramesSize;

};


#endif