// *****************************************************************************
//	Vidomi - Video Encoder
//
//	Copyright (C) 2001 Vidomi, Inc.
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

// *****************************************************************************
// *****************************************************************************
//
// en.h header
//
// *****************************************************************************

// Target Win98 and Win NT API's
#define _WIN32_WINDOWS 0x0410
#define WINVER 0x0400

class conversionClass;
class conversionMpegClass;
class writeAviClass;
class readMpegClass;
class postProcessClass;
class audioPostProcessClass;
class registryClass;
class mp3EncodeClass;
class readAviClass;
class mp3DecodeClass;
class encodeVideoClass;
class decodeVideoClass;
class divxClass;
class subtitlesClass;
class translateClass;
class netSlaveClass;
class tcpClass;
class jobHelperClass;
class renderSubtitlesClass;

#ifndef VIDOMISLAVE
class outputVideoClass;
class outputAudioClass;
class windowClass;
class optionsVideoClass;
class optionsAudioClass;
class optionsGeneralClass;
class scanFileClass;
class optionsAdvancedVideoClass;
class optionsSpecialClass;
class settingsClass;
class selectRangeClass;
class jobClass;
class encodeControlClass;
class optionsSubtitleClass;
class ifoClass;
class optionsChaptersClass;
class deepScanClass;
class netConversionClass;
class netMasterClass;
class outputStatsClass;
class optionsOutputSizeClass;
class optionsNetworkClass;
class skinsClass;
class jobServerClass;
class netHelperClass;
#endif

#ifdef VIDOMISLAVE
class slaveWindowClass;
class slaveOptionsClass;
#endif

#include <winsock2.h>
#include <windows.h>
#include <winuser.h>
#include <stdio.h>
#include <stdarg.h>
#include <shlobj.h>
#include <vfw.h>
#include <msacm.h>
#include <io.h>
#include <fcntl.h>
#include <wininet.h>
#include <process.h>
#include <string.h>
#include <math.h>
#include <rpc.h>
#include <direct.h>
#include <winbase.h>
#include <sys\stat.h>
#include <richedit.h>
#include <wingdi.h>
// DLL import and shared structures
#include "../commonall/divxtypes.h"
#include "../commonencoder/common.h"
#include "../version/version.h"

#include "ncoded2a\dvd2avi.h"
#include "ncodefls\flask.h"
#include "lameenc\lameenc.h"

#include "avread.h"
#include "../commonencoder/convertconfig.h"
#include "encoder.h"

#ifndef VIDOMISLAVE
#include "encodermaster.h"
#endif

#ifdef VIDOMISLAVE
#include "slave/encoderslave.h"
#endif

#include "../commonall/log.h"
#include "conversion.h"
#include "conversionmpeg.h"
#include "writeavi.h"
#include "readmpeg.h"
#include "postprocess.h"
#include "audiopostprocess.h"
#include "mp3encode.h"
#include "readavi.h"
#include "mp3Decode.h"
#include "encodevideo.h"
#include "decodevideo.h"
#include "../commonall/divx.h"
#include "divxNetworksstate.h"
#include "subtitles.h"
#include "../commonall/translate.h"
#include "../commonencoder/netCommands.h"
#include "netSlave.h"
#include "../commonencoder/tcp.h"
#include "xvidstate.h"
#include "registry.h"
#include "../commonencoder/jobHelper.h"
#include "../commonencoder/rendersubtitles.h"


#ifndef VIDOMISLAVE
#include "resource.h"
#include "outputvideo.h"
#include "../commonall/outputaudio.h"
#include "outputstatistics.h"
#include "scanfile.h"
#include "window.h"
#include "optionsvideo.h"
#include "optionsaudio.h"
#include "optionsgeneral.h"
#include "optionsadvancedvideo.h"
#include "optionsspecial.h"
#include "settings.h"
#include "selectrange.h"
#include "job.h"
#include "encodeControl.h"
#include "optionssubtitles.h"
#include "ifo.h"
#include "optionsChapters.h"
#include "deepscan.h"
#include "netConversion.h"
#include "../commonencoder/netMaster.h"
#include "optionsOutputSize.h"
#include "optionsNetwork.h"
#include "../commonall/zlib/unzip.h"
#include "skinsmessagesen.h"
#include "../commonall/skins.h"
#include "../commonencoder/jobServer.h"
#include "../commonencoder/netHelper.h"
#endif

#ifdef VIDOMISLAVE
#include "slave/slaveresources.h"
#include "slave/slaveWindow.h"
#include "slave/slaveOptions.h"
#endif


