#include "../en.h"

GLOBALS * globals;

int main(int argc, char * argv[])
{
	ENCODESLAVES * slaveList;
	int numSlaveEncodeMachines;
	netMasterClass * netMaster;

	// Now Configure the globals
	configureGlobals(0);

	// Now Init the Logging mechanism
	clearLog();	//clear text based log file

	// Simple Encode Startup

	numSlaveEncodeMachines = 1;

	// Create the slave list (For now just this computer)
	slaveList = new ENCODESLAVES [sizeof(ENCODESLAVESINGLE)*numSlaveEncodeMachines];
	memset(slaveList,0,sizeof(ENCODESLAVES)*numSlaveEncodeMachines);

	strcpy(slaveList->slave[0].networkName,"127.0.0.1");
	strcpy(slaveList->slave[0].name,"Local Machine");
	slaveList->slave[0].port = PORT_NUMBER;
		// These are floats, so init to 0.0f
	slaveList->slave[0].conversionStats.percentOfPassComplete = 0.0f;
	slaveList->slave[0].conversionStats.framesPerSecond = 0.0f;

	// Create the master communication module
	netMaster = new netMasterClass();

	// Give the master the list of slaves it owns
	netMaster->begin(numSlaveEncodeMachines, slaveList);

	
	// Call net Master with command to start encoding on a Slave
	netMaster->sendJob(0,globals->convertConfig,globals->gatherResults);
	
	// Do a status check to see if it worked
	// then exit

	netMaster->end();
	delete netMaster;
	delete [] slaveList;
	delete [] globals;

	printf("CLI Encoder Version of Vidomi\n\n");
	return(true);

}

// *****************************************************************************
//  Configure the Globals and put/get from registry
// *****************************************************************************
void configureGlobals(HINSTANCE hInst)
{
	char * commandLine;
	char * tempStr;
	char * tempPtr;
	char * pathToExe;
	bool done;

	// Create Global Var Struct
	globals = new GLOBALS [1];
	memset(globals,0,sizeof(GLOBALS));
	
	globals->hWnd = NULL;
	globals->hInst = hInst;
	// Now lets have some fun and create the path to the EXE
	commandLine = GetCommandLine();
	tempStr = new char [MAX_PATH];
	pathToExe = new char [MAX_PATH];
	strcpy(tempStr,commandLine);
	done=false;

	//walk through the path until we locate .exe
	tempPtr = tempStr;
	while(1)
		{
		if(!(tempPtr = strchr(tempPtr,'.')))
			{
			// if can't find .exe, then use CWD
			GetCurrentDirectory(MAX_PATH, pathToExe);
			done=true;
			break;
			}
		if((*(tempPtr+1) == 'e') && (*(tempPtr+2)=='x') && (*(tempPtr+3) == 'e'))
			{	
			*(tempPtr+4) = 0;
			break;
			}
		if((*(tempPtr+1) == 'E') && (*(tempPtr+2)=='X') && (*(tempPtr+3) == 'E'))
			{	
			*(tempPtr+3) = 0;
			break;
			}
		//Advance to the next Char
		if(tempPtr)
			{
			tempPtr++;
			}
		}

	if(!done)
		{
		// Remove leading quote if any
		if(tempStr[0] == '\"')
			{
			strcpy(pathToExe,&tempStr[1]);
			}
		else
			{
			strcpy(pathToExe,tempStr);
			}
		
		//Now wack off everything after the last "\"
		if(tempPtr = strrchr(pathToExe,'\\'))
			{
			*tempPtr = 0;
			}
		else
			{
			GetCurrentDirectory(MAX_PATH, pathToExe);
			}
		}

	//pathToExe now holds the path to the EXE dir
	strcpy(globals->pathToExeDir,pathToExe);
	// Set Default Values debug vars
	
	//GetCurrentDirectory(MAX_PATH, globals->pathToExeDir);
	strcpy(globals->optionsLogFilename,globals->pathToExeDir);
	strcat(globals->optionsLogFilename, "\\encoderclidebug.txt");

	globals->optionsLogOutput = false;

	globals->version=VERSION;
	globals->dualCpuEncodeBuffers=8;

	strcpy(globals->vidomiLanguage, "english");


}

