// *****************************************************************************
//	Vidomi - Video Encoder
//
//	Copyright (C) 2001 Vidomi, Inc.
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

// *****************************************************************************
// *****************************************************************************
//
// This is encodermaster.h
//
// *****************************************************************************

#ifndef encodermaster_h
#define encodermaster_h

typedef struct 
	{

	HWND					hWnd;
	bool					optionsUp;
	HINSTANCE				hInst;
	int						cpuType;
	int						optionsLogOutput;
	char					optionsLogFilename[MAX_PATH];
	windowClass *			window;
	conversionClass *		conversion;
	netConversionClass *	netConversion;
	outputVideoClass *		outputVideo;
	outputAudioClass *		outputAudio;
	scanFileClass *			scanFile;
	optionsVideoClass *		optionsVideo;
	optionsAdvancedVideoClass *	optionsAdvancedVideo;
	optionsSpecialClass *	optionsSpecial;
	optionsAudioClass *		optionsAudio;
	optionsGeneralClass *	optionsGeneral;
	registryClass *			registry;
	outputStatsClass *		outputStats;
	settingsClass *			settings;
	selectRangeClass *		selectRange;
	jobClass *				job;
	encodeControlClass *	encodeControl;
	optionsSubtitleClass *	optionsSubtitle;
	translateClass *		translate;
	optionsChaptersClass *	optionsChapters;
	optionsOutputSizeClass * optionsOutputSize;
	optionsNetworkClass *	optionsNetwork;
	jobServerClass *		jobServer;
	jobHelperClass *		jobHelper;
	netHelperClass *		netHelper;
	int						windowTop;
	int						windowLeft;
	int						outputTop;
	int						outputLeft;
	int						statsTop;
	int						statsLeft;
	int						jobTop;
	int						jobLeft;
	int						encodeControlTop;
	int						encodeControlLeft;
	float					version;
	char					pathToExeDir[MAX_PATH];
	CONVERTCONFIG *			convertConfig;
	GATHERRESULTS *			gatherResults;
	JOBLISTENTRY			jobList[MAX_JOBS];
	int						jobCount;
	int						jobIndex;
	int						vidomiMode;
	HWND					vidomiSwitcherhWnd;
	char					playFilename[MAX_PATH];
	bool					contactVidomi;
	char					browseSourcePath[MAX_PATH];
	int						browseSourceDefaultType;
	char					browseDestPath[MAX_PATH];
	int						browseDestDefaultType;
	bool					converting;
	char					browseSettingsPath[MAX_PATH];
	int						browseSettingsDefaultType;
	int						dualCpuEncodeBuffers;
	bool					divxNetworksInstalled;
	char					vidomiLanguage[MAX_PATH];
	char *					errorText;
	int						numSlaveEncodeMachines;
	SLAVEENCODEMACHINES *	slaveEncodeMachines;			
	char					browseJobListPath[MAX_PATH];
	int						browseJobListDefaultType;
	char					currentSkin[MAX_PATH];
	char					encodeServerIPAddress[MAX_PATH];
	bool					encodeServerEnabled;
	} GLOBALS;


void configureGlobals(HINSTANCE hInst);
void configureSmartAVDefaults(CONVERTCONFIG * convertConfig);
BOOL CALLBACK EnumWindowsProc(HWND hwnd, LPARAM lParam);
int vidomiErrorBox(HWND hWnd,char * text, char * caption, unsigned int type);
void xvidHelper();

#endif
