// *****************************************************************************
//	Vidomi - Video Encoder
//
//	Copyright (C) 2001 Vidomi, Inc.
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

// *****************************************************************************
// *****************************************************************************
// writeavi class
// *****************************************************************************
#ifndef encodevideo_h
#define encodevideo_h

class encodeVideoClass 
{

	public:
									encodeVideoClass();
									~encodeVideoClass();
			bool					init(CONVERTCONFIG * settings);
			bool					setVideoInputFormat(int width,int height, float framerate, int colorSpace);
			bool					setVideoOutputFormatCbr(COMPVARS * videoDefault);
			bool					setVideoOutputFormatVbr(DWORD fourCC);
			bool					setVideoOutputFormatDivxNetworks(COMPVARS * videoDefault);
			bool					setVideoOutputFormatXvid(COMPVARS * videoDefault);

			bool					startEncoder(bool firstTime);
			bool					endEncoder();
			FRAMEDATA *				encode(FRAMEDATA * frame, DWORD * flags);
			BITMAPINFOHEADER *		getFormatOut();
			DWORD					getFccHandler();
			void					setBitsRemaining(int val);
			int						getBitsRemaining();
			void					setCurrentCompressionLevel(int val);
			int						getCurrentCompressionLevel();
			void					setCompressionMinMax(int min, int max);
			void					setDataRate(int val);
			int						getDataRate();
			void					setCrispness(int val);
			void					setDeltaFrame(int val);
			bool					setDivxNetworksLogFile(char * logFile);
			bool					setDivxNetworksEncodeMode(int encodeMode, int pass);
			bool					setDivxNetworksBitrate(int bitrate);
			bool					updateDivxNetworksBitrate(int bitrate);
			void					setDivxNetworksKeyframe(bool keyframe);
			bool					setXvidLogFile(char * logFile);
			bool					setXvidEncodeMode(int encodeMode, int pass);
			bool					setXvidBitrate(int bitrate);
			bool					updateXvidBitrate(int bitrate);
			bool					setXvidFilesize(__int64 size);
			void					setXvidKeyframe(bool keyframe);
			void					rgb32ToRgb24(FRAMEDATA * srcFrame, FRAMEDATA * dstFrame);

	private:
			BITMAPINFOHEADER		bitmapFormatIn;
			BITMAPINFOHEADER *		bitmapFormatOut;
			COMPVARS				writeVideoSettings;
			ICINFO					videoCodecInfo;
			float					videoFramerate;
			int						videoWidth;
			int						videoHeight;
			int						videoBpp;
			int						videoColorSpace;
			bool					videoInputSet;
			FRAMEDATA	*			frameOut;
			FRAMEDATA *				frameTemp;
			int						nextKeyFrame;
			int						frameCounter;
			bool					vbrMode;
			int						curDataRate;
			int *					divxCrispness;
			int *					divxCurrentCompressionLevel;
			int *					divxDeltaFrame;
			int *					divxBitsPerFrame;
			double *				divxKbps;
			int *					divxMaxCompressionLevel;
			int *					divxMinCompressionLevel;
			int *					divxBitsRemaining;
			int *					divxBitsMax;
			int *					divxBitsMin;
			int *					divxBitrate;
			double *				divxKbps2;
			int *					divxLimit;
			int *					divxBitsPerFrame2;
			bool					uncompressed;
			bool					divxNetworksMode;
			int						divxNetworksEncodeBitrate;
			int						divxNetworksEncodeMode;
			bool					xvidMode;
			bool					xvidVbrMode;
			bool					divxNetworksVersion5;
			int						xvidEncodeModeOffset;
			int						xvidBitrateOffset;
			int						xvidDesiredSizeOffset;
			int						xvidStatsFilenameOffset;
			int						divx4VbrModeOffset;
			int						divx4BitrateOffset;
			int						divx5BitrateOffset;
			int						divx5VbrModeOffset;
			bool					keyframeCodecRestartMode; 
			int						xvidEncodeBitrate;
			bool					convertTo24Bpp;

};


#endif