/*____________________________________________________________________________

	MP3 Decode init routine. 


____________________________________________________________________________*/
#include <stdlib.h>


#include "mhead.h"		/* mpeg header structure, decode protos */
#include "port.h"

#define TRUE 1
#define FALSE 0

typedef struct
	{
      int (*decode_init) (MPEG_HEAD * h, int framebytes_arg,
			  int reduction_code, int transform_code,
			  int convert_code, int freq_limit);
      void (*decode_info) (DEC_INFO * info);
        IN_OUT(*decode) (unsigned char *bs, short *pcm);
	} AUDIO;
   
static AUDIO audio;

static AUDIO audio_table[2][2] =
	{
      {
	 {audio_decode_init, audio_decode_info, audio_decode},
	 {audio_decode8_init, audio_decode8_info, audio_decode8},
      },
      {
	 {i_audio_decode_init, i_audio_decode_info, i_audio_decode},
	 {audio_decode8_init, audio_decode8_info, audio_decode8},
      }
	};

MPEG_HEAD head;
IN_OUT x;
DEC_INFO decinfo;

#define BS_BUFBYTES 60000U
static unsigned char *bs_buffer;
static unsigned char *bs_bufptr;
static int bs_trigger;
static int bs_bufbytes;

int Xing_Mp3_Init(int convert_code, int reduction_code, int freq_limit, 
					int integer_code, int decode8_flag) 
{
	
   if (decode8_flag && (convert_code >= 4))
      audio = audio_table[integer_code & 1][1];
   else
      audio = audio_table[integer_code & 1][0];

   bs_trigger = 2500;
   bs_bufbytes = 0;
   bs_bufptr = bs_buffer;

   bs_buffer = malloc(BS_BUFBYTES);
   if (bs_buffer == NULL)
   {
	return FALSE;
   }
	return TRUE;
}

