// *****************************************************************************
//	Vidomi - Video Encoder
//
//	Copyright (C) 2001 Vidomi, Inc.
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

// *****************************************************************************
// *****************************************************************************
// ifo class
// *****************************************************************************
#ifndef ifo_h
#define ifo_h

#define IFO_VIDEO_ATTRIBUTES_START 0x200
#define IFO_AUDIO_ATTRIBUTES_START 0x202
#define IFO_SUBTITLE_ATTRIBUTES_START 0x254

typedef struct {
	int			numPrograms;
	int			numCells;
	int			programMap[256];
	int			cellLBAStart[256];
	int			cellNumFrames[256];
	int			cellFramerate[256];
	int			cellFlags[256];
} TITLEDATA;



class ifoClass 
{

	public:
									ifoClass();
									~ifoClass();
		bool						readIfo(char * filename,GATHERRESULTS * fileInfo);
		void						readChapterData(GATHERRESULTS * fileInfo);
		void						readVideoData(GATHERRESULTS * fileInfo);
		void						readAudioData(GATHERRESULTS * fileInfo);
		void						readSubtitleData(GATHERRESULTS * fileInfo);
		unsigned int				getInt();
		unsigned char				getChar();
		unsigned short				getShort();
		int							bcdToHex(int bcd);

	private:
		TITLEDATA *					titleData[1];
		unsigned char *				ifoData;
		unsigned int				ifoDataSize;
		FILE *						ifoFile;
		unsigned char *				ifoPtr;

};


#endif