// *****************************************************************************
//	Vidomi - Video Encoder
//
//	Copyright (C) 2001 Vidomi, Inc.
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

// *****************************************************************************
// *****************************************************************************
// job class
// *****************************************************************************
#ifndef job_h
#define job_h

typedef struct
	{
		char	jobToken[16];
		int		numJobs;
		int		sizeOfJobEntry;
	} JOBFILEHEADER;

class jobClass 
{

	public:
									jobClass();
									~jobClass();
			bool					createWindow(HINSTANCE hInst);
			bool					showWindow();
			bool					hideWindow();
			BOOL static CALLBACK	jobDialogHandler(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
			BOOL					jobDialogHandler1(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
			bool					windowVisible();
			bool					addToJobList();
			bool					resetJobList();
			void					clearJob(int index);
			bool					setJobIndex(int index);
			bool					refresh();
			bool					updateJobWindow();
			bool					deleteJobIndex(int index);
			bool					saveJobList(char * filename);
			bool					loadJobList(char * filename, bool clearFirst);
			void					makeNewJobEntry();
			BOOL static CALLBACK	encodeStatsDialogHandler(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
			BOOL					encodeStatsDialogHandler1(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
			void					getEncodeServerStatus();

	private:
			bool					visible;
			HWND					jobhWnd;
			char *					jobStr;
			bool					windowsCreated;
			HINSTANCE				jobhInst;
			HMENU					jobMenu;

};


#endif