// *****************************************************************************
// lameenc.h
// *****************************************************************************
#ifndef lameenc_h
#define lameenc_h

//
#define LAME_CONFIG_LAME						256

// Mode values
#define		LAME_STEREO							0
#define		LAME_JSTEREO						1
#define		LAME_DUALCHANNEL					2
#define		LAME_MODE_MONO						3

// error values
#define		LAME_SUCCESSFUL						0	
#define		LAME_INVALID_FORMAT					1
#define		LAME_INVALID_FORMAT_PARAMETERS		2
#define		LAME_NO_MORE_HANDLES				3
#define		LAME_INVALID_HANDLE					4
#define		LAME_BUFFER_TOO_SMALL				5

#define		LAME_CBR							0
#define		LAME_VBR							1
#define		LAME_ABR							2

#define		LAME_QUALITY_NORMAL					0
#define		LAME_QUALITY_LOW					1
#define		LAME_QUALITY_HIGH					2
#define		LAME_QUALITY_VOICE					3
	

typedef unsigned long LAMEHANDLE;
typedef	struct	{ 
			DWORD			config;			
			
			DWORD 			structVersion;	
			DWORD			structSize;

			DWORD			sampleRate;	
			DWORD			resampleRate;	
			LONG			mode;			
			DWORD			minBitrate;		
			DWORD			maxBitrate;	
			LONG			preset;	
			DWORD			mpegVersion;	
			DWORD			psycoModel;		
			DWORD			emphasis;		

			BOOL			lameprivate;		
			BOOL			crc;			
			BOOL			copyright;		
			BOOL			original;		
			
			BOOL			writeVbrHeader;	
			BOOL			enableVbr;			
			INT				vbrQuality;		
			DWORD			dwVbrAbr_bps;		
			BOOL			noRes;				

			BYTE			reserved[255-2*sizeof(DWORD)];	// not used

			} LAMECONFIG;					



typedef unsigned long (*INITSTREAM) (LAMECONFIG * config, unsigned int * sizeWavBuffer, unsigned int * sizeMp3Buffer, LAMEHANDLE * handle);
typedef unsigned long (*ENCODECHUNK) (LAMEHANDLE, unsigned int bytesToEncode, short * wavBuffer, unsigned char * mp3Buffer, unsigned int * bytesWritten);
typedef unsigned long (*DEINITSTREAM) (LAMEHANDLE, unsigned char * mp3Buffer, unsigned int * bytesWritten);
typedef unsigned long (*CLOSESTREAM) (LAMEHANDLE);

#define	TEXT_INITSTREAM		"beInitStream"
#define	TEXT_ENCODECHUNK	"beEncodeChunk"
#define	TEXT_DEINITSTREAM	"beDeinitStream"
#define	TEXT_CLOSESTREAM	"beCloseStream"

#endif
