// *****************************************************************************
//	Vidomi - Video Encoder
//
//	Copyright (C) 2001 Vidomi, Inc.
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

// *****************************************************************************
// *****************************************************************************
//
//
// mp3Decode.cpp
// 
//
// *****************************************************************************
#include "en.h"

extern GLOBALS * globals;

// *****************************************************************************
// mp3DecodeClass::mp3DecodeClass()
//
// scanmpeg class constructor
// *****************************************************************************
mp3DecodeClass::mp3DecodeClass()
{
	pathToDll = new char [MAX_PATH];

	d2aDll = NULL;
	dvd2AviMp3Init = NULL;
	dvd2AviMp3End = NULL;
	dvd2AviMp3Decode = NULL;
	dvd2AviMp3Prepare = NULL;

}

// *****************************************************************************
// mp3DecodeClass::~mp3DecodeClass()
//
// scanmpeg class destructor
// *****************************************************************************
mp3DecodeClass::~mp3DecodeClass()
{
	end();

	delete [] pathToDll;

}

// *****************************************************************************
// mp3DecodeClass::init()
//
// initialize
////////////////////
// NOTE: The MP3 decode can't be used when the mpeg2 decode is in use. 
////////////////////
// *****************************************************************************
bool mp3DecodeClass::init()
{
	strcpy(pathToDll,globals->pathToExeDir);
	strcat(pathToDll,"\\ncoded2a.dll");


	d2aDll = LoadLibrary(pathToDll);

	if(d2aDll==NULL)
		{
		// If failed, make a second attempt at debug env location
		#ifdef _DEBUG
		strcpy(pathToDll,globals->pathToExeDir);
		strcat(pathToDll,"\\..\\ncoded2a\\Debug\\ncoded2a.dll");
		#else
		strcpy(pathToDll,globals->pathToExeDir);
		strcat(pathToDll,"\\..\\ncoded2a\\Release\\ncoded2a.dll");
		#endif
		d2aDll=LoadLibrary(pathToDll);
		if(d2aDll==NULL)
			return(false);
		}

	dvd2AviMp3Init = (DVD2AVIMP3INIT) GetProcAddress(d2aDll, TEXT_DVD2AVIMP3INIT);
	dvd2AviMp3End = (DVD2AVIMP3END) GetProcAddress(d2aDll, TEXT_DVD2AVIMP3END);
	dvd2AviMp3Decode = (DVD2AVIMP3DECODE) GetProcAddress(d2aDll, TEXT_DVD2AVIMP3DECODE);
	dvd2AviMp3Prepare = (DVD2AVIMP3PREPARE) GetProcAddress(d2aDll, TEXT_DVD2AVIMP3PREPARE);

	if(!dvd2AviMp3Init || !dvd2AviMp3End || !dvd2AviMp3Decode || !dvd2AviMp3Prepare)
		{
		FreeLibrary(d2aDll);
		d2aDll=NULL;
		return(false);
		}

	dvd2AviMp3Init();

	return(true);

}

// *****************************************************************************
// mp3DecodeClass::end()
//
// end
// *****************************************************************************
void mp3DecodeClass::end()
{
	if(d2aDll)
		{
		dvd2AviMp3End();
		FreeLibrary(d2aDll);
		}

	d2aDll = NULL;
	dvd2AviMp3Init = NULL;
	dvd2AviMp3End = NULL;
	dvd2AviMp3Decode = NULL;
	dvd2AviMp3Prepare = NULL;

}

// *****************************************************************************
// mp3DecodeClass::decode()
//
// end
// *****************************************************************************
int mp3DecodeClass::decode(unsigned char * source, int sourceLength, unsigned char * dest)
{
	return(dvd2AviMp3Decode((char *)source, sourceLength, (char *)dest));
}

// *****************************************************************************
// mp3DecodeClass::decode()
//
// end
// *****************************************************************************
int mp3DecodeClass::prepare(unsigned char * source, int sourceLength, int * channels, int * samplerate, int * framesize)
{

	return(dvd2AviMp3Prepare((char *)source, sourceLength, channels, samplerate, framesize));
}
