#define GLOBAL

extern "C"
{
#include "global.h"
#include "AC3Dec\ac3.h"
}

#include "dvd2avi.h"

extern "C" void mpegEnd(void);
extern "C" void mpegInit(void);
extern "C" int mpegDecode(char * source, int sourceLength, char *dest);
extern "C" int mpegPrepare(char * source, int sourceLength, int * channels, int * samplerate, int * framesize);
extern "C" int videoFramesOutput;
extern "C" int writeFrameValid;
extern "C" int writeFrameState;

double aspectTable[5] = { 0.0f, 1.0f, (4.0f / 3.0f), (16.0f / 9.0f), (2.21f / 1.0f)};

// *****************************************************************************
// dvd2AviDLL Entry()
//
//
// *****************************************************************************
BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}

// *****************************************************************************
// dvd2AviInit()
//
//
// *****************************************************************************
NCODED2A_API void dvd2AviInit(void)
{
	int i;
	int index;

	CheckCPU();

	iDCT_Flag = IDCT_MMX;

	if(cpu.ssemmx)
		iDCT_Flag = IDCT_SSEMMX;

	INIT_X = 0;
	INIT_Y = 0;
//	iDCT_Flag = IDCT_REF;
//	FO_Flag = FO_NONE;
	Scale_Flag = TRUE;				//What is this ?
//	Track_Flag = TRACK_1;			//AC3 Track to Rip.
	Format_Flag = FORMAT_NONE;		//Decode the detected type
	AC3_Flag = AUDIO_DECODE;		//Decode AC3 stream
	Surround_Flag = FALSE;
	MPA_Flag = AUDIO_DEMUXONE;			
	SRC_Flag = SRC_NONE;			//Downsample to 44.1 ?
	Norm_Flag = NORM_NONE;			//Normalize
	Priority_Flag = PRIORITY_NORMAL;
	videoFramesOutput = 0;
	Coded_Picture_Width = INIT_WIDTH;
	Coded_Picture_Height = INIT_HEIGHT;
	Store_Flag = STORE_RGB32;
	PreScale_Ratio = 1.0f;
	DSDown_Flag = TRUE;

	VideoPTS = 0;
	AudioPTS = 0;
	for(i=0;i<CHANNEL;i++)
		{
		ac3[i].rip=0;
		ac3[i].delay=0;
		ac3[i].mode=0;
		ac3[i].rate=0;
		ac3[i].size=0;
		ac3[i].file=0;
		ac3[i].grabIt = 0;
		ac3[i].bufferNum =0;
		ac3[i].directStreamCopy=0;
		mpa[i].grabIt = 0;
		mpa[i].bufferNum=0;
		mpa[i].directStreamCopy=0;
		pcm[i].grabIt = 0;
		pcm[i].bufferNum = 0;
		CH[i]=0;
		}

	for(i=0;i<SUBCHANNELMAX;i++)
		{
		subtitle[i].rip=0;
		subtitle[i].grabIt=0;
		subtitle[i].bufferNum=0;
		}

	// Taken from CheckFlag Function
	if (Scale_Flag)
	{
		YUVRGB_Scale = 0x1000254310002543;
	}
	else
	{
		YUVRGB_Scale = 0x1000200010002000;
	}

	// Taken from WM_Create Message

	LumGain = 128; LumGainMask = 0x0080008000800080;

	for (i=0; i<8; i++)
		{
			p_block[i] = (short *)malloc(sizeof(short)*64 + 64);
			block[i]   = (short *)((long)p_block[i] + 64 - (long)p_block[i]%64);
		}

	p_fTempArray = (void *)malloc(sizeof(float)*128 + 64);
	fTempArray = (void *)((long)p_fTempArray + 64 - (long)p_fTempArray%64);

	Initialize_REF_IDCT();
	Initialize_FPU_IDCT();

	frameData.bufferStart=NULL;
	frameData.allocStart=NULL;
	frameData.data=NULL;
	frameData.height=0;
	frameData.width=0;
	frameData.stride=0;
	frameData.pts=0;

	for(i=0;i<MAX_AUDIO_CHANNELS;i++)
		{
		audioData[i].bufferStart = NULL;
		audioData[i].data = audioData[i].bufferStart;
		audioData[i].bufferSize = 0;
		audioData[i].bytesUsed=0;
		}

	for(i=0;i<MAX_SUBTITLE_CHANNELS;i++)
		{
		subtitleData[i].bufferStart = NULL;
		subtitleData[i].data = subtitleData[i].bufferStart;
		subtitleData[i].bufferSize = 0;
		subtitleData[i].bytesUsed = 0;
		subtitleData[i].complete = 0;

		}

	writeFrameValid = 0;
	writeFrameState = 0;
	Second_Field = 0;

	// Init MP3 decoder
	mpegInit();	
	
	index=0;

	//workThreadHandle[index] = CreateThread(NULL,0, workThread1 ,(LPVOID)index , 0 ,&workThreadId[index]);	

	//InitializeCriticalSection(&workToken[index]);

}

// *****************************************************************************
// dvd2AviCleanup()
//
// 
// *****************************************************************************
NCODED2A_API void dvd2AviCleanup(void)
{
	int i;

	Recovery();

	for(i=0;i<CHANNEL;i++)
		{
		ac3[i].rip=0;
		ac3[i].delay=0;
		ac3[i].mode=0;
		ac3[i].rate=0;
		ac3[i].size=0;
		ac3[i].file=0;
		CH[i]=0;
		}

	for (i=0; i<8; i++)
		free(p_block[i]);
	free(p_fTempArray);
	//delete [] audioData.bufferStart;

//	if(workThreadHandle[0])
//		TerminateThread(workThreadHandle[0],0);

	if(File_Limit)
		{
		for (i=0; i<File_Limit; i++)
			{
			if(Infile[i])
				{
				_close(Infile[i]);
				Infile[i] = 0;
				}
			}
		File_Limit=0;
		}

	#ifdef TRANSPORTSTREAM	
	  if(TransportStream_Flag)
		CleanupTransportStream();
	#endif

	mpegEnd();
}

// *****************************************************************************
// dvd2AviSetIdct()
//
// idctType = 0-2 ? 
// *****************************************************************************
NCODED2A_API void dvd2AviSetIdct(int idctType)
{
	iDCT_Flag=idctType;
}


// *****************************************************************************
// dvd2AviGetFrameType()
//
// idctType = 0-2 ? 
// *****************************************************************************
NCODED2A_API int dvd2AviGetFrameType(void)
{
	return(picture_coding_type);
}

// *****************************************************************************
// dvd2AviSetFilm()
//
// film = on/off 
// *****************************************************************************
NCODED2A_API void dvd2AviSetFilm(bool film)
{
	if(film)
		FO_Flag=FO_FILM;
	else
		FO_Flag=FO_NONE;
}

// *****************************************************************************
// dvd2AviSetAudio()
//
// audio = on/off 
// audioTrack = track to rip
// *****************************************************************************
NCODED2A_API void dvd2AviSetAudio(bool audio,int bufferIndex, int audioType, int audioTrack, int streamCopy)
{
	int i;

	if(audio)
		{
		switch(audioType)
			{	
			case audioPcm :
				Format_Flag |= FORMAT_LPCM;
				pcm[audioTrack].grabIt = 1;
				pcm[audioTrack].bufferNum = bufferIndex;
				break;
			case audioMpeg :
				Format_Flag |= FORMAT_MPEG;
				mpa[audioTrack].grabIt = 1;
				mpa[audioTrack].bufferNum = bufferIndex;
				mpa[audioTrack].directStreamCopy = streamCopy;
				break;
			case audioAc3 :
				Format_Flag |= FORMAT_AC3;
				ac3[audioTrack].grabIt = 1;
				ac3[audioTrack].bufferNum = bufferIndex;
				ac3[audioTrack].directStreamCopy = streamCopy;
				break;
			default :
				break;
			}
		}
	else
		{
		Format_Flag = FORMAT_NONE;
		for(i=0;i<CHANNEL;i++)
			{
			ac3[i].grabIt = 0;
			mpa[i].grabIt = 0;
			pcm[i].grabIt = 0;
			}
		}
}

// *****************************************************************************
// dvd2AviSetAudio()
//
// audio = on/off 
// audioTrack = track to rip
// *****************************************************************************
NCODED2A_API void dvd2AviSetSubtitle(bool subEnabled,int bufferIndex, int subTrack)
{
	int i;

	if(subEnabled)
		{
		subtitle[subTrack].grabIt = 1;
		subtitle[subTrack].bufferNum = bufferIndex;
		}
	else
		{
		for(i=0;i<SUBCHANNELMAX;i++)
			{
			subtitle[i].grabIt = 0;
			}
		}
}

// *****************************************************************************
// dvd2AviAddInput()
//
// inputFilename = Filename to Convert
// Repeated calls allow multiple files to be converted into a single AVI. 
// *****************************************************************************
NCODED2A_API void dvd2AviAddInput(char * inputFilename)
{

	strcpy(Infilename[File_Limit], inputFilename);
	Infile[File_Limit] = _open(Infilename[File_Limit], _O_RDONLY | _O_BINARY);
	File_Limit++;

	Recovery();

	if (File_Limit)
		{
		#ifdef TRANSPORTSTREAM
		  DetectTransportStream();
		#endif

		process.rightfile = File_Limit-1;
		process.rightlba = (int)(process.length[File_Limit-1]/BfrSize);

		process.end = process.total - BfrSize;
		process.endfile = File_Limit - 1;
		process.endloc = (process.length[File_Limit-1]/BfrSize - 1)*BfrSize;
		}
	
}

// *****************************************************************************
// dvd2AviSeekPos()
//
// *****************************************************************************
NCODED2A_API bool dvd2AviSeekPos(__int64 seekTo)
{
	int i;
	__int64 curStart;
	__int64 curEnd;
	__int64 pos;
	__int64 end;

	#ifdef TRANSPORTSTREAM
	  if (TransportStream_Flag)
		BfrSize = BUFFER_SIZE;
	#endif

	if(seekTo > process.total)
		return(FALSE);

	for(i=0;i<MAX_AUDIO_CHANNELS;i++)
		{
		audioData[i].data = audioData[i].bufferStart;
		audioData[i].bytesUsed=0;
		audioData[i].pts = 0;
		}

	frameData.pts=0;

	end = dvd2AviGetEndPos();
	// Backup a little to make the end easily determined
	end -=8;

	curStart = 0;
	curEnd = 0;
	for(i=0;i<File_Limit;i++)
		{
		curStart = curEnd;
		curEnd += process.length[i];
		if(seekTo>=curStart && seekTo < curEnd)
			break;
		}

	File_Flag = i;
	_lseeki64(Infile[i], ((seekTo - curStart)/BfrSize)*BfrSize, SEEK_SET);
	
	Fault_Flag = 0;
	writeFrameValid = 0;
	writeFrameState = 0;
	Frame_Number = Second_Field = 0;
	VOB_ID = CELL_ID = 0;

	Initialize_Buffer();
	
	while (Get_Hdr())
		{
		if(Fault_Flag > CRITICAL_ERROR_LEVEL)
			return (FALSE);

		pos = _telli64(Infile[i]);

		if(pos==-1)
			return(FALSE);

		if((pos + curStart) >= end)
			return(FALSE);

		if (picture_coding_type==I_TYPE)
			{
			Decode_Picture();

			while (Get_Hdr())
				{
				pos = _telli64(Infile[i]);
				if(pos==-1)
					return(FALSE);
				if((pos + curStart) >= end)
					return(FALSE);

				if (picture_coding_type!=B_TYPE)
					{
					return(TRUE);
					}

				if(Fault_Flag > CRITICAL_ERROR_LEVEL)
					return (FALSE);
				}
			}	

		}
	return(FALSE);
}

// *****************************************************************************
// dvd2AviGetCurPos()
//
// *****************************************************************************
NCODED2A_API __int64 dvd2AviGetCurPos(void)
{
	int i;
	__int64 curStart;
	__int64 tempPos;
	curStart = 0;
	for(i=0;i<File_Flag;i++)
		{
		curStart += process.length[i];
		}
	tempPos = _telli64(Infile[i]);
	if(tempPos == -1)
		{
		tempPos = process.length[i];
		}
	curStart += tempPos;

	return(curStart);
}

// *****************************************************************************
// dvd2AviGetEndPos()
//
// *****************************************************************************
NCODED2A_API __int64 dvd2AviGetEndPos(void)
{
	int i;
	__int64 curEnd;

	curEnd = 0;
	for(i=0;i<File_Limit;i++)
		{
		curEnd += process.length[i];
		}
	return(curEnd);
}

// *****************************************************************************
// dvd2AviClearInput()
//
// *****************************************************************************
NCODED2A_API void dvd2AviClearInput(void)
{
	int i;
	if(File_Limit)
		{
		for (i=0; i<File_Limit; i++)
			{
			if(Infile[i])
				{
				_close(Infile[i]);
				Infile[i] = 0;
				}
			}
		File_Limit=0;
		}

	#ifdef TRANSPORTSTREAM	
	  if(TransportStream_Flag)
		CleanupTransportStream();
	#endif

}


// *****************************************************************************
// dvd2AviStartConversion()
//
//
// *****************************************************************************
NCODED2A_API bool dvd2AviStartConversion()
{
	AVI_Flag = true;
	Statistics_Flag = false;

	process.locate = LOCATE_RIP;

	return(TRUE);

}

// *****************************************************************************
// dvd2AviGetHeader()
//
// 
// *****************************************************************************
NCODED2A_API int dvd2AviGetHeader(void)
{
	return(Get_Hdr());
}

// *****************************************************************************
// dvd2AviDecodeFrame()
//
// 
// *****************************************************************************
NCODED2A_API void dvd2AviDecodeFrame(void)
{
	Decode_Picture();
}

// *****************************************************************************
// dvd2AviDecodeFrameBegin()
//
// 
// *****************************************************************************
NCODED2A_API void dvd2AviDecodeFrameBegin(void)
{
	Decode_Picture_Begin();
}

// *****************************************************************************
// dvd2AviDecodeFrameMiddle()
//
// 
// *****************************************************************************
NCODED2A_API int dvd2AviDecodeFrameMiddle(void)
{
	int ret;

	// Call decode until a single frame is generated.
	for(;;)
		{
		frameData.valid = FALSE;

		ret = Decode_Write_Frame();
		if(ret)
			{
			if(frameData.valid==TRUE)
				{
				return(ret);
				}
			}
		else
			{
			return(ret);
			}
		}
}

// *****************************************************************************
// dvd2AviDecodeFrameMiddle()
//
// 
// *****************************************************************************
NCODED2A_API void dvd2AviDecodeFrameEnd(void)
{
	Decode_Picture_End();
}
// *****************************************************************************
// dvd2AviCheckStopFlag()
//
// 
// *****************************************************************************
NCODED2A_API int dvd2AviCheckStopFlag(void)
{
	return(Stop_Flag);
}

// *****************************************************************************
// dvd2AviSetFaultFlag()
//
//  x = value to set fault to.
// *****************************************************************************
NCODED2A_API void dvd2AviSetFaultFlag(int x)
{
	Fault_Flag=x;
}
// *****************************************************************************
// dvd2AviGetFaultFlag()
//
//  x = value to set fault to.
// *****************************************************************************
NCODED2A_API int dvd2AviGetFaultFlag()
{
	return(Fault_Flag);
}


// *****************************************************************************
// dvd2AviDecodeInit()
//
// 
// *****************************************************************************
NCODED2A_API DWORD dvd2AviDecodeInit(int mode)
{
	switch(mode)
		{
		case rgb32Frame:
			Store_Flag = STORE_RGB32;
			break;
		case yv12Frame:
			Store_Flag = STORE_YV12;
			break;
		case yuy2Frame:
			Store_Flag = STORE_YUY2;
			break;
		}

	return(MPEG2DecInit());
}


// *****************************************************************************
// dvd2AviGetFrameData()
//
// pointer to struct that will receive the framedata. 
// *****************************************************************************
NCODED2A_API FRAMEDATA * dvd2AviGetFrameData()
{
	return(&frameData);
}

// *****************************************************************************
// dvd2AviGetAudioData()
//
// pointer to struct that will receive the audiodata. 
// *****************************************************************************
NCODED2A_API AUDIODATA * dvd2AviGetAudioData(int channelIndex)
{
	return(&audioData[channelIndex]);
}

// *****************************************************************************
// dvd2AviGetSubtitleData()
//
// pointer to struct that will receive the audiodata. 
// *****************************************************************************
NCODED2A_API SUBTITLEDATA * dvd2AviGetSubtitleData(int channelIndex)
{
	return(&subtitleData[channelIndex]);
}

// *****************************************************************************
// dvd2AviGetDimentions()
//
// pointer to me struct that will receive the framedata. 
// *****************************************************************************
NCODED2A_API void dvd2AviGetDimentions(int * width, int * height, double * aspectRatio)
{
	*width = Coded_Picture_Width;
	*height = Coded_Picture_Height;
	*aspectRatio = aspectTable[aspect_ratio_information];
}

// *****************************************************************************
// dvd2AviGetFrameRate()
//
// return framerate
// *****************************************************************************
NCODED2A_API float dvd2AviGetFramerate()
{
	return((FO_Flag==FO_FILM) ? frame_rate*0.8f : frame_rate);
}

// *****************************************************************************
// dvd2AviGetCpuType()
//
// CPUType
// *****************************************************************************
NCODED2A_API int dvd2AviGetCpuType()
{
	CheckCPU();

	return( (cpu.ssefpu<<3) | (cpu.ssemmx<<2) | (cpu._3dnow<<1) | cpu.mmx);
}

// *****************************************************************************
// dvd2AviResampleInit()
//
// *****************************************************************************
NCODED2A_API void dvd2AviResampleInit()
{

	InitialSRC();

}

// *****************************************************************************
// dvd2AviResampleInit()
//
// *****************************************************************************
NCODED2A_API int dvd2AviResample(unsigned char * source, unsigned char * dest, int size)
{

	return(resample48To44(source, dest, size));

}

// *****************************************************************************
// dvd2AviMp3DecideInit()
//
// *****************************************************************************
NCODED2A_API void dvd2AviMp3Init()
{
	mpegInit();
}

// *****************************************************************************
// dvd2AviMp3DecideInit()
//
// *****************************************************************************
NCODED2A_API void dvd2AviMp3End()
{
	mpegEnd();
}

// *****************************************************************************
// dvd2AviMp3DecideInit()
//
// *****************************************************************************
NCODED2A_API int dvd2AviMp3Prepare(char * source, int sourceLength, int *channels, int * samplerate, int * framesize)
{
	return(mpegPrepare(source,sourceLength,channels,samplerate, framesize));
}

// *****************************************************************************
// dvd2AviMp3DecideInit()
//
// *****************************************************************************
NCODED2A_API int dvd2AviMp3Decode(char * source, int sourceLength, char *dest)
{
	return(mpegDecode(source,sourceLength,dest));

}
///////////////////////////////////////////////
// Functions below are lifted from gui.cpp   //
///////////////////////////////////////////////

static void CheckCPU()
{
	__asm
	{
		mov			eax, 1
		cpuid
		test		edx, 0x00800000		// STD MMX
		jz			TEST_SSE
		mov			[cpu.mmx], 1
TEST_SSE:
		test		edx, 0x02000000		// STD SSE
		jz			TEST_3DNOW
		mov			[cpu.ssemmx], 1
		mov			[cpu.ssefpu], 1
TEST_3DNOW:
		mov			eax, 0x80000001
		cpuid
		test		edx, 0x80000000		// 3D NOW
		jz			TEST_SSEMMX
		mov			[cpu._3dnow], 1
TEST_SSEMMX:
		test		edx, 0x00400000		// SSE MMX
		jz			TEST_END
		mov			[cpu.ssemmx], 1
TEST_END:
	}


}

static void Recovery()
{
	int i;

	if (Check_Flag)
	{
		
		if (lpDD2)
			lpDD2->Release();
		if (lpDD)
			lpDD->Release();
		

		free(backward_reference_frame[0]);
		free(forward_reference_frame[0]);
		free(auxframe[0]);

		free(u422);
		free(v422);
		free(u444);
		free(v444);

		if(rgb32)
			{
			free(rgb32);
			}
		if(yuy2)
			{
			free(yuy2);
			}
		if(yv12)
			{
			free(yuy2);
			}
		if(lum)
			{
			free(lum);
			}
	}

	Check_Flag = false;
	DDOverlay_Flag = false;

	if (File_Limit)
	{
		ZeroMemory(&process, sizeof(PROCESS));
		process.trackright = TRACK_PITCH;

		SystemStream_Flag = false;
		Display_Flag = true;

		for (i=0; i<File_Limit; i++)
		{
			process.length[i] = _filelengthi64(Infile[i]);
			process.total += process.length[i];
		}
	}

}

void ThreadKill()
{
	int i,size;

	if (Check_Flag)
	{
		if ((AVI_Flag || D2V_Flag) && Track_Flag!=TRACK_NONE)
		{
			if (ac3[Track_Flag].rip && AC3_Flag==AUDIO_DECODE)
			{
				for (i=0; i<6; i++)
				{
					//memcpy(audioData.data, AC3Flush, 768);
					//audioData.data = audioData.data + 768;

					size = ac3_decode_data(0,AC3Flush, 768);
					/*
					if (SRC_Flag)
						Wavefs44(ac3[Track_Flag].file, size, AC3Dec_Buffer);
					else
						fwrite(AC3Dec_Buffer, size, 1, ac3[Track_Flag].file);
					*/
					//ac3[Track_Flag].size += size;
				}
				/*
				if (SRC_Flag)
				{
					EndSRC(ac3[Track_Flag].file);
					ac3[Track_Flag].size = ((int)(0.91875*ac3[Track_Flag].size)>>2)<<2;
				}

				if (Norm_Flag)
				{
					fseek(ac3[Track_Flag].file, 44, SEEK_SET);
					Normalize(NULL, 44, ac3[Track_Flag].filename, ac3[Track_Flag].file, 44, ac3[Track_Flag].size);
				}

				EndWAV(ac3[Track_Flag].file, ac3[Track_Flag].size);
				*/
			}
			/*
			if (pcm.rip)
			{
				if (SRC_Flag)
				{
					EndSRC(pcm.file);
					pcm.size = ((int)(0.91875*pcm.size)>>2)<<2;
				}

				if (Norm_Flag)
				{
					fseek(pcm.file, 44, SEEK_SET);
					Normalize(NULL, 44, pcm.filename, pcm.file, 44, (int)pcm.size);
				}

				EndWAV(pcm.file, (int)pcm.size);
			}
			*/
		}

		//_fcloseall();

		for(i=0;i<File_Limit;i++)
			{
			if(Infile[i])
				{
				_close(Infile[i]);
				Infile[i]=0;
				}
			}

		AVI_Flag = false;
		Display_Flag = false;
		D2V_Flag = false;

	}

	ExitThread(0);
}


// *****************************************************************************
// workThread1()
//
// Returns TRUE if success
// *****************************************************************************

DWORD WINAPI workThread1(LPVOID lParam)
{
	int index;
	volatile int workData;
	volatile int work;
	index = (int) lParam;

	for(;;)
		{
		EnterCriticalSection(&workToken[index]);
		work = workToBeDone[index];
		workData = workData1[index];
		LeaveCriticalSection(&workToken[index]);
		switch(work)
			{
			case 1 :
				EnterCriticalSection(&workToken[index]);
				workToBeDone[index] = 0;
				LeaveCriticalSection(&workToken[index]);
				break;
			case -1 :
				ExitThread(0);  
				break;
			default :
				Sleep(1000);
				break;
			}
		}
	ExitThread(0);  
	return(0);
}