// *****************************************************************************
// dvd2avi.h
// *****************************************************************************
#ifdef NCODED2A_EXPORTS
#define NCODED2A_API extern "C" __declspec(dllexport)

NCODED2A_API void dvd2AviSetIdct(int idctType);
NCODED2A_API bool dvd2AviStartConversion(void);
NCODED2A_API int dvd2AviGetHeader(void);
NCODED2A_API void dvd2AviDecodeFrame(void);
NCODED2A_API void dvd2AviDecodeFrameBegin(void);
NCODED2A_API int dvd2AviDecodeFrameMiddle(void);
NCODED2A_API void dvd2AviDecodeFrameEnd(void);
NCODED2A_API int dvd2AviCheckStopFlag(void);
NCODED2A_API void dvd2AviSetFaultFlag(int x);
NCODED2A_API int dvd2AviGetFaultFlag(void);
NCODED2A_API DWORD dvd2AviDecodeInit(int mode);
NCODED2A_API FRAMEDATA * dvd2AviGetFrameData(void);
NCODED2A_API void dvd2AviGetDimentions(int * width, int * height, double * aspectRatio);
NCODED2A_API float dvd2AviGetFramerate(void);
NCODED2A_API int dvd2AviGetCpuType(void);
NCODED2A_API void dvd2AviSetFilm(bool film);
NCODED2A_API AUDIODATA * dvd2AviGetAudioData(int channelIndex);
NCODED2A_API void dvd2AviSetAudio(bool audio, int bufferIndex, int audioType, int audioTrack, int streamCopy);
NCODED2A_API int dvd2AviAc3Decode(char * source, int sourceLength, char * dest);
NCODED2A_API void dvd2AviInitAc3Decode(void);
NCODED2A_API void dvd2AviCleanup(void);
NCODED2A_API void dvd2AviAddInput(char * inputFilename);
NCODED2A_API void dvd2AviClearInput(void);
NCODED2A_API void dvd2AviInit(void);
NCODED2A_API void dvd2AviResampleInit(void);
NCODED2A_API int dvd2AviResample(unsigned char * source, unsigned char * dest, int size);
NCODED2A_API __int64 dvd2AviGetEndPos(void);
NCODED2A_API __int64 dvd2AviGetCurPos(void);
NCODED2A_API bool dvd2AviSeekPos(__int64 seekTo);
DWORD WINAPI workThread1(LPVOID lParam);
NCODED2A_API void dvd2AviMp3Init(void);
NCODED2A_API void dvd2AviMp3End(void);
NCODED2A_API int dvd2AviMp3Decode(char * source, int sourceLength, char *dest);
NCODED2A_API int dvd2AviMp3Prepare(char * source, int sourceLength, int *channels, int * samplerate, int * framesize);
NCODED2A_API SUBTITLEDATA * dvd2AviGetSubtitleData(int channelIndex);
NCODED2A_API void dvd2AviSetSubtitle(bool subEnabled, int bufferIndex, int subTrack);
NCODED2A_API int dvd2AviGetFrameType(void);

#else

typedef void (*DVD2AVISETIDCT) (int idctType);
typedef bool (*DVD2AVISTARTCONVERSION) (void);
typedef int (*DVD2AVIGETHEADER) (void);
typedef void (*DVD2AVIDECODEFRAME) (void);
typedef void (*DVD2AVIDECODEFRAMEBEGIN) (void);
typedef int (*DVD2AVIDECODEFRAMEMIDDLE) (void);
typedef void (*DVD2AVIDECODEFRAMEEND) (void);
typedef int (*DVD2AVICHECKSTOPFLAG) (void);
typedef void (*DVD2AVISETFAULTFLAG) (int x);
typedef int (*DVD2AVIGETFAULTFLAG) (void);
typedef DWORD (*DVD2AVIDECODEINIT) (int mode);
typedef FRAMEDATA * (*DVD2AVIGETFRAMEDATA) (void);
typedef void (*DVD2AVIGETDIMENTIONS) (int * width, int * height, double * aspectRatio);
typedef float (*DVD2AVIGETFRAMERATE) (void);
typedef int (*DVD2AVIGETCPUTYPE) (void );
typedef void (*DVD2AVISETFILM) (bool film);
typedef AUDIODATA * (*DVD2AVIGETAUDIODATA) (int channelIndex);
typedef void (*DVD2AVISETAUDIO) (bool audio,int bufferIndex, int audioType, int audioTrack, int streamCopy);
typedef void (*DVD2AVICLEANUP) (void);
typedef void (*DVD2AVIADDINPUT) (char * inputFilename);
typedef void (*DVD2AVICLEARINPUT) (void);
typedef int (*DVD2AVIGETCPUTYPE) (void);
typedef void (*DVD2AVIINIT) (void);
typedef void (*DVD2AVIRESAMPLEINIT) (void);
typedef int (*DVD2AVIRESAMPLE) (unsigned char * source, unsigned char * dest, int size);
typedef __int64 (*DVD2AVIGETENDPOS)(void);
typedef __int64 (*DVD2AVIGETCURPOS)(void);
typedef bool (*DVD2AVISEEKPOS)(__int64 seekTo);
typedef void (*DVD2AVIMP3INIT) (void);
typedef void (*DVD2AVIMP3END) (void);
typedef int (*DVD2AVIMP3DECODE) (char * source, int sourceLength, char *dest);
typedef int (*DVD2AVIMP3PREPARE) (char * source, int sourceLength, int *channels, int * samplerate, int * framesize);
typedef SUBTITLEDATA * (*DVD2AVIGETSUBTITLEDATA)(int channelIndex);
typedef void (*DVD2AVISETSUBTITLE) (bool subEnabled, int bufferIndex, int subTrack);
typedef int (*DVD2AVIGETFRAMETYPE) (void);


#define TEXT_DVD2AVISETIDCT "dvd2AviSetIdct" 
#define TEXT_DVD2AVISTARTCONVERSION "dvd2AviStartConversion" 
#define TEXT_DVD2AVIGETHEADER "dvd2AviGetHeader" 
#define TEXT_DVD2AVIDECODEFRAME "dvd2AviDecodeFrame" 
#define TEXT_DVD2AVIDECODEFRAMEBEGIN "dvd2AviDecodeFrameBegin" 
#define TEXT_DVD2AVIDECODEFRAMEMIDDLE "dvd2AviDecodeFrameMiddle" 
#define TEXT_DVD2AVIDECODEFRAMEEND "dvd2AviDecodeFrameEnd" 
#define TEXT_DVD2AVICHECKSTOPFLAG "dvd2AviCheckStopFlag" 
#define TEXT_DVD2AVISETFAULTFLAG "dvd2AviSetFaultFlag" 
#define TEXT_DVD2AVIGETFAULTFLAG "dvd2AviGetFaultFlag" 
#define TEXT_DVD2AVIDECODEINIT "dvd2AviDecodeInit" 
#define TEXT_DVD2AVIGETFRAMEDATA "dvd2AviGetFrameData" 
#define TEXT_DVD2AVIGETDIMENTIONS "dvd2AviGetDimentions" 
#define TEXT_DVD2AVIGETFRAMERATE "dvd2AviGetFramerate" 
#define TEXT_DVD2AVIGETCPUTYPE "dvd2AviGetCpuType"  
#define TEXT_DVD2AVISETFILM "dvd2AviSetFilm" 
#define TEXT_DVD2AVIGETAUDIODATA "dvd2AviGetAudioData" 
#define TEXT_DVD2AVISETAUDIO "dvd2AviSetAudio" 
#define TEXT_DVD2AVICLEANUP "dvd2AviCleanup"
#define TEXT_DVD2AVIADDINPUT "dvd2AviAddInput"
#define TEXT_DVD2AVICLEARINPUT "dvd2AviClearInput"
#define TEXT_DVD2AVIINIT "dvd2AviInit"
#define TEXT_DVD2AVIRESAMPLEINIT "dvd2AviResampleInit"
#define TEXT_DVD2AVIRESAMPLE "dvd2AviResample"
#define TEXT_DVD2AVIGETENDPOS "dvd2AviGetEndPos"
#define TEXT_DVD2AVIGETCURPOS "dvd2AviGetCurPos"
#define TEXT_DVD2AVISEEKPOS "dvd2AviSeekPos"
#define TEXT_DVD2AVIMP3INIT "dvd2AviMp3Init"
#define TEXT_DVD2AVIMP3END "dvd2AviMp3End"
#define TEXT_DVD2AVIMP3DECODE "dvd2AviMp3Decode"
#define TEXT_DVD2AVIMP3PREPARE "dvd2AviMp3Prepare"
#define TEXT_DVD2AVIGETSUBTITLEDATA "dvd2AviGetSubtitleData" 
#define TEXT_DVD2AVISETSUBTITLE "dvd2AviSetSubtitle" 
#define TEXT_DVD2AVIGETFRAMETYPE "dvd2AviGetFrameType" 

#endif

