// *****************************************************************************
// flask.h
// *****************************************************************************
#ifndef FLASK_H
#define FLASK_H

#include "../../commonall/divxtypes.h"
#include "../../commonencoder/common.h"

#ifdef NCODEFLS_EXPORTS
#define NCODEFLS_API extern "C" __declspec(dllexport)


NCODEFLS_API void flaskInit(void);
NCODEFLS_API void flaskDeinterlace(FRAMEDATA * src, FRAMEDATA * dst);
NCODEFLS_API int flaskStartDeinterlacer(FRAMEDATA * frame, int blend, int thresHold);
NCODEFLS_API int flaskStopDeinterlacer(void);
NCODEFLS_API void flaskStartResizer(int outputWidth, int outputHeight, int filterMode, FRAMEDATA * src);
NCODEFLS_API void flaskStopResizer(void);
NCODEFLS_API void flaskResize(FRAMEDATA * src, FRAMEDATA * dst);
NCODEFLS_API void flaskCrop(FRAMEDATA * source, FRAMEDATA * dest, int cropTopOffset, int cropBottomOffset, int cropLeftOffset, int cropRightOffset);
NCODEFLS_API void flaskDIBconvert_24_to_32(void *dest, long dest_pitch, void *src, long src_pitch, long width, long height);
NCODEFLS_API void flaskStartIVTC(FRAMEDATA * src, bool fDecomb, int iOffset, bool fInvertedPolarity);
NCODEFLS_API void flaskIVTCProcessIn(FRAMEDATA * src, long lFrameNum);
NCODEFLS_API long flaskIVTCProcessOut(FRAMEDATA * dst);
NCODEFLS_API void flaskYuvResize(FRAMEDATA * src, FRAMEDATA * dst, int clipLeft, int clipRight,int clipTop, int clipBottom);

#else

typedef void (*FLASKINIT) (void);
typedef void (*FLASKDEINTERLACE) (FRAMEDATA * src, FRAMEDATA * dst);
typedef int (*FLASKSTARTDEINTERLACER) (FRAMEDATA * frame, int blend, int thresHold);
typedef int (*FLASKSTOPDEINTERLACER) (void);
typedef void (*FLASKSTARTRESIZER) (int outputWidth, int outputHeight, int filterMode, FRAMEDATA * src);
typedef void (*FLASKSTOPRESIZER) (void);
typedef void (*FLASKRESIZE) (FRAMEDATA * src, FRAMEDATA * dst);
typedef void (*FLASKCROP) (FRAMEDATA * source, FRAMEDATA * dest, int cropTopOffset, int cropBottomOffset, int cropLeftOffset, int cropRightOffset);
typedef void (*FLASKDIBCONVERT_24_TO_32) (void *dest, long dest_pitch, void *src, long src_pitch, long width, long height);
typedef void (*FLASKSTARTIVTC) (FRAMEDATA * src, bool fDecomb, int iOffset, bool fInvertedPolarity);
typedef void  (*FLASKIVTCPROCESSIN) (FRAMEDATA * src, long lFrameNum);
typedef long  (*FLASKIVTCPROCESSOUT) (FRAMEDATA * dst);
typedef void (*FLASKYUVRESIZE) (FRAMEDATA * src, FRAMEDATA * dst, int clipLeft, int clipRight,int clipTop, int clipBottom);



#define TEXT_FLASKINIT "flaskInit"
#define TEXT_FLASKDEINTERLACE "flaskDeinterlace"
#define TEXT_FLASKSTARTDEINTERLACER "flaskStartDeinterlacer"
#define TEXT_FLASKSTOPDEINTERLACER "flaskStopDeinterlacer"
#define TEXT_FLASKSTARTRESIZER "flaskStartResizer"
#define TEXT_FLASKSTOPRESIZER "flaskStopResizer"
#define TEXT_FLASKRESIZE "flaskResize"
#define TEXT_FLASKCROP "flaskCrop"
#define TEXT_FLASKDIBCONVERT_24_TO_32 "flaskDIBconvert_24_to_32"
#define TEXT_FLASKSTARTIVTC "flaskStartIVTC"
#define TEXT_FLASKIVTCPROCESSIN "flaskIVTCProcessIn"
#define TEXT_FLASKIVTCPROCESSOUT "flaskIVTCProcessOut"
#define TEXT_FLASKYUVRESIZE "flaskYuvResize"

#endif

#endif
