// *****************************************************************************
//	Vidomi - Video Encoder
//
//	Copyright (C) 2001 Vidomi, Inc.
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

// *****************************************************************************
// *****************************************************************************
// netconversion class
// *****************************************************************************
#ifndef netconversion_h
#define netconversion_h


class netConversionClass {

	public:
									netConversionClass();
									~netConversionClass();
			bool					startNetConversion();
			static DWORD WINAPI		netConversionThread(LPVOID lParam);
			bool					netConversion(void);
			void					processAllSlaveJobs();
			void					createSlaveJobList();
			void					releaseSlaveJobList();

			void					abort(int slave);
			bool					pause();
			void					setThreadPriority(int priorty);
			void					setSleepPerFrame(int sleep);
			void					setShutdown(bool shutdownState);
			void					performShutdown();
			void					outputStatistics(int jobsBeingProcessed, int jobsRemaining);
			bool					loadSlaveList(char * filename);
			void					setForcedAbortConversion();
	protected:
			DWORD					netThreadId;
			HANDLE					netThreadHandle;
			bool volatile			forcedAbortConversion;
			bool volatile			abortConversion;
			bool volatile 			pauseConversion;
			bool volatile 			shutdown;
			bool volatile 			netConversionThreadTerminated;

			netMasterClass *		netMaster;
			netSlaveClass *			netSlave;
			SLAVEJOBLIST *			slaveJobList;
			int						numSlaveJobs;
			int						numSlaveEncodeMachines;
			SLAVEENCODEMACHINES *	slaveEncodeMachines;
			DWORD					encodeStartTime;
			int						numFailedJobs;
			bool					useBuiltinSlave;

};




#endif