// *****************************************************************************
//	Vidomi - Video Encoder
//
//	Copyright (C) 2001 Vidomi, Inc.
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

// *****************************************************************************
// *****************************************************************************
// netslave class
// *****************************************************************************
#ifndef netslave_h
#define netslave_h

typedef struct {
	netSlaveClass *			slave;	
	NETSTARTCONVERSION *	inputData;
} NETSLAVECONVERSIONTHREAD;
//
// netSlave : This is what receives commands and starts the encode work
//

class netSlaveClass {

	public:
									netSlaveClass();
									~netSlaveClass();
			void					begin();
			void					end();
			static DWORD WINAPI		netSlaveThread(LPVOID lParam);
			bool					netSlave();
			bool					parseCommand(DWORD command, int size);
			bool					startConversion(DWORD command, int size);
			bool					safeReceiveBytes(char * ptr, int bytesRemaining);
			bool					safeSendBytes(char * ptr, int bytesRemaining);
			bool					status(DWORD command, int size);
			bool					error(DWORD command, int size);
			bool					abort(DWORD command, int size);
			bool					pause(DWORD command, int size);
			bool					resume(DWORD command, int size);
			bool					sleep(DWORD command, int size);
			bool					shutdown(DWORD command, int size);
			bool					threadPriority(DWORD command, int size);
			void					performShutdown();

			static DWORD WINAPI		conversionThread(LPVOID lParam);
			bool 					conversion(JOBLISTENTRY * jobListEntry);

	protected:
			DWORD					netSlaveThreadId;
			HANDLE					netSlaveThreadHandle;
			volatile bool			terminateSlave;
			volatile bool			slaveThreadTerminated;
			tcpClass *				tcp;
			SOCKET					rSocket;
			SOCKET					slaveSocket;
			volatile int			conversionStatus;
			CRITICAL_SECTION		conversionStatusLock;
			DWORD					conversionThreadId;
			HANDLE					conversionThreadHandle;


};




#endif