// *****************************************************************************
//	Vidomi - Video Encoder
//
//	Copyright (C) 2001 Vidomi, Inc.
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

// *****************************************************************************
// *****************************************************************************
//
//
// optionsAdvacnedVideo.cpp
// 
//
// *****************************************************************************

#include "en.h"

extern GLOBALS * globals;

static TRANSLATEIDTABLE advancedVideoOptionsTID[] = {
										{"VidomiAdvancedVideoOptionsText1",VidomiAdvancedVideoOptionsText1},
										{"VidomiOptionsVbrCrispnessText",VidomiOptionsVbrCrispnessText},
										{"VidomiOptionsVbrMinKeyFrameText",VidomiOptionsVbrMinKeyFrameText},
										{"VidomiOptionsVbrMaxKeyFrameText",VidomiOptionsVbrMaxKeyFrameText},
										{"VidomiOptionsVbrQualityBitrateText",VidomiOptionsVbrQualityBitrateText},
										{"VidomiOptionsVbrQualityBitrateText1",VidomiOptionsVbrQualityBitrateText1},
										{"VidomiOptionsVbrMinBitrateText",VidomiOptionsVbrMinBitrateText},
										{"VidomiOptionsVbrMaxBitrateText",VidomiOptionsVbrMaxBitrateText},
										{"VidomiOptionsVbrMinReservoirText",VidomiOptionsVbrMinReservoirText},
										{"VidomiOptionsVbrMaxReservoirText",VidomiOptionsVbrMaxReservoirText},
										{"VidomiOptionsVbrMinReservoirText1",VidomiOptionsVbrMinReservoirText1},
										{"VidomiOptionsVbrMaxReservoirText1",VidomiOptionsVbrMaxReservoirText1},
										{"VidomiAdvancedVideoOptionsText2",VidomiAdvancedVideoOptionsText2},
										{"VidomiOptionsLumaProcessingText",VidomiOptionsLumaProcessingText},
										{"VidomiOptionsLumaLowText1",VidomiOptionsLumaLowText1},
										{"VidomiOptionsLumaLowText2",VidomiOptionsLumaLowText2},
										{"VidomiOptionsLumaDeltaText1",VidomiOptionsLumaDeltaText1},
										{"VidomiOptionsLumaDeltaText2",VidomiOptionsLumaDeltaText2},
										{"VidomiAdvancedVideoOptionsText3",VidomiAdvancedVideoOptionsText3},
										{"VidomiOptionsStopAfterPassOneText",VidomiOptionsStopAfterPassOneText},
										{"VidomiOptionsVbrDeletePassOneFilesText",VidomiOptionsVbrDeletePassOneFilesText},
										{"VidomiAdvancedVideoOptionsText4",VidomiAdvancedVideoOptionsText4},
										{"VidomiOptionsAspectRatioDetect43Text",VidomiOptionsAspectRatioDetect43Text},
										{"VidomiOptionsAspectRatioOverrideText",VidomiOptionsAspectRatioOverrideText},
										{"VidomiOptionsAspectRatioText",VidomiOptionsAspectRatioText},
										{"VidomiOptionsCancel",VidomiOptionsCancel},
										{"VidomiOptionsOk",VidomiOptionsOk},
										{"",0}
																			
										};

// *****************************************************************************
// optionsAdvancedVideoClass::optionsAdvancedVideoClass()
//
// conversion class constructor
// *****************************************************************************
optionsAdvancedVideoClass::optionsAdvancedVideoClass()
{
	convertConfig = new CONVERTCONFIG [1];

}

// *****************************************************************************
// optionsAdvancedVideoClass::~optionsAdvancedVideoClass()
//
// conversion class destructor
// *****************************************************************************
optionsAdvancedVideoClass::~optionsAdvancedVideoClass()
{
	delete [] convertConfig;
}

// *****************************************************************************
// optionsAdvancedVideoClass::bringUpOptions()
//
// Bring up the options screen
// *****************************************************************************
void optionsAdvancedVideoClass::bringUpOptions(HINSTANCE hInst, CONVERTCONFIG * convertConfigIn)
{
	char text[4096];
	int i;

	optionshWnd = CreateDialog(hInst,MAKEINTRESOURCE(VidomiAdvancedVideoOptions),globals->hWnd, optionsDialogHandler);
	

	globals->translate->translate(text, "VidomiAdvancedVideoOptions");
	SetWindowText(optionshWnd, text);			

	for(i=0;;i++)
		{
		if(!advancedVideoOptionsTID[i].id)
			break;
		globals->translate->translate(text, advancedVideoOptionsTID[i].textId);
		SetWindowText(GetDlgItem(optionshWnd, advancedVideoOptionsTID[i].id),text);			
		}

	convertConfigOriginal = convertConfigIn;
	memcpy(convertConfig,convertConfigOriginal,sizeof(CONVERTCONFIG));
	
	configureOptionsWindow(optionshWnd);

}

// *****************************************************************************
// encoderVideoClass::optionsDialogHandler()
//
//
// *****************************************************************************
BOOL CALLBACK optionsAdvancedVideoClass::optionsDialogHandler(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{

	return(globals->optionsAdvancedVideo->optionsDialogHandler1(hWnd,message,wParam,lParam));
}
// *****************************************************************************
// optionsAdvancedVideoClass::optionsDialogHandler1()
//
//
// *****************************************************************************
BOOL optionsAdvancedVideoClass::optionsDialogHandler1(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	unsigned short commandId;
	unsigned short commandEvent;
	int state;

	switch(message)
		{

		case WM_COMMAND:
			commandId   = LOWORD(wParam); // Remember, these are...
			commandEvent = HIWORD(wParam); // ...different for Win32!

			//Parse the menu selections:

			switch (commandId) 
				{
				case VidomiOptionsOk :
					readWindowVars(hWnd);

					convertConfigOriginal->vbrDeletePassOneFiles = convertConfig->vbrDeletePassOneFiles;
					convertConfigOriginal->vbrCrispness = convertConfig->vbrCrispness;
					convertConfigOriginal->vbrMinKeyFrame = convertConfig->vbrMinKeyFrame;
					convertConfigOriginal->vbrMaxKeyFrame = convertConfig->vbrMaxKeyFrame;
					convertConfigOriginal->vbrMinBitrate = convertConfig->vbrMinBitrate;
					convertConfigOriginal->vbrMaxBitrate = convertConfig->vbrMaxBitrate;
					convertConfigOriginal->vbrMinReservoir = convertConfig->vbrMinReservoir;
					convertConfigOriginal->vbrMaxReservoir = convertConfig->vbrMaxReservoir;
					convertConfigOriginal->vbrQualityBitrate = convertConfig->vbrQualityBitrate;
					convertConfigOriginal->lumaProcessing = convertConfig->lumaProcessing;
					convertConfigOriginal->lumaLowProcessing = convertConfig->lumaLowProcessing;
					convertConfigOriginal->lumaDeltaProcessing = convertConfig->lumaDeltaProcessing;
					convertConfigOriginal->lumaLowThresh = convertConfig->lumaLowThresh;
					convertConfigOriginal->lumaLowBoost = convertConfig->lumaLowBoost;
					convertConfigOriginal->lumaDeltaThresh = convertConfig->lumaDeltaThresh;
					convertConfigOriginal->lumaDeltaBoost = convertConfig->lumaDeltaBoost;
					convertConfigOriginal->aspectRatioOverride = convertConfig->aspectRatioOverride;
					convertConfigOriginal->aspectRatioOverrideValue = convertConfig->aspectRatioOverrideValue;
					convertConfigOriginal->stopAfterPassOne = convertConfig->stopAfterPassOne;
					convertConfigOriginal->aspectRatioDontCorrect43 = convertConfig->aspectRatioDontCorrect43;
					DestroyWindow(hWnd);
					globals->optionsUp=false;
					break;

				case VidomiOptionsLumaProcessing : 
					if((convertConfig->encodeMode == ENCODE_MODE_VBR) || 
						(convertConfig->encodeMode == ENCODE_MODE_VBRTIME) ||
						(convertConfig->encodeMode == ENCODE_MODE_HYBRID1) ||
						(convertConfig->encodeMode == ENCODE_MODE_HYBRID2) ||
						(convertConfig->encodeMode == ENCODE_MODE_HYBRID2TIME) ||
						(convertConfig->encodeMode == ENCODE_MODE_DIVXVBRPLUS) ||
						(convertConfig->encodeMode == ENCODE_MODE_XVIDVBR))
						{
						if(SendDlgItemMessage(hWnd,VidomiOptionsLumaProcessing,BM_GETCHECK , (WPARAM)BST_UNCHECKED, (LPARAM)  0)==BST_CHECKED)
							state = TRUE;
						else
							state = FALSE;
						}
					else
						{
						state = FALSE;
						}

					EnableWindow(GetDlgItem(hWnd,VidomiOptionsLumaLowProcessing), state);	
					EnableWindow(GetDlgItem(hWnd,VidomiOptionsLumaDeltaProcessing), state);	
					EnableWindow(GetDlgItem(hWnd,VidomiOptionsLumaLowThresh), state);	
					EnableWindow(GetDlgItem(hWnd,VidomiOptionsLumaLowBoost), state);		
					EnableWindow(GetDlgItem(hWnd,VidomiOptionsLumaDeltaThresh), state);	
					EnableWindow(GetDlgItem(hWnd,VidomiOptionsLumaDeltaBoost), state);		
					EnableWindow(GetDlgItem(hWnd,VidomiOptionsLumaLowText1), state);	
					EnableWindow(GetDlgItem(hWnd,VidomiOptionsLumaLowText2), state);	
					EnableWindow(GetDlgItem(hWnd,VidomiOptionsLumaDeltaText1), state);	
					EnableWindow(GetDlgItem(hWnd,VidomiOptionsLumaDeltaText2), state);	
					

					break;

				case VidomiOptionsAspectRatioOverride:
					if(SendDlgItemMessage(hWnd,VidomiOptionsAspectRatioOverride,BM_GETCHECK , (WPARAM)BST_UNCHECKED, (LPARAM)  0)==BST_CHECKED)
						state = TRUE;
					else
						state = FALSE;

					EnableWindow(GetDlgItem(hWnd,VidomiOptionsAspectRatioValue), state);	
					EnableWindow(GetDlgItem(hWnd,VidomiOptionsAspectRatioText), state);	
					break;

				case VidomiOptionsCancel :
					DestroyWindow(hWnd);
					globals->optionsUp=false;
					break;

				default : 
					break;

				}
			break;
			
		case WM_CLOSE:
			DestroyWindow(hWnd);
			globals->optionsUp=false;
			break;

		}

	return (FALSE);

}

// *****************************************************************************
// optionsAdvancedVideoClass::configureOptionsWindow()
//
//
// *****************************************************************************
void optionsAdvancedVideoClass::configureOptionsWindow(HWND hWnd)
{
	char tempStr[256];
	int state;

	if(convertConfig->vbrDeletePassOneFiles)
		SendDlgItemMessage(hWnd,VidomiOptionsVbrDeletePassOneFiles,BM_SETCHECK , (WPARAM)BST_CHECKED, (LPARAM)  0);
	else
		SendDlgItemMessage(hWnd,VidomiOptionsVbrDeletePassOneFiles,BM_SETCHECK , (WPARAM)BST_UNCHECKED, (LPARAM)  0);

	sprintf(tempStr,"%d",convertConfig->vbrCrispness);
	SetWindowText(GetDlgItem(hWnd, VidomiOptionsVbrCrispness),tempStr);

	sprintf(tempStr,"%d",convertConfig->vbrMinKeyFrame);
	SetWindowText(GetDlgItem(hWnd, VidomiOptionsVbrMinKeyFrame),tempStr);

	sprintf(tempStr,"%d",convertConfig->vbrMaxKeyFrame);
	SetWindowText(GetDlgItem(hWnd, VidomiOptionsVbrMaxKeyFrame),tempStr);

	sprintf(tempStr,"%d",convertConfig->vbrMinBitrate);
	SetWindowText(GetDlgItem(hWnd, VidomiOptionsVbrMinBitrate),tempStr);

	sprintf(tempStr,"%d",convertConfig->vbrMaxBitrate);
	SetWindowText(GetDlgItem(hWnd, VidomiOptionsVbrMaxBitrate),tempStr);

	sprintf(tempStr,"%d",convertConfig->vbrMinReservoir);
	SetWindowText(GetDlgItem(hWnd, VidomiOptionsVbrMinReservoir),tempStr);

	sprintf(tempStr,"%d",convertConfig->vbrMaxReservoir);
	SetWindowText(GetDlgItem(hWnd, VidomiOptionsVbrMaxReservoir),tempStr);

	sprintf(tempStr,"%d",convertConfig->vbrQualityBitrate);
	SetWindowText(GetDlgItem(hWnd, VidomiOptionsVbrQualityBitrate),tempStr);

	if(convertConfig->lumaProcessing)
		SendDlgItemMessage(hWnd,VidomiOptionsLumaProcessing,BM_SETCHECK , (WPARAM)BST_CHECKED, (LPARAM)  0);
	else
		SendDlgItemMessage(hWnd,VidomiOptionsLumaProcessing,BM_SETCHECK , (WPARAM)BST_UNCHECKED, (LPARAM)  0);

	if(convertConfig->lumaLowProcessing)
		SendDlgItemMessage(hWnd,VidomiOptionsLumaLowProcessing,BM_SETCHECK , (WPARAM)BST_CHECKED, (LPARAM)  0);
	else
		SendDlgItemMessage(hWnd,VidomiOptionsLumaLowProcessing,BM_SETCHECK , (WPARAM)BST_UNCHECKED, (LPARAM)  0);

	if(convertConfig->lumaDeltaProcessing)
		SendDlgItemMessage(hWnd,VidomiOptionsLumaDeltaProcessing,BM_SETCHECK , (WPARAM)BST_CHECKED, (LPARAM)  0);
	else
		SendDlgItemMessage(hWnd,VidomiOptionsLumaDeltaProcessing,BM_SETCHECK , (WPARAM)BST_UNCHECKED, (LPARAM)  0);

	sprintf(tempStr,"%.2f",convertConfig->lumaLowThresh);
	SetWindowText(GetDlgItem(hWnd, VidomiOptionsLumaLowThresh),tempStr);
	sprintf(tempStr,"%d",convertConfig->lumaLowBoost);
	SetWindowText(GetDlgItem(hWnd, VidomiOptionsLumaLowBoost),tempStr);

	sprintf(tempStr,"%.2f",convertConfig->lumaDeltaThresh);
	SetWindowText(GetDlgItem(hWnd, VidomiOptionsLumaDeltaThresh),tempStr);
	sprintf(tempStr,"%d",convertConfig->lumaDeltaBoost);
	SetWindowText(GetDlgItem(hWnd, VidomiOptionsLumaDeltaBoost),tempStr);

	if(convertConfig->stopAfterPassOne)
		SendDlgItemMessage(hWnd,VidomiOptionsStopAfterPassOne,BM_SETCHECK , (WPARAM)BST_CHECKED, (LPARAM)  0);
	else
		SendDlgItemMessage(hWnd,VidomiOptionsStopAfterPassOne,BM_SETCHECK , (WPARAM)BST_UNCHECKED, (LPARAM)  0);


	if((convertConfig->encodeMode ==  ENCODE_MODE_VBR) ||
		(convertConfig->encodeMode ==  ENCODE_MODE_VBRTIME) ||
		(convertConfig->encodeMode == ENCODE_MODE_HYBRID1) ||
		(convertConfig->encodeMode == ENCODE_MODE_HYBRID2) ||
		(convertConfig->encodeMode == ENCODE_MODE_HYBRID2TIME))
		state = true;
	else
		state = false;

	EnableWindow(GetDlgItem(hWnd,VidomiOptionsVbrCrispness), state);	
	EnableWindow(GetDlgItem(hWnd,VidomiOptionsVbrCrispnessText), state);	
	EnableWindow(GetDlgItem(hWnd,VidomiOptionsVbrMinReservoir), state);	
	EnableWindow(GetDlgItem(hWnd,VidomiOptionsVbrMinReservoirText), state);	
	EnableWindow(GetDlgItem(hWnd,VidomiOptionsVbrMinReservoirText1), state);	
	EnableWindow(GetDlgItem(hWnd,VidomiOptionsVbrMaxReservoir), state);	
	EnableWindow(GetDlgItem(hWnd,VidomiOptionsVbrMaxReservoirText), state);	
	EnableWindow(GetDlgItem(hWnd,VidomiOptionsVbrMaxReservoirText1), state);
	EnableWindow(GetDlgItem(hWnd,VidomiOptionsVbrMaxKeyFrame), state);	
	EnableWindow(GetDlgItem(hWnd,VidomiOptionsVbrMaxKeyFrameText), state);
	EnableWindow(GetDlgItem(hWnd,VidomiOptionsLumaProcessing), state);		
	EnableWindow(GetDlgItem(hWnd,VidomiOptionsLumaProcessingText), state);

	if((convertConfig->encodeMode ==  ENCODE_MODE_VBR) ||
		(convertConfig->encodeMode ==  ENCODE_MODE_DIVXVBRPLUS) ||
		(convertConfig->encodeMode ==  ENCODE_MODE_VBRTIME) ||
		(convertConfig->encodeMode == ENCODE_MODE_HYBRID1) ||
		(convertConfig->encodeMode == ENCODE_MODE_HYBRID2) ||
		(convertConfig->encodeMode == ENCODE_MODE_XVIDHYBRID) ||
		(convertConfig->encodeMode == ENCODE_MODE_HYBRID2TIME))
		state = true;
	else
		state = false;

	EnableWindow(GetDlgItem(hWnd,VidomiOptionsVbrMinBitrate), state);	
	EnableWindow(GetDlgItem(hWnd,VidomiOptionsVbrMinBitrateText), state);	
	EnableWindow(GetDlgItem(hWnd,VidomiOptionsVbrMinBitrateText1), state);	
	EnableWindow(GetDlgItem(hWnd,VidomiOptionsVbrMaxBitrate), state);	
	EnableWindow(GetDlgItem(hWnd,VidomiOptionsVbrMaxBitrateText), state);	
	EnableWindow(GetDlgItem(hWnd,VidomiOptionsVbrMaxBitrateText1), state);	

	if((convertConfig->encodeMode == ENCODE_MODE_HYBRID2TIME) || 
		(convertConfig->encodeMode ==  ENCODE_MODE_VBRTIME))
		state = true;
	else
		state = false;

	EnableWindow(GetDlgItem(hWnd,VidomiOptionsVbrQualityBitrate), state);	
	EnableWindow(GetDlgItem(hWnd,VidomiOptionsVbrQualityBitrateText), state);	
	EnableWindow(GetDlgItem(hWnd,VidomiOptionsVbrQualityBitrateText1), state);	

	
	if((convertConfig->encodeMode ==  ENCODE_MODE_VBR) || 
		(convertConfig->encodeMode ==  ENCODE_MODE_DIVXVBR)||
		(convertConfig->encodeMode ==  ENCODE_MODE_DIVXVBRPLUS) ||
		(convertConfig->encodeMode ==  ENCODE_MODE_VBRTIME) ||
		(convertConfig->encodeMode == ENCODE_MODE_XVIDVBR))
		state = true;
	else
		state = false;

	EnableWindow(GetDlgItem(hWnd,VidomiOptionsStopAfterPassOne), state);	
	EnableWindow(GetDlgItem(hWnd,VidomiOptionsStopAfterPassOneText), state);

	if(((convertConfig->encodeMode ==  ENCODE_MODE_VBR) ||
		(convertConfig->encodeMode ==  ENCODE_MODE_VBRTIME) ||
		(convertConfig->encodeMode == ENCODE_MODE_HYBRID1) ||
		(convertConfig->encodeMode == ENCODE_MODE_HYBRID2) ||
		(convertConfig->encodeMode == ENCODE_MODE_HYBRID2TIME)) && convertConfig->lumaProcessing)
		{
		state =true;
		}
	else
		{
		state = false;
		}

	EnableWindow(GetDlgItem(hWnd,VidomiOptionsLumaLowProcessing), state);	
	EnableWindow(GetDlgItem(hWnd,VidomiOptionsLumaDeltaProcessing), state);	
	EnableWindow(GetDlgItem(hWnd,VidomiOptionsLumaLowThresh), state);	
	EnableWindow(GetDlgItem(hWnd,VidomiOptionsLumaLowBoost), state);		
	EnableWindow(GetDlgItem(hWnd,VidomiOptionsLumaDeltaThresh), state);	
	EnableWindow(GetDlgItem(hWnd,VidomiOptionsLumaDeltaBoost), state);		
	EnableWindow(GetDlgItem(hWnd,VidomiOptionsLumaLowText1), state);	
	EnableWindow(GetDlgItem(hWnd,VidomiOptionsLumaLowText2), state);	
	EnableWindow(GetDlgItem(hWnd,VidomiOptionsLumaDeltaText1), state);	
	EnableWindow(GetDlgItem(hWnd,VidomiOptionsLumaDeltaText2), state);	

	if((convertConfig->encodeMode == ENCODE_MODE_VBR) || (convertConfig->encodeMode ==  ENCODE_MODE_VBRTIME))
		state = true;
	else
		state = false;
	
	EnableWindow(GetDlgItem(hWnd,VidomiOptionsVbrMinKeyFrame), state);	
	EnableWindow(GetDlgItem(hWnd,VidomiOptionsVbrMinKeyFrameText), state);

	if((convertConfig->encodeMode == ENCODE_MODE_VBR) || (convertConfig->encodeMode == ENCODE_MODE_DIVXVBR) ||
		(convertConfig->encodeMode == ENCODE_MODE_DIVXVBRPLUS) || (convertConfig->encodeMode ==  ENCODE_MODE_VBRTIME) ||
		(convertConfig->encodeMode == ENCODE_MODE_XVIDVBR))
		state = true;
	else
		state = false;

	EnableWindow(GetDlgItem(hWnd,VidomiOptionsVbrDeletePassOneFiles), state);	
	EnableWindow(GetDlgItem(hWnd,VidomiOptionsVbrDeletePassOneFilesText), state);	

	if(convertConfig->aspectRatioOverride)
		SendDlgItemMessage(hWnd,VidomiOptionsAspectRatioOverride,BM_SETCHECK , (WPARAM)BST_CHECKED, (LPARAM)  0);
	else
		SendDlgItemMessage(hWnd,VidomiOptionsAspectRatioOverride,BM_SETCHECK , (WPARAM)BST_UNCHECKED, (LPARAM)  0);

	if(convertConfig->aspectRatioDontCorrect43)
		SendDlgItemMessage(hWnd,VidomiOptionsAspectRatioDontCorrect43,BM_SETCHECK , (WPARAM)BST_CHECKED, (LPARAM)  0);
	else
		SendDlgItemMessage(hWnd,VidomiOptionsAspectRatioDontCorrect43,BM_SETCHECK , (WPARAM)BST_UNCHECKED, (LPARAM)  0);

	sprintf(tempStr,"%.2f",convertConfig->aspectRatioOverrideValue);
	SetWindowText(GetDlgItem(hWnd, VidomiOptionsAspectRatioValue),tempStr);
	
	state = convertConfig->aspectRatioOverride;

	EnableWindow(GetDlgItem(hWnd,VidomiOptionsAspectRatioValue), state);	
	EnableWindow(GetDlgItem(hWnd,VidomiOptionsAspectRatioText), state);	


}

// *****************************************************************************
// optionsAdvancedVideoClass::readWindowVars()
//
//
// *****************************************************************************
void optionsAdvancedVideoClass::readWindowVars(HWND hWnd)
{
	char tempStr[260];

	GetWindowText(GetDlgItem(hWnd, VidomiOptionsVbrCrispness), tempStr , 256);
 	convertConfig->vbrCrispness = atoi(tempStr);

	GetWindowText(GetDlgItem(hWnd, VidomiOptionsVbrMinKeyFrame), tempStr , 256);
 	convertConfig->vbrMinKeyFrame = atoi(tempStr);

	GetWindowText(GetDlgItem(hWnd, VidomiOptionsVbrMaxKeyFrame), tempStr , 256);
 	convertConfig->vbrMaxKeyFrame = atoi(tempStr);

	GetWindowText(GetDlgItem(hWnd, VidomiOptionsVbrMinBitrate), tempStr , 256);
 	convertConfig->vbrMinBitrate = atoi(tempStr);

	GetWindowText(GetDlgItem(hWnd, VidomiOptionsVbrMaxBitrate), tempStr , 256);
 	convertConfig->vbrMaxBitrate = atoi(tempStr);

	GetWindowText(GetDlgItem(hWnd, VidomiOptionsVbrMinReservoir), tempStr , 256);
 	convertConfig->vbrMinReservoir = atoi(tempStr);

	GetWindowText(GetDlgItem(hWnd, VidomiOptionsVbrMaxReservoir), tempStr , 256);
 	convertConfig->vbrMaxReservoir = atoi(tempStr);

	GetWindowText(GetDlgItem(hWnd, VidomiOptionsVbrQualityBitrate), tempStr , 256);
 	convertConfig->vbrQualityBitrate = atoi(tempStr);

	if(SendDlgItemMessage(hWnd,VidomiOptionsVbrDeletePassOneFiles,BM_GETCHECK , (WPARAM)BST_UNCHECKED, (LPARAM)  0)==BST_CHECKED)
		convertConfig->vbrDeletePassOneFiles=true;
	else
		convertConfig->vbrDeletePassOneFiles=false;

	if(SendDlgItemMessage(hWnd,VidomiOptionsLumaProcessing,BM_GETCHECK , (WPARAM)BST_UNCHECKED, (LPARAM)  0)==BST_CHECKED)
		convertConfig->lumaProcessing=true;
	else
		convertConfig->lumaProcessing=false;

	if(SendDlgItemMessage(hWnd,VidomiOptionsLumaLowProcessing,BM_GETCHECK , (WPARAM)BST_UNCHECKED, (LPARAM)  0)==BST_CHECKED)
		convertConfig->lumaLowProcessing=true;
	else
		convertConfig->lumaLowProcessing=false;

	if(SendDlgItemMessage(hWnd,VidomiOptionsLumaDeltaProcessing,BM_GETCHECK , (WPARAM)BST_UNCHECKED, (LPARAM)  0)==BST_CHECKED)
		convertConfig->lumaDeltaProcessing=true;
	else
		convertConfig->lumaDeltaProcessing=false;

	//Floating point
	GetWindowText(GetDlgItem(hWnd, VidomiOptionsLumaLowThresh), tempStr , 256);
 	convertConfig->lumaLowThresh = (float)atof(tempStr);

	GetWindowText(GetDlgItem(hWnd, VidomiOptionsLumaLowBoost), tempStr , 256);
 	convertConfig->lumaLowBoost = atoi(tempStr);

	//Floating point
	GetWindowText(GetDlgItem(hWnd, VidomiOptionsLumaDeltaThresh), tempStr , 256);
 	convertConfig->lumaDeltaThresh = (float)atof(tempStr);

	GetWindowText(GetDlgItem(hWnd, VidomiOptionsLumaDeltaBoost), tempStr , 256);
 	convertConfig->lumaDeltaBoost = atoi(tempStr);


	if(SendDlgItemMessage(hWnd,VidomiOptionsAspectRatioOverride,BM_GETCHECK , (WPARAM)BST_UNCHECKED, (LPARAM)  0)==BST_CHECKED)
		convertConfig->aspectRatioOverride=true;
	else
		convertConfig->aspectRatioOverride=false;

	//Floating point
	GetWindowText(GetDlgItem(hWnd, VidomiOptionsAspectRatioValue), tempStr , 256);
 	convertConfig->aspectRatioOverrideValue = (float)atof(tempStr);

	if(SendDlgItemMessage(hWnd,VidomiOptionsAspectRatioDontCorrect43,BM_GETCHECK , (WPARAM)BST_UNCHECKED, (LPARAM)  0)==BST_CHECKED)
		convertConfig->aspectRatioDontCorrect43=true;
	else
		convertConfig->aspectRatioDontCorrect43=false;

	if(SendDlgItemMessage(hWnd,VidomiOptionsStopAfterPassOne,BM_GETCHECK , (WPARAM)BST_UNCHECKED, (LPARAM)  0)==BST_CHECKED)
		convertConfig->stopAfterPassOne=true;
	else
		convertConfig->stopAfterPassOne=false;

}