// *****************************************************************************
//	Vidomi - Video Encoder
//
//	Copyright (C) 2001 Vidomi, Inc.
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

// *****************************************************************************
// *****************************************************************************
//
//
// optionsspecial.cpp
// 
//
// *****************************************************************************

#include "en.h"

extern GLOBALS * globals;
char * specialBrowseText = "All\0*.*\0\0";

// *****************************************************************************
// optionsSpecialClass::optionsSpecialClass()
//
// conversion class constructor
// *****************************************************************************
optionsSpecialClass::optionsSpecialClass()
{
	convertConfig = new CONVERTCONFIG [1];

}

// *****************************************************************************
// optionsSpecialClass::~optionsSpecialClass()
//
// conversion class destructor
// *****************************************************************************
optionsSpecialClass::~optionsSpecialClass()
{
	delete [] convertConfig;
}

// *****************************************************************************
// optionsSpecialClass::bringUpOptions()
//
// Bring up the options screen
// *****************************************************************************
void optionsSpecialClass::bringUpOptions(HINSTANCE hInst, CONVERTCONFIG * convertConfigIn)
{

	optionshWnd = CreateDialog(hInst,MAKEINTRESOURCE(VidomiSpecialOptions),globals->hWnd, optionsDialogHandler);
	
	convertConfigOriginal = convertConfigIn;
	memcpy(convertConfig,convertConfigOriginal,sizeof(CONVERTCONFIG));
	
	configureOptionsWindow(optionshWnd);

}

// *****************************************************************************
// encoderVideoClass::optionsDialogHandler()
//
//
// *****************************************************************************
BOOL CALLBACK optionsSpecialClass::optionsDialogHandler(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{

	return(globals->optionsSpecial->optionsDialogHandler1(hWnd,message,wParam,lParam));
}

// *****************************************************************************
// optionsSpecialClass::windowDialogHandler()
//
//
// *****************************************************************************
BOOL optionsSpecialClass::optionsDialogHandler1(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	unsigned short commandId;
	unsigned short commandEvent;
	BROWSEINFO OpenDirData;
	ITEMIDLIST * itemId;

	switch(message)
		{

		case WM_COMMAND:
			commandId   = LOWORD(wParam); // Remember, these are...
			commandEvent = HIWORD(wParam); // ...different for Win32!

			//Parse the menu selections:

			switch (commandId) 
				{
				case VidomiOptionsOk :
					readWindowVars(hWnd);

					convertConfigOriginal->introAvi = convertConfig->introAvi;
					convertConfigOriginal->useSpecifiedTarget = convertConfig->useSpecifiedTarget;
					convertConfigOriginal->specifiedTarget = convertConfig->specifiedTarget;
					strcpy(convertConfigOriginal->introAviPrimaryPath,convertConfig->introAviPrimaryPath);
					strcpy(convertConfigOriginal->introAviSecondaryPath,convertConfig->introAviSecondaryPath);
					DestroyWindow(hWnd);
					globals->optionsUp=false;
					break;

				case VidomiOptionsSetIntroAviPrimaryPath :
					OpenDirData.hwndOwner = globals->hWnd;	
					OpenDirData.pidlRoot = NULL;
					OpenDirData.pszDisplayName = convertConfig->introAviPrimaryPath;
					OpenDirData.lpszTitle  = "Select Primary Directory";
					OpenDirData.ulFlags  = 0;
					OpenDirData.lpfn   = NULL;
					OpenDirData.lParam = 0 ;
					OpenDirData.iImage  = 0 ;
					itemId = SHBrowseForFolder(&OpenDirData);
					if(itemId)
						{
						SHGetPathFromIDList(itemId,convertConfig->introAviPrimaryPath);
						}
					SetWindowText(GetDlgItem(hWnd, VidomiOptionsSetIntroAviPrimaryPathText), convertConfig->introAviPrimaryPath);
					break;

				case VidomiOptionsSetIntroAviSecondaryPath :
					OpenDirData.hwndOwner = globals->hWnd;	
					OpenDirData.pidlRoot = NULL;
					OpenDirData.pszDisplayName = convertConfig->introAviSecondaryPath;
					OpenDirData.lpszTitle  = "Select Secondary Directory";
					OpenDirData.ulFlags  = 0;
					OpenDirData.lpfn   = NULL;
					OpenDirData.lParam = 0 ;
					OpenDirData.iImage  = 0 ;
					itemId = SHBrowseForFolder(&OpenDirData);
					if(itemId)
						{
						SHGetPathFromIDList(itemId,convertConfig->introAviSecondaryPath);
						}
					SetWindowText(GetDlgItem(hWnd, VidomiOptionsSetIntroAviSecondaryPathText), convertConfig->introAviSecondaryPath);
					break;

				case VidomiOptionsCancel :
					DestroyWindow(hWnd);
					globals->optionsUp=false;
					break;

				}
			break;
			
		case WM_CLOSE:
			DestroyWindow(hWnd);
			globals->optionsUp=false;
			break;

		}

	return (FALSE);

}

// *****************************************************************************
// optionsSpecialClass::configureOptionsWindow()
//
//
// *****************************************************************************
void optionsSpecialClass::configureOptionsWindow(HWND hWnd)
{
	char tempStr[256];

	if(convertConfig->introAvi)
		SendDlgItemMessage(hWnd,VidomiOptionsUseIntroAvi,BM_SETCHECK , (WPARAM)BST_CHECKED, (LPARAM)  0);
	else
		SendDlgItemMessage(hWnd,VidomiOptionsUseIntroAvi,BM_SETCHECK , (WPARAM)BST_UNCHECKED, (LPARAM)  0);

	if(convertConfig->useSpecifiedTarget)
		SendDlgItemMessage(hWnd,VidomiOptionsUseSpecifiedTarget,BM_SETCHECK , (WPARAM)BST_CHECKED, (LPARAM)  0);
	else
		SendDlgItemMessage(hWnd,VidomiOptionsUseSpecifiedTarget,BM_SETCHECK , (WPARAM)BST_UNCHECKED, (LPARAM)  0);

	sprintf(tempStr,"%d",convertConfig->specifiedTarget);
	SetWindowText(GetDlgItem(hWnd, VidomiOptionsSpecifiedTarget),tempStr);

	SetWindowText(GetDlgItem(hWnd, VidomiOptionsSetIntroAviPrimaryPathText),convertConfig->introAviPrimaryPath);
	SetWindowText(GetDlgItem(hWnd, VidomiOptionsSetIntroAviSecondaryPathText),convertConfig->introAviSecondaryPath);
}

// *****************************************************************************
// optionsSpecialClass::readWindowVars()
//
//
// *****************************************************************************
void optionsSpecialClass::readWindowVars(HWND hWnd)
{
	char tempStr[256];

	if(SendDlgItemMessage(hWnd,VidomiOptionsUseIntroAvi,BM_GETCHECK , (WPARAM)BST_UNCHECKED, (LPARAM)  0)==BST_CHECKED)
		convertConfig->introAvi=true;
	else
		convertConfig->introAvi=false;

	if(SendDlgItemMessage(hWnd,VidomiOptionsUseSpecifiedTarget,BM_GETCHECK , (WPARAM)BST_UNCHECKED, (LPARAM)  0)==BST_CHECKED)
		convertConfig->useSpecifiedTarget=true;
	else
		convertConfig->useSpecifiedTarget=false;

	GetWindowText(GetDlgItem(hWnd, VidomiOptionsSpecifiedTarget), tempStr , 256);
 	convertConfig->specifiedTarget = atoi(tempStr);

}