// *****************************************************************************
//	Vidomi - Video Encoder
//
//	Copyright (C) 2001 Vidomi, Inc.
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

// *****************************************************************************
// *****************************************************************************
// outputStats class
// *****************************************************************************
#ifndef outputStats_h
#define outputStats_h

class outputStatsClass 
{

	public:
									outputStatsClass();
									~outputStatsClass();
			bool					createOutputWindow(HINSTANCE hInst);
			bool					showOutputWindow();
			bool					hideOutputWindow();
			BOOL static CALLBACK	statsDialogHandler(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
			BOOL					statsDialogHandler1(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
			void					setFPS(float fps);
			void					setPass(int currentPass, int totalPasses);
			void					setElapsedPassTime(int milliseconds);
			void					setElapsedJobTime(int secs);
			void					setElapsedTime(int secs);
			void					setRemainingTime(int secs);
			void					setPercentComplete(float percent);
			bool					windowVisible();
			void					setJobsRemaining(int count);
			void					setJobsBeingProcessed(int count);
			void					setTotalEncodeJobs(int count);
			int						getMachineSelected();
			void					insertMachineName(char * name, int index);
			void					resetMachineSelection();
			void					setJobNameText(char * jobText);
			void					setRange(int currentRange, int totalNumRanges);
			void					setJobsCompleted(int count);
			void					setConnectionStatusText(char * connectionText);
	private:
			bool					visible;
			HWND					statshWnd;
			char *					statsStr;
			HINSTANCE				statshInst;
			bool					windowsCreated;
};


#endif