// *****************************************************************************
//	Vidomi - Video Encoder
//
//	Copyright (C) 2001 Vidomi, Inc.
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

// *****************************************************************************
// *****************************************************************************
// outputvideo class
// *****************************************************************************
#ifndef outputvideo_h
#define outputvideo_h

class outputVideoClass 
{

	public:
									outputVideoClass();
									~outputVideoClass();
			bool					createOutputWindow(HINSTANCE hInst);
			bool					registerWindowClass(HINSTANCE hInst);
			bool					displayFrame(FRAMEDATA * frame);
			BOOL static CALLBACK	windowMessageHandler(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
			BOOL static CALLBACK	windowMessageHandlerFullscreen(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
			BOOL					windowMessageHandler1(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
			BOOL					windowMessageHandlerFullscreen1(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
			bool					showOutputWindow();
			bool					hideOutputWindow();
			bool					setVideoInputFormat(int width,int height,int colorSpace);
			bool					setOutputWindowSize(int width,int height, int extraWidth, int extraHeight);
			bool					setOutputWindowText(char * tempStr);
			bool					windowVisible();
			bool					displayAviFrame(FRAMEDATA * frame);
			bool					windowRepaint();
			bool					setResize(bool onOff);
			bool					getScreenState();
			HWND					outputhWnd;
			BITMAPINFO				bitmapInfo;

	private:
			HWND					outputhWnd1;
			HINSTANCE				outputhInst;
			WNDCLASS				windCls;
			int						videoWidth;
			int						videoHeight;
			int						videoBpp;
			int						videoColorSpace;
			bool					videoInputSet;
			int						leftBorder;
			int						topBorder;
			bool					visible;
			double					aspectRatio;
			double					invAspectRatio;
			HDRAWDIB				hdd;
			RECT					outputState;
			int						monitorWidth;
			int						monitorHeight;
			int						originalWidth;
			int						originalHeight;
			DEVMODE					displayDevice;
			volatile int			outputOffsetX;
			volatile int			outputOffsetY;
			volatile int			outputWidth;
			volatile int			outputHeight;
			volatile bool			fullscreen;
			CRITICAL_SECTION		fullscreenLock;
			POINT					mousePos;
			bool					needsRepaint;
			bool					resize;
			int						panelWidth;
			int						panelHeight;


};


#endif