// *****************************************************************************
// readavi class
// *****************************************************************************
#ifndef readavi_h
#define readavi_h

#define CRITICAL_ERROR 50

#define AVIREADAUDIO_BUFFER_SIZE 2000000
#define AUDIO_FORMAT_BUFFER_SIZE 1024
#define AVI_READ_MODE_PLAYER_NONE 0
#define AVI_READ_MODE_PLAYER_RGB32 1
#define AVI_READ_MODE_PLAYER_YV12 2

#define MAX_AUDIO_CHANNELS 4
#define MAX_VIDEO_CHANNELS 4

class readAviClass : public avReadClass
{

	public:
									readAviClass();
									~readAviClass();
			void					addInput(char * inputFilename);
			bool					begin(int mode);
			void					setIdct(int idctType);
			void					clearInput();
			bool					init();
			void					end();
			bool					checkEnd();
			int						decodeFrame();

			FRAMEDATA *				getFrameData();
			void					getDimentions(int * width, int * height, double * aspectRatio);
			void					getAudioOutput(int channel, int * outChannels, int * outSampleRate);
			float					getFramerate();
			void					setFilm(bool film);
			AUDIODATA *				getAudioData(int channelIndex);
			void					setAudio(bool audio, int channelIndex, int audioType, int audioTrack, int streamCopy);
			bool					seekPos(__int64 pos);
			__int64					getLength();
			__int64					getCurPos();
			long					getNextKeyframe(void);
			long					getPrevKeyframe(void);
			bool					seekFramePos(long frame);
			long					getFramePos();
			int						skipFrame();
			void					setDecodeMode(int mode);
			bool					decodeFrameRead(FRAMEDATA * dest);
			void					decodeFrameSize(unsigned int * size);
			int						decodeFrameDecompress(FRAMEDATA * source,DWORD decompType, long size);
			long					getClosestKeyframe(int seekFrame);
			void					rgb24ToRgb32(FRAMEDATA * srcFrame, FRAMEDATA * dstFrame);
			SUBTITLEDATA *			getSubtitleData(int channelIndex);
			void					setSubtitle(bool subEnabled,int channelIndex, int subtitleTrack);
			int						getFrameType(void);

	private:
			divxClass *				divx;
			bool					notDone;
			FRAMEDATA *				frame;
			AUDIODATA *				audio;
			char *					inputFiles[16];
			int						inputFileIndex;				
			bool					aviInitialized;
			int						readFileIndex;
			DIVXVIDEOINFO			divxVideoStreamInfo[MAX_VIDEO_CHANNELS];
			bool					hasAudio;
			bool					wantAudio;
			bool					hasVideo;
			int						width;
			int						height;
			float					framerate;
			int						sampleRate[MAX_AUDIO_CHANNELS];
			int						channels[MAX_AUDIO_CHANNELS];
			int						frameCount;
			long					startingFrame;
			long					endingFrame;
			long					startingSample;
			long					endingSample;
			int						audioSamplePos;
			AUDIODATA *				audioOut;
			AUDIODATA *				audioIn;
			int						bufferSize;
			WAVEFORMATEX			audioFormatOut[MAX_AUDIO_CHANNELS];
			MPEGLAYER3WAVEFORMAT *	audioFormatIn[MAX_AUDIO_CHANNELS];
			long					audioFormatSize[MAX_AUDIO_CHANNELS];
			HACMSTREAM				audioAcmStream;
			ACMSTREAMHEADER			audioAcmHeader;
			DWORD					sourceAtom;
			DWORD					destAtom;
			double					samplesPerFrame[MAX_AUDIO_CHANNELS];
			int						audioBytesToSkip;
			int						aviReadMode;
			double					msPerFrame;
			FRAMEDATA *				frameIn;
			BITMAPINFO *			videoFormatIn;
			BITMAPINFO *			videoFormatOut;
			int						bytesPerSample[MAX_AUDIO_CHANNELS];
			int						audioStreamRate;
			int						videoStreamRate;
			int						currentAudioChannel;
			int						currentVideoChannel;
			int						numAudioChannels;
			int						numVideoChannels;
			bool					decodeFirstTime;


};



#endif