// *****************************************************************************
//	Vidomi - Video Encoder
//
//	Copyright (C) 2001 Vidomi, Inc.
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

// *****************************************************************************
// *****************************************************************************
//
//
// readmpeg.cpp
// 
//
// *****************************************************************************

#include "en.h"

extern GLOBALS * globals;

// *****************************************************************************
// readMpegClass::readMpegClass()
//
// conversion class constructor
// *****************************************************************************
readMpegClass::readMpegClass()
{
	pathToDll = new char [MAX_PATH];

	d2aDll = NULL;
	dvd2AviInit	= NULL;
	dvd2AviSetIdct = NULL;
	dvd2AviStartConversion = NULL;
	dvd2AviGetHeader = NULL;
	dvd2AviDecodeFrame = NULL;
	dvd2AviDecodeFrameBegin = NULL;
	dvd2AviDecodeFrameMiddle = NULL;
	dvd2AviDecodeFrameEnd = NULL;
	dvd2AviCheckStopFlag = NULL;
	dvd2AviSetFaultFlag = NULL;
	dvd2AviGetFaultFlag = NULL;
	dvd2AviDecodeInit = NULL;
	dvd2AviGetFrameData = NULL;
	dvd2AviGetDimentions = NULL;
	dvd2AviGetFramerate = NULL;
	dvd2AviGetCpuType = NULL;
	dvd2AviSetFilm = NULL;
	dvd2AviGetAudioData = NULL;
	dvd2AviSetAudio = NULL;
	dvd2AviCleanup = NULL;
	dvd2AviAddInput = NULL;
	dvd2AviClearInput = NULL;
	dvd2AviInit = NULL;
	dvd2AviGetEndPos = NULL;
	dvd2AviSeekPos = NULL;
	dvd2AviGetCurPos = NULL;
	dvd2AviGetSubtitleData = NULL;
	dvd2AviSetSubtitle = NULL;

}

// *****************************************************************************
// readMpegClass::~readMpegClass()
//
// conversion class destructor
// *****************************************************************************
readMpegClass::~readMpegClass()
{
	delete [] pathToDll;
}

// *****************************************************************************
// readMpegClass::init()
//
// *****************************************************************************
bool readMpegClass::init()
{
	strcpy(pathToDll,globals->pathToExeDir);
	strcat(pathToDll,"\\ncoded2a.dll");


	d2aDll = LoadLibrary(pathToDll);

	if(d2aDll==NULL)
		{
		// If failed, make a second attempt at debug env location
		#ifdef _DEBUG
		strcpy(pathToDll,globals->pathToExeDir);
		strcat(pathToDll,"\\..\\ncoded2a\\Debug\\ncoded2a.dll");
		#else
		strcpy(pathToDll,globals->pathToExeDir);
		strcat(pathToDll,"\\..\\ncoded2a\\Release\\ncoded2a.dll");
		#endif
		d2aDll=LoadLibrary(pathToDll);
		if(d2aDll==NULL)
			return(false);
		}

	dvd2AviInit	= (DVD2AVIINIT) GetProcAddress(d2aDll, TEXT_DVD2AVIINIT);
	dvd2AviSetIdct = (DVD2AVISETIDCT) GetProcAddress(d2aDll, TEXT_DVD2AVISETIDCT);
	dvd2AviStartConversion = (DVD2AVISTARTCONVERSION) GetProcAddress(d2aDll, TEXT_DVD2AVISTARTCONVERSION);
	dvd2AviGetHeader = (DVD2AVIGETHEADER) GetProcAddress(d2aDll, TEXT_DVD2AVIGETHEADER);
	dvd2AviDecodeFrame = (DVD2AVIDECODEFRAME) GetProcAddress(d2aDll, TEXT_DVD2AVIDECODEFRAME);
	dvd2AviDecodeFrameBegin = (DVD2AVIDECODEFRAMEBEGIN) GetProcAddress(d2aDll, TEXT_DVD2AVIDECODEFRAMEBEGIN);
	dvd2AviDecodeFrameMiddle = (DVD2AVIDECODEFRAMEMIDDLE) GetProcAddress(d2aDll, TEXT_DVD2AVIDECODEFRAMEMIDDLE);
	dvd2AviDecodeFrameEnd = (DVD2AVIDECODEFRAMEEND) GetProcAddress(d2aDll, TEXT_DVD2AVIDECODEFRAMEEND);
	dvd2AviCheckStopFlag = (DVD2AVICHECKSTOPFLAG) GetProcAddress(d2aDll, TEXT_DVD2AVICHECKSTOPFLAG);
	dvd2AviSetFaultFlag = (DVD2AVISETFAULTFLAG) GetProcAddress(d2aDll, TEXT_DVD2AVISETFAULTFLAG);
	dvd2AviGetFaultFlag = (DVD2AVIGETFAULTFLAG) GetProcAddress(d2aDll, TEXT_DVD2AVIGETFAULTFLAG);
	dvd2AviDecodeInit = (DVD2AVIDECODEINIT) GetProcAddress(d2aDll, TEXT_DVD2AVIDECODEINIT);
	dvd2AviGetFrameData = (DVD2AVIGETFRAMEDATA) GetProcAddress(d2aDll, TEXT_DVD2AVIGETFRAMEDATA);
	dvd2AviGetDimentions = (DVD2AVIGETDIMENTIONS) GetProcAddress(d2aDll, TEXT_DVD2AVIGETDIMENTIONS);
	dvd2AviGetFramerate = (DVD2AVIGETFRAMERATE) GetProcAddress(d2aDll, TEXT_DVD2AVIGETFRAMERATE);
	dvd2AviGetCpuType = (DVD2AVIGETCPUTYPE) GetProcAddress(d2aDll, TEXT_DVD2AVIGETCPUTYPE);
	dvd2AviSetFilm = (DVD2AVISETFILM) GetProcAddress(d2aDll, TEXT_DVD2AVISETFILM);
	dvd2AviGetAudioData = (DVD2AVIGETAUDIODATA) GetProcAddress(d2aDll, TEXT_DVD2AVIGETAUDIODATA);
	dvd2AviSetAudio = (DVD2AVISETAUDIO) GetProcAddress(d2aDll, TEXT_DVD2AVISETAUDIO);
	dvd2AviCleanup = (DVD2AVICLEANUP) GetProcAddress(d2aDll, TEXT_DVD2AVICLEANUP);
	dvd2AviAddInput = (DVD2AVIADDINPUT) GetProcAddress(d2aDll, TEXT_DVD2AVIADDINPUT);
	dvd2AviClearInput = (DVD2AVICLEARINPUT) GetProcAddress(d2aDll, TEXT_DVD2AVICLEARINPUT);
	dvd2AviInit = (DVD2AVIINIT) GetProcAddress(d2aDll, TEXT_DVD2AVIINIT);
	dvd2AviSeekPos = (DVD2AVISEEKPOS) GetProcAddress(d2aDll, TEXT_DVD2AVISEEKPOS);
	dvd2AviGetEndPos = (DVD2AVIGETENDPOS) GetProcAddress(d2aDll, TEXT_DVD2AVIGETENDPOS);
	dvd2AviGetCurPos = (DVD2AVIGETCURPOS) GetProcAddress(d2aDll, TEXT_DVD2AVIGETCURPOS);
	dvd2AviGetSubtitleData = (DVD2AVIGETSUBTITLEDATA) GetProcAddress(d2aDll, TEXT_DVD2AVIGETSUBTITLEDATA);
	dvd2AviSetSubtitle = (DVD2AVISETSUBTITLE) GetProcAddress(d2aDll, TEXT_DVD2AVISETSUBTITLE);
	dvd2AviGetFrameType = (DVD2AVIGETFRAMETYPE) GetProcAddress(d2aDll, TEXT_DVD2AVIGETFRAMETYPE);

	if(!dvd2AviInit || !dvd2AviSetIdct || !dvd2AviStartConversion || !dvd2AviGetHeader || !dvd2AviDecodeFrame ||
		!dvd2AviDecodeFrameBegin || !dvd2AviDecodeFrameMiddle || !dvd2AviDecodeFrameEnd || 
		!dvd2AviCheckStopFlag || !dvd2AviSetFaultFlag || !dvd2AviGetFaultFlag || !dvd2AviDecodeInit ||
		!dvd2AviGetFrameData || !dvd2AviGetDimentions || !dvd2AviGetFramerate || !dvd2AviGetCpuType ||
		!dvd2AviSetFilm || !dvd2AviGetAudioData || !dvd2AviSetAudio || !dvd2AviCleanup || !dvd2AviCleanup ||
		!dvd2AviAddInput || !dvd2AviClearInput || !dvd2AviInit || !dvd2AviSeekPos || !dvd2AviGetEndPos
		|| !dvd2AviGetCurPos || !dvd2AviGetSubtitleData || !dvd2AviSetSubtitle || !dvd2AviGetFrameType)
		{
		FreeLibrary(d2aDll);
		d2aDll=NULL;
		return(false);
		}

	return(true);

}

// *****************************************************************************
// readMpegClass::end()
//
// *****************************************************************************
void readMpegClass::end()
{
	int i;

	if(d2aDll)
		{
		for(i=0;i<MAX_AUDIO_CHANNELS;i++)
			{
			audio = dvd2AviGetAudioData(i);		
			delete [] audio->bufferStart;
			}

		for(i=0;i<MAX_SUBTITLE_CHANNELS;i++)
			{
			subtitle = dvd2AviGetSubtitleData(i);
			delete [] subtitle->bufferStart;
			}

		dvd2AviCleanup();
		FreeLibrary(d2aDll);
		}

	d2aDll = NULL;

	dvd2AviInit	= NULL;
	dvd2AviSetIdct = NULL;
	dvd2AviStartConversion = NULL;
	dvd2AviGetHeader = NULL;
	dvd2AviDecodeFrame = NULL;
	dvd2AviDecodeFrameBegin = NULL;
	dvd2AviDecodeFrameMiddle = NULL;
	dvd2AviDecodeFrameEnd = NULL;
	dvd2AviCheckStopFlag = NULL;
	dvd2AviSetFaultFlag = NULL;
	dvd2AviGetFaultFlag = NULL;
	dvd2AviDecodeInit = NULL;
	dvd2AviGetFrameData = NULL;
	dvd2AviGetDimentions = NULL;
	dvd2AviGetFramerate = NULL;
	dvd2AviGetCpuType = NULL;
	dvd2AviSetFilm = NULL;
	dvd2AviGetAudioData = NULL;
	dvd2AviSetAudio = NULL;
	dvd2AviCleanup = NULL;
	dvd2AviAddInput = NULL;
	dvd2AviClearInput = NULL;
	dvd2AviInit = NULL;
	dvd2AviGetEndPos = NULL;
	dvd2AviSeekPos = NULL;
	dvd2AviGetCurPos = NULL;
	dvd2AviGetSubtitleData = NULL;
	dvd2AviSetSubtitle = NULL;
	dvd2AviGetFrameType = NULL;

	delete [] pathToDll;

}

// *****************************************************************************
// readMpegClass::clearInput()
//
// Clear all files that have been set as input files. 
// *****************************************************************************
void readMpegClass::clearInput()
{
	dvd2AviClearInput();
}

// *****************************************************************************
// readMpegClass::getLength()
//
// get the length of the entire set of files
// *****************************************************************************
__int64 readMpegClass::getLength()
{
	return(dvd2AviGetEndPos());
}

// *****************************************************************************
// readMpegClass::getCurPos()
//
// get the length of the entire set of files
// *****************************************************************************
__int64 readMpegClass::getCurPos()
{
	return(dvd2AviGetCurPos());
}

// *****************************************************************************
// readMpegClass::getFrameType()
//
// get the Current Frame Type
// *****************************************************************************
int readMpegClass::getFrameType()
{
	return(dvd2AviGetFrameType());
}

// *****************************************************************************
// readMpegClass::seekPos()
//
// Seek to a position in the stream
// *****************************************************************************
bool readMpegClass::seekPos(__int64 pos)
{

	if(dvd2AviSeekPos(pos)==true)
		{
		atHeader=true;
		decodeState = 0;
		return(true);
		}
	return(false);
}

// *****************************************************************************
// readMpegClass::addInput()
//
// inputFilename = path and name of input MPEG
// *****************************************************************************
void readMpegClass::addInput(char * inputFilename)
{
	dvd2AviAddInput(inputFilename);
}

// *****************************************************************************
// readMpegClass::begin()
//
// *****************************************************************************
bool readMpegClass::begin(int mode)
{
	int i;

	logPrintf("Calling dvd2AviStartConverson\n");
	dvd2AviStartConversion();
	logPrintf("Calling dvd2AviInit\n");
	dvd2AviInit();

	for(i=0;i<MAX_AUDIO_CHANNELS;i++)
		{
		audio = dvd2AviGetAudioData(i);
		audio->bufferStart = new unsigned char [AUDIO_BUFFER_SIZE ]; //malloc(AUDIO_DECODE_BUFFER_SIZE);
		audio->data = audio->bufferStart;
		audio->bufferSize = AUDIO_BUFFER_SIZE ;
		audio->bytesUsed=0;
		}

	for(i=0;i<MAX_SUBTITLE_CHANNELS;i++)
		{
		subtitle = dvd2AviGetSubtitleData(i);
		subtitle->bufferStart = new unsigned char [SUBTITLE_BUFFER_SIZE]; 
		subtitle->data = subtitle->bufferStart;
		subtitle->bufferSize = SUBTITLE_BUFFER_SIZE;
		memset(subtitle->bufferStart,0,subtitle->bufferSize);
		}

	logPrintf("Calling dvd2AviDecodeInit\n");
	dvd2AviDecodeInit(mode);							//After Init we are ready to decode the first frame
	atHeader=true;
	decodeState=0;
	notDone=true;
	logPrintf("Done with readMpeg-Begin\n");
	
	return(true);	
}

// *****************************************************************************
// readMpegClass::setIdct()
//
//  idctType = 1-3. 
// 1 = MMX
// 2 = FPU
// 3 = REFERENCE

// *****************************************************************************
void readMpegClass::setIdct(int idctType)
{
	dvd2AviSetIdct(idctType);
}

// *****************************************************************************
// readMpegClass::setFilm()
//
// *****************************************************************************
void readMpegClass::setFilm(bool film)
{
	dvd2AviSetFilm(film);
}

// *****************************************************************************
// readMpegClass::setAudio()
//
// *****************************************************************************
void readMpegClass::setAudio(bool audio,int channelIndex, int audioType, int audioTrack, int streamCopy)
{
	dvd2AviSetAudio(audio, channelIndex, audioType, audioTrack, streamCopy);
}

// *****************************************************************************
// readMpegClass::setSubtitle()
//
// *****************************************************************************
void readMpegClass::setSubtitle(bool subEnabled,int channelIndex, int subtitleTrack)
{
	dvd2AviSetSubtitle(subEnabled, channelIndex, subtitleTrack);
}

// *****************************************************************************
// readMpegClass::getSubtitleData()
//
// *****************************************************************************
SUBTITLEDATA * readMpegClass::getSubtitleData(int channelIndex)
{
	subtitle = dvd2AviGetSubtitleData(channelIndex);
	return(subtitle);
}


// *****************************************************************************
// readMpegClass::checkEnd()
//
// *****************************************************************************
bool readMpegClass::checkEnd()
{
	int status;
	int stop;
	stop = dvd2AviCheckStopFlag();
	status = dvd2AviGetFaultFlag();

	if(stop || (status >CRITICAL_ERROR))
		return(true);
	else
		return(false);
}

// *****************************************************************************
// readMpegClass::getDimentions()
//
// width = pointer to var that will hold the width
// height = pointer to var that will hold the height
// *****************************************************************************
void readMpegClass::getDimentions(int * width, int * height, double * aspectRatio)
{
	dvd2AviGetDimentions(width, height, aspectRatio);
}

// *****************************************************************************
// readMpegClass::getDimentions()
//
// width = pointer to var that will hold the width
// height = pointer to var that will hold the height
// *****************************************************************************
void readMpegClass::getAudioOutput(int channelIndex, int * outChannels, int * outSampleRate)
{
	// This function isn't supported under MPEG reading, so just return some
	// bogus values
	*outChannels = 0;
	*outSampleRate = 0;
}

// *****************************************************************************
// readMpegClass::getFramerate()
//
// *****************************************************************************
float readMpegClass::getFramerate()
{
	return(dvd2AviGetFramerate());
}


// *****************************************************************************
// readMpegClass::decodeFrame()
//
// width = pointer to var that will hold the width
// height = pointer to var that will hold the height
// *****************************************************************************
int readMpegClass::decodeFrame()
{
	for(;;)
		{
		if(!atHeader&&decodeState==0)
			{
			notDone = dvd2AviGetHeader();
			if(!notDone)
				return(notDone);
			}

		if(!decodeState)
			{
			dvd2AviDecodeFrameBegin();
			}

		decodeState=dvd2AviDecodeFrameMiddle();

		if(!decodeState)
			{
			dvd2AviDecodeFrameEnd();
			atHeader=false;			
			}
		else
			{
			return(notDone);
			}
		}	

}

// *****************************************************************************
// readMpegClass::getFrameData()
//
// *****************************************************************************
FRAMEDATA * readMpegClass::getFrameData()
{
	frame = dvd2AviGetFrameData();
	
	return(frame);
}

// *****************************************************************************
// readMpegClass::getFrameData()
//
// *****************************************************************************
AUDIODATA * readMpegClass::getAudioData(int channelIndex)
{

	audio = dvd2AviGetAudioData(channelIndex);
	return(audio);
}
// *****************************************************************************
// readMpegClass::getHeader()
//
// *****************************************************************************
bool readMpegClass::getHeader()
{
	if(dvd2AviGetHeader())
		return(true);			//to shut VC++ up
	else
		return(false);
}

// *****************************************************************************
// readMpegClass::getNextKeyframe()
//
// Seek to a position in the stream
// *****************************************************************************
long readMpegClass::getNextKeyframe(void)
{
	return(0);
}

// *****************************************************************************
// readMpegClass::getPrevKeyframe()
//
// Seek to a position in the stream
// *****************************************************************************
long readMpegClass::getPrevKeyframe(void)
{
	return(0);
}

// *****************************************************************************
// readMpegClass::seekFramePos()
//
// Seek to a position in the stream
// *****************************************************************************
bool readMpegClass::seekFramePos(long frame)
{
	return(true);
}

// *****************************************************************************
// readMpegClass::getFramePos()
//
// Get our position in the stream
// *****************************************************************************
long readMpegClass::getFramePos()
{
	return(0);
}
// *****************************************************************************
// readMpegClass::getNextKeyframe()
//
// Seek to a position in the stream
// *****************************************************************************
long readMpegClass::getClosestKeyframe(int seekFrame)
{
	return(0);
}

// *****************************************************************************
// readMpegClass::skipFrame()
//
// Get our position in the stream
// *****************************************************************************
int readMpegClass::skipFrame()
{
	return(true);
}

// *****************************************************************************
// readMpegClass::setDecodeMode()
//
// *****************************************************************************
void readMpegClass::setDecodeMode(int mode)
{
	//unused on MPEG reader
}
