// *****************************************************************************
//	Vidomi - Video Encoder
//
//	Copyright (C) 2001 Vidomi, Inc.
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

// *****************************************************************************
// *****************************************************************************
// readmpeg class
// *****************************************************************************
#ifndef readmpeg_h
#define readmpeg_h

#define CRITICAL_ERROR 50
#define MPEG_BLOCK_SIZE 2048

class readMpegClass : public avReadClass
{

	public:
									readMpegClass();
									~readMpegClass();
			void					addInput(char * inputFilename);
			bool					begin(int mode);
			void					setIdct(int idctType);
			void					clearInput();
			bool					init();
			void					end();
			bool					checkEnd();
			int						decodeFrame();

			FRAMEDATA *				getFrameData();
			void					getDimentions(int * width, int * height, double * aspectRatio);
			void					getAudioOutput(int channelIndex, int * outChannels, int * outSampleRate);
			float					getFramerate();
			void					setFilm(bool film);
			AUDIODATA *				getAudioData(int channelIndex);
			void					setAudio(bool audio,int channelIndex, int audioType, int audioTrack, int streamCopy);
			bool					seekPos(__int64 pos);
			__int64					getLength();
			__int64					getCurPos();
			long					getNextKeyframe(void);
			long					getPrevKeyframe(void);
			bool					seekFramePos(long frame);
			long					getFramePos();
			int						skipFrame();
			void					setDecodeMode(int mode);
			long					getClosestKeyframe(int seekFrame);
			SUBTITLEDATA *			getSubtitleData(int channelIndex);
			void					setSubtitle(bool subEnabled,int channelIndex, int subtitleTrack);
			int						getFrameType(void);

	private:
			bool					getHeader();
		
			
			bool					atHeader;
			int						notDone;
			int						decodeState;
			FRAMEDATA *				frame;
			AUDIODATA *				audio;
			SUBTITLEDATA *			subtitle;

			DVD2AVISETIDCT			dvd2AviSetIdct;
			DVD2AVISTARTCONVERSION	dvd2AviStartConversion;
			DVD2AVIGETHEADER		dvd2AviGetHeader;
			DVD2AVIDECODEFRAME		dvd2AviDecodeFrame;
			DVD2AVIDECODEFRAMEBEGIN	dvd2AviDecodeFrameBegin;
			DVD2AVIDECODEFRAMEMIDDLE dvd2AviDecodeFrameMiddle;
			DVD2AVIDECODEFRAMEEND	dvd2AviDecodeFrameEnd;
			DVD2AVICHECKSTOPFLAG	dvd2AviCheckStopFlag;
			DVD2AVISETFAULTFLAG		dvd2AviSetFaultFlag;
			DVD2AVIGETFAULTFLAG		dvd2AviGetFaultFlag;
			DVD2AVIDECODEINIT		dvd2AviDecodeInit;
			DVD2AVIGETFRAMEDATA		dvd2AviGetFrameData;
			DVD2AVIGETDIMENTIONS	dvd2AviGetDimentions;
			DVD2AVIGETFRAMERATE		dvd2AviGetFramerate;
			DVD2AVIGETCPUTYPE		dvd2AviGetCpuType;
			DVD2AVISETFILM			dvd2AviSetFilm;
			DVD2AVIGETAUDIODATA		dvd2AviGetAudioData;
			DVD2AVISETAUDIO			dvd2AviSetAudio;
			DVD2AVICLEANUP			dvd2AviCleanup;
			DVD2AVIADDINPUT			dvd2AviAddInput;
			DVD2AVICLEARINPUT		dvd2AviClearInput;
			DVD2AVIINIT				dvd2AviInit;
			DVD2AVIGETENDPOS		dvd2AviGetEndPos;
			DVD2AVIGETCURPOS		dvd2AviGetCurPos;
			DVD2AVISEEKPOS			dvd2AviSeekPos;
			DVD2AVIGETSUBTITLEDATA	dvd2AviGetSubtitleData;
			DVD2AVISETSUBTITLE		dvd2AviSetSubtitle;
			DVD2AVIGETFRAMETYPE		dvd2AviGetFrameType;
			HINSTANCE				d2aDll;	
			char *					pathToDll;

};



#endif