// *****************************************************************************
//	Vidomi - Video Encoder
//
//	Copyright (C) 2001 Vidomi, Inc.
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

// *****************************************************************************
// *****************************************************************************
// scanmpeg class
// *****************************************************************************
#ifndef scanfile_h
#define scanfile_h


#define SCANMPEG_BUFFER_SIZE 256
#define SHREDMPEG_BUFFER_SIZE 64000


#define CHROMA420 1
#define CHROMA422 2
#define CHROMA444 3
#define CHROMARGB32 4

#define SCAN_FILE_TYPE_AVI 0
#define SCAN_FILE_TYPE_MPEG 1

#define MPEG_MODE_MONO 0x02

typedef struct {
	char r;
	char g;
	char b;
	char a;
} RGBAPIXEL;

class scanFileClass 
{

	public:
									scanFileClass();
									~scanFileClass();
		bool						scanFile(char * filename, int scanSize, bool useInfoFile,GATHERRESULTS * fileInfo);
		bool						scanCropRect(CONVERTCONFIG * settings, bool prompt);
		bool						determineRangeSize(CONVERTCONFIG * convertConfig);


	private:
		bool						setPos(long Pos);
		unsigned long				getBits(int numBits);
		unsigned long				peekBits(int numBits);
		void						alignFrame(void);
		void						flushBits(int numBits);
		bool						scanMpeg(char * filename, int scanSize, bool useInfoFile, GATHERRESULTS * fileInfo);
		bool						scanAvi(char * filename, GATHERRESULTS * fileInfo);

		unsigned char *				readBuffer;
		unsigned char *				shredBuffer;
		int							inFile;
		long						inFileSize;
		int							bitsRemaining;
		long						bufferPos;
		long						bufferStart;
		long						bufferEnd;
		bool						reachedEnd;
		int							audioAc3Found[16];
		int							audioAc3Rate[16];
		int							audioAc3Channels[16];
		int							audioAc3SourceChannels[16];
		int							audioMpegFound[16];
		int							audioMpegRate[16];
		int							audioMpegChannels[16];
		int							audioPcmFound[16];
		int							audioPcmRate[16];
		int							audioPcmChannels[16];
		int							subtitleFound[16];

};


#endif