// *****************************************************************************
//	Vidomi - Video Encoder
//
//	Copyright (C) 2001 Vidomi, Inc.
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

// *****************************************************************************
// *****************************************************************************
//
//
// selectrange.cpp
// 
//
// *****************************************************************************

#include "en.h"
/*#include "AudioPlayback.h"*/

#define BUFFER_COUNT 2
#define BUFFER_SIZE  0x10000

void checkpts(int vpts,int apts,char type,char flg);

// Global static module variables
static unsigned char buffers[BUFFER_COUNT][BUFFER_SIZE],cabuf,playsound;
static WAVEHDR  wav_hdr[BUFFER_COUNT];
static int audiosamplerate;
static char audiofound;


#define MINXSIZE 720
#define KEYDNMASK 0x8000

#define THREADCMD(A) EnterCriticalSection(&selectLock);selectCommand=A;LeaveCriticalSection(&selectLock);SetFocus(selectRangehWnd);return(true);

extern GLOBALS * globals;
short rangemark=0;

short mxpos,mypos;
char cutflg;

//extern char pstr1[128],pstr2[128],showpts;
// param vars for diagnostic display
char pstr1[128],pstr2[128],showpts;

unsigned short tframe,frame_event;
volatile char tfflag;
void CALLBACK lpTimeProc(UINT uTimerID, UINT uMsg, DWORD dwUser, DWORD dw1, DWORD dw2);


// *****************************************************************************
// selectRangeClass::selectRangeClass()
//
// selectRange class constructor
// *****************************************************************************
selectRangeClass::selectRangeClass()
{
	selectCommand = selectCommandNoOp;
	selectStatus = selectStatusOk;
	selectState = selectStateIdle;
	font = NULL;
}

// *****************************************************************************
// selectRangeClass::~selectRangeClass()
//
// selectRange class destructor
// *****************************************************************************
selectRangeClass::~selectRangeClass()
{

}

// *****************************************************************************
// selectRangeClass::bringUpSelectRange()
//
// Bring up the selectRange screen
// *****************************************************************************
bool selectRangeClass::bringUpSelectRange(HINSTANCE hInst, CONVERTCONFIG * convertConfig)
{
	int count;

	settings = convertConfig;

	font = CreateFont(8, 0, 0, 0, FW_DONTCARE, FALSE, FALSE, FALSE, DEFAULT_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE, "MS Sans Serif");
	iconSetStart = (HICON) LoadImage(globals->hInst,MAKEINTRESOURCE(VidomiIconSetStart),IMAGE_ICON ,0,0,0);
	iconSetEnd = (HICON) LoadImage(globals->hInst,MAKEINTRESOURCE(VidomiIconSetEnd),IMAGE_ICON ,0,0,0);
	iconFrameAdvance = (HICON) LoadImage(globals->hInst,MAKEINTRESOURCE(VidomiIconFrameAdvance),IMAGE_ICON ,0,0,0);
	iconGoFirst = (HICON) LoadImage(globals->hInst,MAKEINTRESOURCE(VidomiIconGoFirst),IMAGE_ICON ,0,0,0);
	iconGoLast = (HICON) LoadImage(globals->hInst,MAKEINTRESOURCE(VidomiIconGoLast),IMAGE_ICON ,0,0,0);
	iconGoStart = (HICON) LoadImage(globals->hInst,MAKEINTRESOURCE(VidomiIconGoStart),IMAGE_ICON ,0,0,0);
	iconGoEnd = (HICON) LoadImage(globals->hInst,MAKEINTRESOURCE(VidomiIconGoEnd),IMAGE_ICON ,0,0,0);
	iconGoPrev = (HICON) LoadImage(globals->hInst,MAKEINTRESOURCE(VidomiIconGoPrev),IMAGE_ICON ,0,0,0);
	iconGoNext = (HICON) LoadImage(globals->hInst,MAKEINTRESOURCE(VidomiIconGoNext),IMAGE_ICON ,0,0,0);
	iconGoPrevFRame = (HICON) LoadImage(globals->hInst,MAKEINTRESOURCE(VidomiIconPrevFRame),IMAGE_ICON ,0,0,0);
	iconGoPlay = (HICON) LoadImage(globals->hInst,MAKEINTRESOURCE(VidomiIconPlay),IMAGE_ICON ,0,0,0);
	iconGoStop = (HICON) LoadImage(globals->hInst,MAKEINTRESOURCE(VidomiIconStop),IMAGE_ICON ,0,0,0);

  
	registerWindowClass(globals->hInst,"VidomiRangeWindow");
	
	selectRangehWnd = CreateWindowEx(0, "VidomiRangeWindow", "Vidomi Range", WS_BORDER | WS_CHILD,
							0, 0, 
							200, 200, globals->outputVideo->outputhWnd, NULL, globals->hInst, NULL );

    SetFocus(selectRangehWnd);
    
// reset rangelist
    rangemark=0;
    playing=0;
    showpts=0;
   audiofound=globals->gatherResults->audioFound;
    audiosamplerate=globals->gatherResults->audioRate[0];
    
    
    if (!settings->rangelist[0].valid) {
     for (count=0; count<MAX_RANGES; count++) {
      settings->rangelist[count].startingFilePos=0;
      settings->rangelist[count].startingFileFrame=0;
      settings->rangelist[count].endingFilePos = 0x7fffffffffffffff;
      settings->rangelist[count].endingFileFrame=0;
      settings->rangelist[count].valid=0;
     }
    }
    else {
      settings->startingFilePos=settings->rangelist[0].startingFilePos;
      settings->startingFileFrame=settings->rangelist[0].startingFileFrame;
      settings->endingFilePos=settings->rangelist[0].endingFilePos;
      settings->endingFileFrame=settings->rangelist[0].endingFileFrame;
	}
    settings->rangelist[0].valid=1;

	selectCommand = selectCommandNoOp;
	selectStatus = selectStatusOk;
	selectState = selectStateIdle;
	InitializeCriticalSection(&selectLock);
	//Create the video update thread
	threadHandle = CreateThread(NULL,0,	selectRangeThread ,(LPVOID)this , 0 ,&threadId);
	
	return(true);
}

// *****************************************************************************
// selectRangeClass::registerWindowClass()
//
//
// *****************************************************************************
bool selectRangeClass::registerWindowClass(HINSTANCE hInst,char * className)
{
	//Main Window
	windCls.style         = CS_HREDRAW | CS_VREDRAW;
    windCls.lpfnWndProc   = (WNDPROC)selectRangeMessageHandler;
    windCls.cbClsExtra    = 0;
    windCls.cbWndExtra    = 0;
    windCls.hInstance     = hInst;          
    windCls.hIcon         = NULL;
    windCls.hCursor       = LoadCursor(hInst, IDC_ARROW);
    windCls.hbrBackground = HBRUSH(COLOR_BTNFACE+1);
    windCls.lpszMenuName  = NULL; 
	windCls.lpszClassName = className;
	
    if (!RegisterClass( &windCls))
		{
		logPrintf("Failed To create window Class\n");
        return FALSE;
		}

	return TRUE;
}

// *****************************************************************************
// selectRangeClass::selectRangeMessageHandler()
//
//
// *****************************************************************************
BOOL CALLBACK selectRangeClass::selectRangeMessageHandler(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
   
    return(globals->selectRange->selectRangeMessageHandler1(hWnd,message,wParam,lParam));
    
}


// *****************************************************************************
// selectRangeClass::optionsDialogHandler1()
//
//
// *****************************************************************************
BOOL selectRangeClass::selectRangeMessageHandler1(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	unsigned short commandId;
	unsigned short commandEvent;
	RECT screenSize;
	HWND temphWnd;
	int width;
	int height;
	int pos;
	int posX;
	int posY;
	char text[4096];

    
	switch (message)
		{
				
	   case WM_KILLFOCUS:
	   /* if (hWnd==GetParent((HWND)wParam)) {  doesnt work, had to put setfocus after each command !!! 
	     SetFocus(hWnd);
	    }*/
	    return(true);

	   case WM_SETFOCUS:
	    return(true);

	   
       case WM_CHAR:
  // handle keys
                switch ((char)wParam) {
                    case '<':
                    case 's':
                    case 'a':
                    // set start
                        SendMessage(hWnd,WM_COMMAND,VidomiSelectRangeSetStart,0);
			            return (true);
                    case '>':
                    case 'e':
                   // set end
                        SendMessage(hWnd,WM_COMMAND,VidomiSelectRangeSetEnd,0);
			            return (true);
			        case 'x':
			            showpts=!showpts;
			            return (true);
			        case 't':
			            THREADCMD(selectCommandTestAV)
			            return (true);
			            
			     }
			     return (true);
			     
        case WM_KEYDOWN:
        case WM_SYSKEYDOWN:
                switch (wParam) {
                    case VK_LEFT:
                    // left one frame
                        SendMessage(hWnd,WM_COMMAND,VidomiSelectRangeGoPrev,0);
			            return (true);
                    case VK_RIGHT:
                    // right one frame
                        SendMessage(hWnd,WM_COMMAND,VidomiSelectRangeGoNext,0);
			            return (true);
                    case ' ':
                    // play, stop
                        SendMessage(hWnd,WM_COMMAND,VidomiSelectRangeFrameAdvance,0);
			            return (true);
                    case VK_UP:
                    // next cut
                        SendMessage(hWnd,WM_COMMAND,VidomiSelectRangeMarkp,0);
			            return (true);
                    case VK_DOWN:
                    // prev cut
                        SendMessage(hWnd,WM_COMMAND,VidomiSelectRangeMarkm,0);
			            return (true);
			        case VK_DELETE:
			        // delete one cut    
                        SendMessage(hWnd,WM_COMMAND,VidomiSelectRangeClear,0);
			            return (true);
			        case VK_INSERT:
			        // insert one cut    
				        EnterCriticalSection(&selectLock);
				        selectCommand = selectCommandRangeInsert;
				        LeaveCriticalSection(&selectLock);
			            return (true);
			        case VK_TAB:
			        // tab to next mark start or end   
				        EnterCriticalSection(&selectLock);
				        selectCommand = selectCommandRangeTab;
				        LeaveCriticalSection(&selectLock);
			            return (true);
                }
                return(true);
                break;
            
       case WM_KEYUP:
       case WM_SYSKEYUP:
            return (false);
               
		case WM_SHOWWINDOW :
			if (wParam)
				{
				GetWindowRect(hWnd,&screenSize);
				width = screenSize.right - screenSize.left;
				height = screenSize.bottom - screenSize.top;
				// Done always is in right corner

				globals->translate->translate(text, "VidomiRangeDone");

				temphWnd = CreateWindowEx(0, "BUTTON", text, BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE, 
								width-64, SELECT_RANGE_PANEL_SIZE-32, 
								55, 26, selectRangehWnd, (HMENU)VidomiSelectRangeDoneButton, globals->hInst, NULL );

				SendMessage(temphWnd, WM_SETFONT, (WPARAM)font, (LPARAM)0 );

				globals->translate->translate(text, "VidomiRangeStartPosition");
				temphWnd = CreateWindowEx(0, "STATIC", text, WS_CHILD | WS_VISIBLE | SS_CENTER, 
								0, SELECT_RANGE_PANEL_SIZE-70, 
								95, 15, selectRangehWnd, (HMENU)VidomiSelectRangeTextStatic, globals->hInst, NULL );

				SendMessage(temphWnd, WM_SETFONT, (WPARAM)font, (LPARAM)0 );

				temphWnd = CreateWindowEx(0, "STATIC", "0000000000+0000", WS_CHILD | WS_VISIBLE | SS_CENTER, 
								0, SELECT_RANGE_PANEL_SIZE-55, 
								95, 15, selectRangehWnd, (HMENU)VidomiSelectRangeStartByteText, globals->hInst, NULL );

				SendMessage(temphWnd, WM_SETFONT, (WPARAM)font, (LPARAM)0 );

				globals->translate->translate(text, "VidomiRangeEndPosition");

				temphWnd = CreateWindowEx(0, "STATIC", text, WS_CHILD | WS_VISIBLE | SS_CENTER, 
								width-95, SELECT_RANGE_PANEL_SIZE-70, 
								95, 15, selectRangehWnd, (HMENU)VidomiSelectRangeTextStatic, globals->hInst, NULL );

				SendMessage(temphWnd, WM_SETFONT, (WPARAM)font, (LPARAM)0 );

				temphWnd = CreateWindowEx(0, "STATIC", "0000000000+0000", WS_CHILD | WS_VISIBLE | SS_CENTER, 
								width-95, SELECT_RANGE_PANEL_SIZE-55, 
								95, 15, selectRangehWnd, (HMENU)VidomiSelectRangeEndByteText, globals->hInst, NULL );

				SendMessage(temphWnd, WM_SETFONT, (WPARAM)font, (LPARAM)0 );

				globals->translate->translate(text, "VidomiRangeSelected");
				strcat(text," 0000000000");

				temphWnd = CreateWindowEx(0, "STATIC", text,  WS_CHILD | WS_VISIBLE | SS_CENTER, 
								0, SELECT_RANGE_PANEL_SIZE-35, 
								120, 17, selectRangehWnd, (HMENU)VidomiSelectRangeTotalSelectedByteText, globals->hInst, NULL );
				SendMessage(temphWnd, WM_SETFONT, (WPARAM)font, (LPARAM)0 );

				globals->translate->translate(text, "VidomiRangeTotal");
				strcat(text," 32 - 00:00:00");

				temphWnd = CreateWindowEx(0, "BUTTON", text, BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE | SS_CENTER, 
								0, SELECT_RANGE_PANEL_SIZE-17, 
								120, 17, selectRangehWnd, (HMENU)VidomiSelectRangeTotalTimeText, globals->hInst, NULL );
				SendMessage(temphWnd, WM_SETFONT, (WPARAM)font, (LPARAM)0 );

#define PREVNEXT 1

#if PREVNEXT
#define XOFFSET 140
#else
#define XOFFSET 120
#endif

				posX = ((width - BUTTON_PANEL_WIDTH) /2 )-XOFFSET;
				posY = SELECT_RANGE_PANEL_SIZE-37;

				// Set Start Button
				temphWnd = CreateWindowEx(0, "BUTTON", NULL , BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE | BS_ICON, 
								posX, posY-28, 
								BUTTON_SET_START_WIDTH, 26, selectRangehWnd, (HMENU)VidomiSelectRangeSetStart, globals->hInst, NULL );
				SendMessage(temphWnd, BM_SETIMAGE, IMAGE_ICON, (LPARAM)iconSetStart);
				posX+=BUTTON_SET_START_WIDTH+BUTTON_BORDER_SIZE;

				// Go Start Button
				temphWnd = CreateWindowEx(0, "BUTTON", NULL , BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE | BS_ICON, 
								posX, posY, 
								BUTTON_GO_START_WIDTH, 26, selectRangehWnd, (HMENU)VidomiSelectRangeGoStart, globals->hInst, NULL );
				SendMessage(temphWnd, BM_SETIMAGE, IMAGE_ICON, (LPARAM)iconGoStart);
				posX+=BUTTON_GO_START_WIDTH+BUTTON_BORDER_SIZE;

				// Go First Button
				temphWnd = CreateWindowEx(0, "BUTTON", NULL , BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE | BS_ICON, 
								posX, posY, 
								BUTTON_GO_FIRST_WIDTH, 26, selectRangehWnd, (HMENU)VidomiSelectRangeGoFirst, globals->hInst, NULL );
				SendMessage(temphWnd, BM_SETIMAGE, IMAGE_ICON, (LPARAM)iconGoFirst);
				posX+=BUTTON_GO_FIRST_WIDTH+BUTTON_BORDER_SIZE;


#if PREVNEXT
				// Go Prev Button
				temphWnd = CreateWindowEx(0, "BUTTON", NULL , BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE | BS_ICON, 
								posX, posY, 
								BUTTON_GO_PREV_WIDTH, 26, selectRangehWnd, (HMENU)VidomiSelectRangeGoPrev, globals->hInst, NULL );
				SendMessage(temphWnd, BM_SETIMAGE, IMAGE_ICON, (LPARAM)iconGoPrev);
				posX+=BUTTON_GO_PREV_WIDTH+BUTTON_BORDER_SIZE;
#endif

				// Play/Stop Button
				temphWnd = CreateWindowEx(0, "BUTTON", NULL, BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE | BS_ICON, 
								posX, posY, 
								BUTTON_FRAME_ADVANCE_WIDTH, 26, selectRangehWnd, (HMENU)VidomiSelectRangeFrameAdvance, globals->hInst, NULL );
				SendMessage(temphWnd, BM_SETIMAGE, IMAGE_ICON, (LPARAM)iconGoPlay);
				PlayWnd=temphWnd;
				posX+=BUTTON_FRAME_ADVANCE_WIDTH+BUTTON_BORDER_SIZE;

				globals->translate->translate(text, "VidomiRangeCurrentPosition");

				temphWnd = CreateWindowEx(0, "STATIC", text, WS_CHILD | WS_VISIBLE | SS_CENTER, 
								posX-60, SELECT_RANGE_PANEL_SIZE-70, 
								95, 15, selectRangehWnd, (HMENU)VidomiSelectRangeTextStatic, globals->hInst, NULL );
				SendMessage(temphWnd, WM_SETFONT, (WPARAM)font, (LPARAM)0 );

				temphWnd = CreateWindowEx(0, "STATIC", "0+0", WS_CHILD | WS_VISIBLE | SS_CENTER, 
								posX-60, SELECT_RANGE_PANEL_SIZE-55, 
								95, 15, selectRangehWnd, (HMENU)VidomiSelectRangeCurrentByteText, globals->hInst, NULL );
				SendMessage(temphWnd, WM_SETFONT, (WPARAM)font, (LPARAM)0 );



#if PREVNEXT
				// Frame Advance Button
				// Go Next Button
				temphWnd = CreateWindowEx(0, "BUTTON", NULL , BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE | BS_ICON, 
								posX, posY, 
								BUTTON_GO_NEXT_WIDTH, 26, selectRangehWnd, (HMENU)VidomiSelectRangeGoNext, globals->hInst, NULL );
				SendMessage(temphWnd, BM_SETIMAGE, IMAGE_ICON, (LPARAM)iconFrameAdvance);
				posX+=BUTTON_GO_NEXT_WIDTH+BUTTON_BORDER_SIZE;
#endif

				// Go Last Button
				temphWnd = CreateWindowEx(0, "BUTTON", NULL , BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE | BS_ICON, 
								posX, posY, 
								BUTTON_GO_LAST_WIDTH, 26, selectRangehWnd, (HMENU)VidomiSelectRangeGoLast, globals->hInst, NULL );
				SendMessage(temphWnd, BM_SETIMAGE, IMAGE_ICON, (LPARAM)iconGoLast);
				posX+=BUTTON_GO_LAST_WIDTH+BUTTON_BORDER_SIZE;

				// Go End Button
				temphWnd = CreateWindowEx(0, "BUTTON", NULL , BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE | BS_ICON, 
								posX, posY, 
								BUTTON_GO_END_WIDTH, 26, selectRangehWnd, (HMENU)VidomiSelectRangeGoEnd, globals->hInst, NULL );
				SendMessage(temphWnd, BM_SETIMAGE, IMAGE_ICON, (LPARAM)iconGoEnd);
				posX+=BUTTON_GO_END_WIDTH+BUTTON_BORDER_SIZE;


				// Set End Button
				temphWnd = CreateWindowEx(0, "BUTTON", NULL, BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE | BS_ICON, 
								posX, posY-28, 
								BUTTON_SET_END_WIDTH, 26, selectRangehWnd, (HMENU)VidomiSelectRangeSetEnd, globals->hInst, NULL );
				SendMessage(temphWnd, BM_SETIMAGE, IMAGE_ICON, (LPARAM)iconSetEnd);
				posX+=BUTTON_SET_END_WIDTH+BUTTON_BORDER_SIZE;

				
#define TEXTBUTTONSIZE 42
#define TEXTBUTTONSIZESPACE 3
#define TEXTBUTTONYSIZ 15
                posY-=2;

				// Set cur number Buttons
				temphWnd = CreateWindowEx(0, "STATIC", "000", WS_CHILD | WS_VISIBLE | SS_CENTER, 
								posX, posY-18, 
								TEXTBUTTONSIZE, 17, selectRangehWnd, (HMENU)ShowMark, globals->hInst, NULL );
				SendMessage(temphWnd, WM_SETFONT, (WPARAM)font, (LPARAM)0 );

				globals->translate->translate(text, "VidomiRangeCutNumberAdd");

				temphWnd = CreateWindowEx(0, "BUTTON", text, BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE,
								posX, posY, 
								TEXTBUTTONSIZE, TEXTBUTTONYSIZ, selectRangehWnd, (HMENU)VidomiSelectRangeMarkp, globals->hInst, NULL );
				SendMessage(temphWnd, WM_SETFONT, (WPARAM)font, (LPARAM)0 );

				globals->translate->translate(text, "VidomiRangeCutNumberSub");

				temphWnd = CreateWindowEx(0, "BUTTON", text, BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE,
								posX, posY+19, 
								TEXTBUTTONSIZE, TEXTBUTTONYSIZ, selectRangehWnd, (HMENU)VidomiSelectRangeMarkm, globals->hInst, NULL );
				SendMessage(temphWnd, WM_SETFONT, (WPARAM)font, (LPARAM)0 );
				posX+=TEXTBUTTONSIZE+TEXTBUTTONSIZESPACE;

                // sound checkbox
				//globals->translate->translate(text, "VidomiRangeSound");
				//temphWnd = CreateWindowEx(0, "BUTTON", text, BS_AUTOCHECKBOX | WS_CHILD | WS_VISIBLE,
				//				posX, posY-30, 
				//				TEXTBUTTONSIZE+20, TEXTBUTTONYSIZ, selectRangehWnd, (HMENU)VidomiSelectSound, globals->hInst, NULL );
				//SendMessage(temphWnd, WM_SETFONT, (WPARAM)font, (LPARAM)0 );
	            //if (playsound)
		        //  SendDlgItemMessage(temphWnd,VidomiSelectSound,BM_SETCHECK , (WPARAM)BST_CHECKED, (LPARAM)  0);
	            //else
		        //    SendDlgItemMessage(temphWnd,VidomiSelectSound,BM_SETCHECK , (WPARAM)BST_UNCHECKED, (LPARAM)  0);

				globals->translate->translate(text, "VidomiRangeCutNumberClearCurrent");

				temphWnd = CreateWindowEx(0, "BUTTON", text, BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE,
								posX, posY, 
								TEXTBUTTONSIZE, TEXTBUTTONYSIZ, selectRangehWnd, (HMENU)VidomiSelectRangeClear, globals->hInst, NULL );
				SendMessage(temphWnd, WM_SETFONT, (WPARAM)font, (LPARAM)0 );

				globals->translate->translate(text, "VidomiRangeCutNumberClearAll");
				temphWnd = CreateWindowEx(0, "BUTTON", text, BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE,
								posX, posY+19, 
								TEXTBUTTONSIZE, TEXTBUTTONYSIZ, selectRangehWnd, (HMENU)VidomiSelectRangeReset, globals->hInst, NULL );
				SendMessage(temphWnd, WM_SETFONT, (WPARAM)font, (LPARAM)0 );
				posX+=TEXTBUTTONSIZE+TEXTBUTTONSIZESPACE;



                // show cropped resolution
				temphWnd = CreateWindowEx(0, "STATIC", "720 * 576", WS_CHILD | WS_VISIBLE | SS_CENTER, 
								posX+60, posY-34, 
								TEXTBUTTONSIZE+20, 17, selectRangehWnd, (HMENU)ShowCropRes, globals->hInst, NULL );
				SendMessage(temphWnd, WM_SETFONT, (WPARAM)font, (LPARAM)0 );


				// Set crop Buttons
				temphWnd = CreateWindowEx(0, "STATIC", "000", WS_CHILD | WS_VISIBLE | SS_CENTER, 
								posX, posY-18, 
								TEXTBUTTONSIZE, 17, selectRangehWnd, (HMENU)ShowCropTop, globals->hInst, NULL );
				SendMessage(temphWnd, WM_SETFONT, (WPARAM)font, (LPARAM)0 );

				globals->translate->translate(text, "VidomiRangeCropTopAdd");
				
				temphWnd = CreateWindowEx(0, "BUTTON", text, BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE,
								posX, posY, 
								TEXTBUTTONSIZE, TEXTBUTTONYSIZ, selectRangehWnd, (HMENU)VidomiSelectRangeCropTopp, globals->hInst, NULL );
				SendMessage(temphWnd, WM_SETFONT, (WPARAM)font, (LPARAM)0 );

				globals->translate->translate(text, "VidomiRangeCropTopSub");
				
				temphWnd = CreateWindowEx(0, "BUTTON", text, BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE,
								posX, posY+19, 
								TEXTBUTTONSIZE, TEXTBUTTONYSIZ, selectRangehWnd, (HMENU)VidomiSelectRangeCropTopm, globals->hInst, NULL );
				SendMessage(temphWnd, WM_SETFONT, (WPARAM)font, (LPARAM)0 );

				posX+=TEXTBUTTONSIZE+TEXTBUTTONSIZESPACE;



				// Set crop Buttons
				temphWnd = CreateWindowEx(0, "STATIC", "000", WS_CHILD | WS_VISIBLE | SS_CENTER, 
								posX, posY-18, 
								TEXTBUTTONSIZE, 17, selectRangehWnd, (HMENU)ShowCropBottom, globals->hInst, NULL );
				SendMessage(temphWnd, WM_SETFONT, (WPARAM)font, (LPARAM)0 );

				globals->translate->translate(text, "VidomiRangeCropBotAdd");

				temphWnd = CreateWindowEx(0, "BUTTON", text, BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE, 
								posX, posY, 
								TEXTBUTTONSIZE, TEXTBUTTONYSIZ, selectRangehWnd, (HMENU)VidomiSelectRangeCropBottomp, globals->hInst, NULL );
				SendMessage(temphWnd, WM_SETFONT, (WPARAM)font, (LPARAM)0 );

				globals->translate->translate(text, "VidomiRangeCropBotSub");
				temphWnd = CreateWindowEx(0, "BUTTON", text, BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE,
								posX, posY+19, 
								TEXTBUTTONSIZE, TEXTBUTTONYSIZ, selectRangehWnd, (HMENU)VidomiSelectRangeCropBottomm, globals->hInst, NULL );
				SendMessage(temphWnd, WM_SETFONT, (WPARAM)font, (LPARAM)0 );
				posX+=TEXTBUTTONSIZE+TEXTBUTTONSIZESPACE;

				// Set crop Buttons
				temphWnd = CreateWindowEx(0, "STATIC", "000", WS_CHILD | WS_VISIBLE | SS_CENTER, 
								posX, posY-18, 
								TEXTBUTTONSIZE, 17, selectRangehWnd, (HMENU)ShowCropLeft, globals->hInst, NULL );
				SendMessage(temphWnd, WM_SETFONT, (WPARAM)font, (LPARAM)0 );

				globals->translate->translate(text, "VidomiRangeCropLeftAdd");

				temphWnd = CreateWindowEx(0, "BUTTON", text, BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE,
								posX, posY, 
								TEXTBUTTONSIZE, TEXTBUTTONYSIZ, selectRangehWnd, (HMENU)VidomiSelectRangeCropLeftp, globals->hInst, NULL );
				SendMessage(temphWnd, WM_SETFONT, (WPARAM)font, (LPARAM)0 );

				globals->translate->translate(text, "VidomiRangeCropLeftSub");
				temphWnd = CreateWindowEx(0, "BUTTON", text, BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE,
								posX, posY+19, 
								TEXTBUTTONSIZE, TEXTBUTTONYSIZ, selectRangehWnd, (HMENU)VidomiSelectRangeCropLeftm, globals->hInst, NULL );
				SendMessage(temphWnd, WM_SETFONT, (WPARAM)font, (LPARAM)0 );
				posX+=TEXTBUTTONSIZE+TEXTBUTTONSIZESPACE;
				
				// Set crop Buttons
				temphWnd = CreateWindowEx(0, "STATIC", "000", WS_CHILD | WS_VISIBLE | SS_CENTER, 
								posX, posY-18, 
								TEXTBUTTONSIZE, 17, selectRangehWnd, (HMENU)ShowCropRight, globals->hInst, NULL );
				SendMessage(temphWnd, WM_SETFONT, (WPARAM)font, (LPARAM)0 );

				globals->translate->translate(text, "VidomiRangeCropRightAdd");

				temphWnd = CreateWindowEx(0, "BUTTON", text, BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE,
								posX, posY, 
								TEXTBUTTONSIZE, TEXTBUTTONYSIZ, selectRangehWnd, (HMENU)VidomiSelectRangeCropRightp, globals->hInst, NULL );
				SendMessage(temphWnd, WM_SETFONT, (WPARAM)font, (LPARAM)0 );

				globals->translate->translate(text, "VidomiRangeCropRightSub");
				temphWnd = CreateWindowEx(0, "BUTTON", text, BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE,
								posX, posY+19, 
								TEXTBUTTONSIZE, TEXTBUTTONYSIZ, selectRangehWnd, (HMENU)VidomiSelectRangeCropRightm, globals->hInst, NULL );
				SendMessage(temphWnd, WM_SETFONT, (WPARAM)font, (LPARAM)0 );
				posX+=TEXTBUTTONSIZE+TEXTBUTTONSIZESPACE;



				// Position Slider
				sliderRange = width;
				temphWnd = CreateWindowEx(0,TRACKBAR_CLASS,NULL,WS_CHILD|WS_VISIBLE|TBS_AUTOTICKS|TBS_ENABLESELRANGE,
								0,0,width,23,selectRangehWnd, (HMENU)VidomiSelectRangeSlider, globals->hInst, NULL);
				SendMessage(temphWnd,TBM_SETRANGEMIN ,(WPARAM) TRUE,(LPARAM) 0);
				SendMessage(temphWnd,TBM_SETRANGEMAX ,(WPARAM) TRUE,(LPARAM) sliderRange);
	
				EnterCriticalSection(&selectLock);
				selectCommand = selectCommandInitSlider;
				LeaveCriticalSection(&selectLock);
				}
			return(true);

		case WM_MOUSEWHEEL:
            EnterCriticalSection(&selectLock);
            pos = SendMessage(GetDlgItem(selectRangehWnd,VidomiSelectRangeSlider),TBM_GETPOS,(WPARAM) 0,(LPARAM) 0);

            if (GetAsyncKeyState(VK_SHIFT)&KEYDNMASK) 
				{
                // fast move
				pos+=(short)(HIWORD(wParam));
				}
            else 
				{
                // slow move
				pos+=(short)(HIWORD(wParam))/VIDOMI_WHEEL_DELTA;
				}

			SendMessage(GetDlgItem(selectRangehWnd,VidomiSelectRangeSlider),TBM_SETPOS,TRUE,(LPARAM) pos);
			selectCommand = selectCommandSeek;
			selectData = pos;
            LeaveCriticalSection(&selectLock);
            SetFocus(selectRangehWnd);
            return(true);


		case WM_HSCROLL:
			switch(LOWORD(wParam))
				{	
				case SB_THUMBTRACK :
				case SB_THUMBPOSITION :
					EnterCriticalSection(&selectLock);
					selectCommand = selectCommandSeek;
					selectData = HIWORD(wParam);
					LeaveCriticalSection(&selectLock);
					break;
				case SB_PAGELEFT :
				case SB_PAGERIGHT :
					pos = SendMessage((HWND) lParam,TBM_GETPOS ,(WPARAM) 0,(LPARAM) 0);
					EnterCriticalSection(&selectLock);
					selectCommand = selectCommandSeek;
					selectData = pos;
					LeaveCriticalSection(&selectLock);
					break;					
				default:
					break;
				}
		    SetFocus(selectRangehWnd);
			return(true);

		case WM_COMMAND:
			commandId   = LOWORD(wParam); // Remember, these are...
			commandEvent = HIWORD(wParam); // ...different for Win32!

			//Parse the menu selections:
			if (playing && commandId!=VidomiSelectRangeFrameAdvance) {
			// ignore cmds while playing
			    //MessageBeep(MB_OK);
			    return(true);
			}
			switch (commandId) 
				{

                case VidomiSelectMouseclick :
                    mxpos=LOWORD(lParam);
                    mypos=HIWORD(lParam);
	                THREADCMD(selectCommandselpic)

				case VidomiSelectRangeDoneButton :
				    THREADCMD(selectCommandDie)

				case VidomiSelectRangeSetStart :
				    THREADCMD(selectCommandSetStart)

				case VidomiSelectRangeSetEnd :
				    THREADCMD(selectCommandSetEnd)
				
				case VidomiSelectRangeGoFirst :
					SendMessage(GetDlgItem(selectRangehWnd,VidomiSelectRangeSlider),TBM_SETPOS ,TRUE,(LPARAM) 0);
					EnterCriticalSection(&selectLock);
					selectCommand = selectCommandSeek;
					selectData = 0;
					LeaveCriticalSection(&selectLock);
					SetFocus(selectRangehWnd);
					return(true);
					
				case VidomiSelectRangeGoLast :
					SendMessage(GetDlgItem(selectRangehWnd,VidomiSelectRangeSlider),TBM_SETPOS ,TRUE,(LPARAM) sliderRange);
					EnterCriticalSection(&selectLock);
					selectCommand = selectCommandSeek;
					selectData = sliderRange;
					LeaveCriticalSection(&selectLock);
					SetFocus(selectRangehWnd);
					return(true);
					
				case VidomiSelectRangeGoStart :
				    THREADCMD(selectCommandGoStart)
				case VidomiSelectRangeGoEnd :
				    THREADCMD(selectCommandGoEnd)

// go  prev				
				case VidomiSelectRangeGoPrev :
					  playing=3;
				    THREADCMD(selectCommandGoPrev)

// is play stop now
				case VidomiSelectRangeFrameAdvance :
			    	if (playing) {
			    	// stop, should change icon 
						EnterCriticalSection(&selectLock);
			     		playing=0;
						LeaveCriticalSection(&selectLock);
						SetFocus(selectRangehWnd);
			     		return(true);
			    	}
			    	else {
			    	// play
						EnterCriticalSection(&selectLock);
						playing=3;
   			    	    SendMessage(PlayWnd, BM_SETIMAGE, IMAGE_ICON, (LPARAM)iconGoStop);
                        selectCommand =selectCommandPlay;
						LeaveCriticalSection(&selectLock);
						SetFocus(selectRangehWnd);
			     		return(true);
			    	}

// is frame advance now
				case VidomiSelectRangeGoNext :
					    playing=3;
				    THREADCMD(selectCommandFrameAdvance)

// done
				case VidomiSelectRangeTerminate :
                    // remember last window position 
                    GetWindowRect(globals->outputVideo->outputhWnd,&screenSize);
                    //settings->oleft=screenSize.left;
                    //settings->otop=screenSize.top;
 					DestroyWindow(selectRangehWnd);
					return(true);

// sound
				//case VidomiSelectSound:
				//	if (SendDlgItemMessage(hWnd,VidomiSelectSound,BM_GETCHECK , (WPARAM)BST_UNCHECKED, (LPARAM)  0)==BST_CHECKED)
				//		playsound = true;
				//	else
				//		playsound = false;
				//	SetFocus(selectRangehWnd);
				//	return(true);


				case VidomiSelectRangeCropLeftp :
				    THREADCMD(selectCommandCropLeftp)
				case VidomiSelectRangeCropRightp :
				    THREADCMD(selectCommandCropRightp)
				case VidomiSelectRangeCropTopp :
				    THREADCMD(selectCommandCropTopp)
				case VidomiSelectRangeCropBottomp :
				    THREADCMD(selectCommandCropBottomp)
				case VidomiSelectRangeCropLeftm :
				    THREADCMD(selectCommandCropLeftm)
				case VidomiSelectRangeCropRightm :
				    THREADCMD(selectCommandCropRightm)
				case VidomiSelectRangeCropTopm :
				    THREADCMD(selectCommandCropTopm)
				case VidomiSelectRangeCropBottomm :
				    THREADCMD(selectCommandCropBottomm)
				case VidomiSelectRangeMarkp :
				    THREADCMD(selectCommandMarkp)
				case VidomiSelectRangeMarkm :
				    THREADCMD(selectCommandMarkm)
				case VidomiSelectRangeClear :
				    THREADCMD(selectCommandRangeClear)
				case VidomiSelectRangeReset :
				    THREADCMD(selectCommandRangeReset)
				case VidomiSelectRangeTotalTimeText:
				    THREADCMD(selectCommandRangeTotalTimeText)
					
				}
				break;
		default:
			return (DefWindowProc(hWnd, message, wParam, lParam));
			
		}
	return (DefWindowProc(hWnd, message, wParam, lParam));
}

// *****************************************************************************
// selectRangeClass::selectRangeThread()
//
// Returns TRUE if success
// *****************************************************************************
DWORD WINAPI selectRangeClass::selectRangeThread(LPVOID lParam)
{
	selectRangeClass * sr;
	bool ret;

	sr = (selectRangeClass *) lParam;

	ret = sr->selectRange();
	sr->threadId=0;
	
	ExitThread(ret);
	   
	return(ret);
}


void selectRangeClass::UpdateCrop(CONVERTCONFIG *settings) {     
char statusText[256];
char text[256];
char text1[256];

    if (settings->cropLeft%8) settings->cropLeft&=0xfff8;
    if (settings->cropRight%8) settings->cropRight&=0xfff8;
    
	if(settings->hyperCrop)
		{
		globals->translate->translate(text, "VidomiRangeHyperCropLetters");
		SetWindowText(GetDlgItem(selectRangehWnd,ShowCropTop),text);
		SetWindowText(GetDlgItem(selectRangehWnd,ShowCropBottom),text);
		}
	else
		{
		if (settings->cropTop%8) settings->cropTop&=0xfff8;
		if (settings->cropBottom%8) settings->cropBottom&=0xfff8;
		sprintf(statusText,"%d", settings->cropTop);
		SetWindowText(GetDlgItem(selectRangehWnd,ShowCropTop),statusText);
		sprintf(statusText,"%d", settings->cropBottom);
		SetWindowText(GetDlgItem(selectRangehWnd,ShowCropBottom),statusText);
		}

	sprintf(statusText,"%d", settings->cropLeft);
	SetWindowText(GetDlgItem(selectRangehWnd,ShowCropLeft),statusText);
	sprintf(statusText,"%d", settings->cropRight);
	SetWindowText(GetDlgItem(selectRangehWnd,ShowCropRight),statusText);
	
	if(settings->hyperCrop)
		{
		globals->translate->translate(text, "VidomiRangeHyperCropLetters");
		strcpy(text1,"%d * ");
		strcat(text1,text);
		sprintf(statusText,text1,frame->width-settings->cropRight-settings->cropLeft);
		SetWindowText(GetDlgItem(selectRangehWnd,ShowCropRes),statusText);
		}
	else
		{
		sprintf(statusText,"%d * %d",frame->width-settings->cropRight-settings->cropLeft,\
		frame->height-settings->cropTop-settings->cropBottom);
		SetWindowText(GetDlgItem(selectRangehWnd,ShowCropRes),statusText);
		}
}


// *****************************************************************************
// selectRangeClass::bringUpSelectRange()
//
// Bring up the selectRange screen
// *****************************************************************************
bool selectRangeClass::selectRange()
{	
	char * tempPtr;
	int i;
	FRAMEDATA * endingFrame;
	int command;
	int data;
	int status;
	int state;
	__int64 filePosOld;
	__int64 filePos;
	__int64 tempPos;
	__int64 tempPos1;
	double multiplier;
	int ret,count;
	int sliderPos;
	bool terminate;
	char text[4096];

	status = selectStatusOk;
	state = selectStateIdle;

	tempPtr = strrchr(settings->inputFilenames[0],'.');

	if (!_strnicmp(tempPtr+1,"avi",3))
		{
		aviMode =true;
		avRead = new readAviClass();
		}
	else
		{
		aviMode = false;
		avRead = new readMpegClass();
		}



	if (!avRead->init())
		{
		return(false);
		}

	postProcess = new postProcessClass();
	if(!postProcess->init())
		{
		return(false);
		}

	switch(settings->ivtcFilmMode)
		{
		case 0:
			settings->film=false;
			settings->ivtc=false;
			break;
		case 1:
			settings->deinterlace=false;
			settings->film=true;
			settings->ivtc=false;
			break;
		case 2:
			settings->deinterlace=false;
			settings->film=true;
			settings->ivtc=false;
			settings->ivtcOffset=-1;
			settings->ivtcDeComb=true;
			break;
		case 3:
			settings->film=false;
			settings->ivtc=true;
			settings->ivtcDeComb=true;
			break;
		case 4:
			settings->film=false;
			settings->ivtc=true;
			settings->ivtcDeComb=false;
			break;
		}

	avRead->clearInput();
	for(i=0;i<settings->inputFilenameIndex;i++)
		avRead->addInput(settings->inputFilenames[i]);
	avRead->setIdct(1);
	avRead->setFilm(settings->film);

	// then tell the decoder we're ready to begin
	avRead->begin(rgb32Frame);
	// see if we failed on the open of the mpeg file. 
	if(avRead->checkEnd())
		{
		avRead->end();
		delete avRead;
		return(false);
		}

    // turn on audio on 1 channel
    if (audiofound)
		{
		avRead->setAudio(true,0,0,0,false);
		}
	else
	avRead->setAudio(false,0,0,0,false);

	avRead->decodeFrame();
	avRead->getDimentions(&inputWidth,&inputHeight,&aspectRatio);
	outputFramerate = avRead->getFramerate();
    tdisplay=0;
	fileLen = avRead->getLength();
	
	frameOffset=0;
	postProcess->setCrop(0,0,0,0);
	postProcess->setIvtc(false,false,0,false);
	postProcess->setForceMultiple16(settings->forceMultiple16);
	postProcess->setDeinterlace(settings->deinterlace,settings->blend,settings->blendThreshold);
	postProcess->setOutputDimentions(settings->scale, settings->scaleType,settings->scaleBy, settings->scaleWidth,settings->scaleHeight);

	switch(settings->defaultOutputSize)
		{
		case DEFAULT_OUTPUT_50:
			postProcess->setOutputDimentions(true, 0,2, 50,50);
			break;
		case DEFAULT_OUTPUT_75:
			postProcess->setOutputDimentions(true, 0,2, 75,75);
			break;
		case DEFAULT_OUTPUT_100:
		default:
			postProcess->setOutputDimentions(false, settings->scaleType,settings->scaleBy, settings->scaleWidth,settings->scaleHeight);
			break;
		}

	postProcess->setHyperScale(false,0, false);
	// Then init postprocess by passing in the input frame width / height
	postProcess->begin(inputWidth,inputHeight,outputFramerate,rgb32Frame,false,settings);
	// Now Fetch the final resulting frame output dimentions
	postProcess->getOutputDimentions(&outputWidth,&outputHeight);

	//Set input frame size
	globals->outputVideo->setVideoInputFormat(outputWidth,outputHeight,rgb32Frame);
	//set output window size

	if(outputWidth<MINXSIZE)
		outputWidth = MINXSIZE;

//	globals->outputVideo->setOutputWindowSize(outputWidth,outputHeight+SELECT_RANGE_PANEL_SIZE);
//	globals->outputVideo->setOutputWindowSize(MINXSIZE,outputHeight+SELECT_RANGE_PANEL_SIZE);
	globals->outputVideo->setOutputWindowSize(outputWidth,outputHeight,0,SELECT_RANGE_PANEL_SIZE);

	cropScaleX = (float)outputWidth / (float)inputWidth;
	cropScaleY = (float)outputHeight / (float)inputHeight;

	globals->translate->translate(text, "VidomiRangeWindow");
	globals->outputVideo->setOutputWindowText(text);
	globals->outputVideo->setResize(false);


	if (!selectRangehWnd)
		{
		globals->outputVideo->hideOutputWindow();
		delete postProcess;
		avRead->end();
		delete avRead;
		logPrintf("Failed To created Select Range Window\n");
        return(false);
		}

	//display the output window
    MoveWindow(selectRangehWnd, 0, outputHeight, MINXSIZE, SELECT_RANGE_PANEL_SIZE, TRUE);

	// Find the last valid frame in MPEG mode
	if (!aviMode)
		{
		filePos = ((fileLen/MPEG_BLOCK_SIZE)-64) * MPEG_BLOCK_SIZE;
		for(;;)
			{
			if(avRead->seekPos(filePos))
				{
				fileLen = filePos;
				break;
				}
			filePos-=64*MPEG_BLOCK_SIZE;
			}
		filePos = 0;
		avRead->seekPos(filePos);
		}
	else
		{
		filePos = avRead->getClosestKeyframe(0);
		}

	ShowWindow(selectRangehWnd,TRUE);
	showTotal();

	
	filePosOld = lastKnownGoodPos = filePos;
	avRead->decodeFrame();
	frame = avRead->getFrameData();
	endingFrame = postProcess->processFrame(frame);
	
	displayCropFrame(endingFrame);
	globals->outputVideo->showOutputWindow();

	terminate = false;
	for(;;)
		{
		

		EnterCriticalSection(&selectLock);
		command = selectCommand;
		data = selectData;
		selectCommand = selectCommandNoOp;
		selectStatus = status;
		selectState = state;		
		LeaveCriticalSection(&selectLock);

		switch(command)
			{			
			case selectCommandDie :
				//Hide our output window
				terminate = true;
				break;

            case SelectUpdateCrop :
                UpdateCrop(settings);
                break;

			case selectCommandFrameAdvance :
				displayNextFrame(fileLen,&lastKnownGoodPos,&frameOffset,playing&0x4);
				playing=0;
				break;
				
			case selectCommandPlay:
			    avplay(fileLen,&lastKnownGoodPos,&frameOffset);
			    SendMessage(PlayWnd, BM_SETIMAGE, IMAGE_ICON, (LPARAM)iconGoPlay);
			    break;	
			
			case selectCommandSetStart :
				if (lastKnownGoodPos>settings->endingFilePos)
					break;
				settings->startingFilePos = lastKnownGoodPos;
				settings->startingFileFrame = frameOffset;
				tempPos = avRead->getCurPos();
				showPosition(0,settings->startingFilePos,settings->startingFileFrame,VidomiSelectRangeStartByteText);

				globals->translate->translate(text, "VidomiRangeSlected");
				strcat(text," %I64d");
				showPosition(text,settings->endingFilePos - settings->startingFilePos,0,VidomiSelectRangeTotalSelectedByteText);
                settings->rangelist[rangemark].startingFilePos=settings->startingFilePos;
                settings->rangelist[rangemark].startingFileFrame=settings->startingFileFrame;
                settings->rangelist[rangemark].valid=1;
                UpdateRangeSlider();
                showTotal();
                break;

			case selectCommandSetEnd :
				if(lastKnownGoodPos<settings->startingFilePos)
					break;
				settings->endingFilePos = lastKnownGoodPos;
				settings->endingFileFrame = frameOffset;
				
				tempPos = avRead->getCurPos();
				showPosition(0,settings->endingFilePos,settings->endingFileFrame,VidomiSelectRangeEndByteText);
				globals->translate->translate(text, "VidomiRangeSlected");
				strcat(text," %I64d");
                showPosition(text,settings->endingFilePos - settings->startingFilePos,0,VidomiSelectRangeTotalSelectedByteText);
                settings->rangelist[rangemark].endingFilePos=settings->endingFilePos;
                settings->rangelist[rangemark].endingFileFrame=settings->endingFileFrame;
                settings->rangelist[rangemark].valid=1;
                UpdateRangeSlider();
                showTotal();
				break;

			case selectCommandSeek :
				filePosOld = filePos;
				if (data !=0)
					{
					multiplier = (double) data / (sliderRange * 1.0f);
					filePos = (__int64) (fileLen * multiplier);
					}
				else
					{	
					filePos = 0;
					}
				if (filePos != filePosOld)
					{
					if (filePos >fileLen)
						{
						filePos = fileLen;
						}
					if (aviMode)
						{
						filePos = avRead->getClosestKeyframe((int) filePos);
						}
					ret = avRead->seekPos(filePos); 
					if (ret)
						{
						if (!avRead->decodeFrame())
							break;
						lastKnownGoodPos = filePos;
						frame = avRead->getFrameData();
						endingFrame = postProcess->processFrame(frame);
						displayCropFrame(endingFrame);
						}
					else
						{
						filePos = lastKnownGoodPos;
						avRead->seekPos(filePos);
						avRead->decodeFrame();
						frame = avRead->getFrameData();
						endingFrame = postProcess->processFrame(frame);
						displayCropFrame(endingFrame);
						}
					}
				frameOffset=0;
				UpdateRangeSlider();
				showPosition(0,lastKnownGoodPos,frameOffset,VidomiSelectRangeCurrentByteText);
				break;

			case selectCommandInitSlider :
				showPosition(0,settings->startingFilePos,settings->startingFileFrame,VidomiSelectRangeStartByteText);
				showPosition(0,settings->endingFilePos,settings->endingFileFrame,VidomiSelectRangeEndByteText);			
				globals->translate->translate(text, "VidomiRangeSlected");
				strcat(text," %I64d");
				showPosition(text,settings->endingFilePos - settings->startingFilePos,0,VidomiSelectRangeTotalSelectedByteText);

				// init some new text vars
				UpdateCrop(settings);
						
				// fall through to start of marker
				//break;
						    
			case selectCommandGoStart :
GoStart:
				ret = avRead->seekPos(settings->startingFilePos);
				if(ret)
					{
					lastKnownGoodPos = settings->startingFilePos;
					for(i=0;i<settings->startingFileFrame;i++)
						{
						if(!avRead->decodeFrame())
							break;
						}
					if(!avRead->decodeFrame())
						break;
					lastKnownGoodPos = settings->startingFilePos;
					frameOffset = settings->startingFileFrame;
					frame = avRead->getFrameData();
					endingFrame = postProcess->processFrame(frame);
					displayCropFrame(endingFrame);
					UpdateRangeSlider();
					sliderPos = computeSliderPostion(settings->startingFilePos, fileLen);
					SendMessage(GetDlgItem(selectRangehWnd,VidomiSelectRangeSlider),TBM_SETPOS ,TRUE,(LPARAM) sliderPos);
					}
				showPosition(0,lastKnownGoodPos,frameOffset,VidomiSelectRangeCurrentByteText);
				break;

			case selectCommandGoEnd :
GoEnd:
				ret = avRead->seekPos(settings->endingFilePos);
				if (ret)
					{
					lastKnownGoodPos = settings->endingFilePos;
					for (i=0;i<settings->endingFileFrame;i++)
						{
						if (!avRead->decodeFrame())
							break;
						}
					if (!avRead->decodeFrame())
						break;
					lastKnownGoodPos = settings->endingFilePos;
					frameOffset = settings->endingFileFrame;
					frame = avRead->getFrameData();
					endingFrame = postProcess->processFrame(frame);
					displayCropFrame(endingFrame);
					UpdateRangeSlider();
					sliderPos = computeSliderPostion(settings->endingFilePos, fileLen);
					SendMessage(GetDlgItem(selectRangehWnd,VidomiSelectRangeSlider),TBM_SETPOS ,TRUE,(LPARAM) sliderPos);
					}				
                showPosition(0,lastKnownGoodPos,frameOffset,VidomiSelectRangeCurrentByteText);
				break;

			case selectCommandRangeTab :
			    if (lastKnownGoodPos == settings->startingFilePos) goto GoEnd;
			    if (lastKnownGoodPos == settings->endingFilePos) {
			        rangemark++;
			        goto Updaterangemark;
			    }
			    tempPos = avRead->getCurPos();
			    if (tempPos>settings->startingFilePos) goto GoEnd;
			    if (tempPos<settings->endingFilePos) goto GoStart;
			    break;

			case selectCommandGoPrev :
			// skip some frames in reverse
				if(aviMode)
					{
					avRead->seekPos(avRead->getPrevKeyframe());
					}
				else
					{
					tempPos = lastKnownGoodPos;
					for(;;)
						{
						if (avRead->seekPos(tempPos))
							{
							tempPos1 = avRead->getCurPos();
    						if ((playing&4) && (rangemark>0) && (tempPos1<settings->startingFilePos)) {
                        // skip over to previous cut 
                                while (rangemark>0) {
                                    rangemark--;
                                    if (!settings->rangelist[rangemark].valid) continue;
                                    break;
                                }
                                // get prev segment
                                settings->startingFilePos=settings->rangelist[rangemark].startingFilePos;
                                settings->startingFileFrame=settings->rangelist[rangemark].startingFileFrame;
                                settings->endingFilePos=settings->rangelist[rangemark].endingFilePos;
                                settings->endingFileFrame=settings->rangelist[rangemark].endingFileFrame;
                                UpdateRangeSlider();
                                ShowAll();
                                playing=0;
                                goto GoEnd;
						    }

							if (tempPos1 < lastKnownGoodPos)
								break;
							}
							
						tempPos-=16*MPEG_BLOCK_SIZE;
						


						if (tempPos<=0)
							{
							tempPos=0;
							break;
							}
						}
					}
                playing=0;
				if (!avRead->seekPos(tempPos1)) {
				    break;
				}
				if (!avRead->decodeFrame()) {
					break;
				}
				lastKnownGoodPos = tempPos1;
				frameOffset = 0;
				frame = avRead->getFrameData();
				endingFrame = postProcess->processFrame(frame);
				displayCropFrame(endingFrame);
				UpdateRangeSlider();
				sliderPos = computeSliderPostion(tempPos, fileLen);
				SendMessage(GetDlgItem(selectRangehWnd,VidomiSelectRangeSlider),TBM_SETPOS ,TRUE,(LPARAM) sliderPos);
                showPosition(0,lastKnownGoodPos,frameOffset,VidomiSelectRangeCurrentByteText);
				break;


			case selectCommandGoNext :
			// doesnt work !!!
				break;
				if(aviMode)
					{
					avRead->seekPos(avRead->getNextKeyframe());
					}
				else
					{
					tempPos = lastKnownGoodPos;
					for(;;)
						{
						if(avRead->seekPos(tempPos))
							{
							break;
							}
						tempPos+=64*MPEG_BLOCK_SIZE;
						if(tempPos>=fileLen)
							{
							tempPos=fileLen;
							break;
							}
						}
					}
				if(!avRead->decodeFrame())
					break;
				lastKnownGoodPos = tempPos;
				frameOffset = 0;
				frame = avRead->getFrameData();
				endingFrame = postProcess->processFrame(frame);
				displayCropFrame(endingFrame);
				UpdateRangeSlider();
				sliderPos = computeSliderPostion(tempPos, fileLen);
				SendMessage(GetDlgItem(selectRangehWnd,VidomiSelectRangeSlider),TBM_SETPOS ,TRUE,(LPARAM) sliderPos);
                showPosition(0,lastKnownGoodPos,frameOffset,VidomiSelectRangeCurrentByteText);
				break;

            case selectCommandCropLeftp :
                settings->cropLeft+=8;
				displayCropFrame(endingFrame);
                UpdateCrop(settings);
                break;

            case selectCommandCropLeftm :
                if (settings->cropLeft>=8) settings->cropLeft-=8;
				displayCropFrame(endingFrame);
                UpdateCrop(settings);
                break;
                
             case selectCommandCropRightp :
                settings->cropRight+=8;
 				displayCropFrame(endingFrame);
                UpdateCrop(settings);
                break;
                
             case selectCommandCropRightm :
                if (settings->cropRight>=8) settings->cropRight-=8;
 				displayCropFrame(endingFrame);
                UpdateCrop(settings);
                break;

             case selectCommandCropTopp :
				settings->hyperCrop=false;
                settings->cropTop+=8;
                displayCropFrame(endingFrame);
                UpdateCrop(settings);
                break;

             case selectCommandCropTopm :
				settings->hyperCrop=false;
                if (settings->cropTop>=8) settings->cropTop-=8;
                displayCropFrame(endingFrame);
                UpdateCrop(settings);
                break;

             case selectCommandCropBottomp :
				settings->hyperCrop=false;
                settings->cropBottom+=8;
                displayCropFrame(endingFrame);
                UpdateCrop(settings);
                break;
                
             case selectCommandCropBottomm :
				settings->hyperCrop=false;
                if (settings->cropBottom>=8) settings->cropBottom-=8;
				displayCropFrame(endingFrame);
                UpdateCrop(settings);
                break;
              
             case selectCommandMarkp :
                rangemark++;
                goto Updaterangemark;
                
             case selectCommandMarkm :
                 rangemark--;
Updaterangemark:
                if (rangemark>=MAX_RANGES) rangemark=MAX_RANGES-1;
                if (rangemark<0) rangemark=0;
                showCutNr();
                settings->startingFilePos=settings->rangelist[rangemark].startingFilePos;
                settings->startingFileFrame=settings->rangelist[rangemark].startingFileFrame;
                settings->endingFilePos=settings->rangelist[rangemark].endingFilePos;
                settings->endingFileFrame=settings->rangelist[rangemark].endingFileFrame;
				UpdateRangeSlider();
				globals->translate->translate(text, "VidomiRangeSlected");
				strcat(text," %I64d");	
				showPosition(text,settings->endingFilePos - settings->startingFilePos,0,VidomiSelectRangeTotalSelectedByteText);
				showPosition(0,settings->startingFilePos,settings->startingFileFrame,VidomiSelectRangeStartByteText);
                showPosition(0,settings->endingFilePos,settings->endingFileFrame,VidomiSelectRangeEndByteText);
                showTotal();
                if (settings->rangelist[rangemark].valid) goto GoStart;
                break;


// reset all cut markers
             case selectCommandRangeReset :
                 for (count=0; count<MAX_RANGES; count++) {
                    settings->rangelist[count].startingFilePos=0;
                    settings->rangelist[count].startingFileFrame=0;
                    settings->rangelist[count].endingFilePos = fileLen;
                    settings->rangelist[count].endingFileFrame=0;
                    settings->rangelist[count].valid=0;
                 }
                 rangemark=0;
                 // 1. range must always be valid
                 settings->rangelist[0].valid=1;
                 goto Updaterangemark;

// clear current cut 
             case selectCommandRangeClear :
                 for (count=rangemark; count<31; count++) {
                    settings->rangelist[count].startingFilePos=settings->rangelist[count+1].startingFilePos;
                    settings->rangelist[count].startingFileFrame=settings->rangelist[count+1].startingFileFrame;
                    settings->rangelist[count].endingFilePos = settings->rangelist[count+1].endingFilePos;
                    settings->rangelist[count].endingFileFrame=settings->rangelist[count+1].endingFileFrame;
                    settings->rangelist[count].valid=settings->rangelist[count+1].valid;
                 }
                 settings->rangelist[31].startingFilePos=0;
                 settings->rangelist[31].startingFileFrame=0;
                 settings->rangelist[31].endingFilePos = fileLen;
                 settings->rangelist[31].endingFileFrame=0;
                 settings->rangelist[31].valid=0;
                 
                 // 1. range must always be valid
                 settings->rangelist[0].valid=1;
                 goto Updaterangemark;


// insert one cut
            case selectCommandRangeInsert :
                 for (count=31; count>rangemark; count--) {
                    settings->rangelist[count].startingFilePos=settings->rangelist[count-1].startingFilePos;
                    settings->rangelist[count].startingFileFrame=settings->rangelist[count-1].startingFileFrame;
                    settings->rangelist[count].endingFilePos = settings->rangelist[count-1].endingFilePos;
                    settings->rangelist[count].endingFileFrame=settings->rangelist[count-1].endingFileFrame;
                    settings->rangelist[count].valid=settings->rangelist[count-1].valid;
                 }
                 // clr current
                 settings->rangelist[rangemark].startingFilePos=0;
                 settings->rangelist[rangemark].startingFileFrame=0;
                 settings->rangelist[rangemark].endingFilePos = fileLen;
                 settings->rangelist[rangemark].endingFileFrame=0;
                 settings->rangelist[rangemark].valid=0;
                 // 1. range must always be valid
                 settings->rangelist[0].valid=1;
                 goto Updaterangemark;

            case selectCommandRangeTotalTimeText:
                // switch between time and bytes display
                tdisplay=!tdisplay;
                if (tdisplay) {
                    BpS=GetBytesperSecond();
                }
                showTotal();
				showPosition(0,settings->startingFilePos,settings->startingFileFrame,VidomiSelectRangeStartByteText);
				showPosition(0,settings->endingFilePos,settings->endingFileFrame,VidomiSelectRangeEndByteText);
				globals->translate->translate(text, "VidomiRangeSlected");
				strcat(text," %I64d");
				showPosition(text,settings->endingFilePos - settings->startingFilePos,0,VidomiSelectRangeTotalSelectedByteText);
				showPosition(0,lastKnownGoodPos,frameOffset,VidomiSelectRangeCurrentByteText);
                break;
                
           
            case selectCommandTestAV :
                TestavSync();
                break;

			case selectCommandNoOp :
			default :
				Sleep(30);
			}

		if(globals->outputVideo->windowRepaint())
			{
			displayCropFrame(endingFrame);
			}

		if(!globals->outputVideo->windowVisible() || terminate)
			{
			break;
			}
		}


// declare 1. marker interval to valid    
    settings->rangelist[0].valid=1;
// and copy 1. segment to old global vars    
    settings->startingFilePos=settings->rangelist[0].startingFilePos;
    settings->startingFileFrame=settings->rangelist[0].startingFileFrame;
    settings->endingFilePos=settings->rangelist[0].endingFilePos;
    settings->endingFileFrame=settings->rangelist[0].endingFileFrame;

	
	SendMessage(selectRangehWnd,WM_COMMAND ,(WPARAM)VidomiSelectRangeTerminate,(LPARAM) 0);					
	globals->outputVideo->hideOutputWindow();
	delete postProcess;
	avRead->end();
	delete avRead;	
	globals->optionsUp=false;
	return(true);

}

// *****************************************************************************
// selectRangeClass::computeSliderPos()
//
// *****************************************************************************
int selectRangeClass::computeSliderPostion(__int64 pos, __int64 fileLen)
{	
	double multiplier;

	if(pos)
		{
		multiplier = (double)pos / (double) fileLen;
		return((int) ((sliderRange * 1.0f) * multiplier));
		}
	else
		{
		return(0);
		}

}

// *****************************************************************************
// selectRangeClass::avplay()
//
// play file until stop or the end of the file
// *****************************************************************************
bool selectRangeClass::avplay(__int64 fileLen,__int64 *lastKnownGoodPos,int *frameOffset) {
	FRAMEDATA * endingFrame;

	outputAudio = new outputAudioClass();

	outputAudio->setMaxAudioBuffers(8);
	outputAudio->setAudioInputFormat(2, 48000);
	audioFirstTime = true;
	// play until stop
	checkpts(0,0,0,0);

	while (playing) 
		{
		if (displayNextFrame(fileLen,lastKnownGoodPos,frameOffset,8|playing)) 
			{
			// end of file
			playing=0;
			break;
			}
		}
 
	// display last known i frame
	avRead->seekPos(*lastKnownGoodPos);
	*frameOffset=0;

	if (avRead->decodeFrame()) 
		{
		// should be good frame	
		frame =avRead->getFrameData();											
		endingFrame = postProcess->processFrame(frame);
		displayCropFrame(endingFrame);
		}
	
	showPosition(0,*lastKnownGoodPos,*frameOffset,VidomiSelectRangeCurrentByteText);

	outputAudio->stop();
	outputAudio->end();
	delete outputAudio;
	return (false);
}

// counter for slider update
static short framecount;

int audiobytes;

// advance one frame, optionally skip cut, update slider + cursor text
// return true if out of range or file end
// flg bits:
// 0: (1)update slider + text every frame (0) every MAX_RANGES frames
// 1: (1)display without crop (0) display with cropping frame
// 2: (1)jump from cut to cut (0) play over cutting point
// 3: (1)display with sound, (0) without sound
bool selectRangeClass::displayNextFrame(__int64 fileLen,__int64 *lastKnownGoodPos,int *frameOffset,char flg) {
__int64 tempPos;
unsigned short sliderPos;
FRAMEDATA * endingFrame;
AUDIODATA *	audiosamples;
int xframe;
short pictype;

	// read from current pos
	tempPos = avRead->getCurPos();

    cutflg=0; // flags color coding of picture sequence frames
               
	if (tempPos<=fileLen) 
		{
		if (avRead->decodeFrame()) 
			{
			frame = avRead->getFrameData();
			audiosamples = avRead->getAudioData(0);

            if (audiofound) 
				{				
				if(audiosamples)
					{
					if(audiosamples->bytesUsed)
						{
						audiosamples->bytesUsed=0;
						audiosamples->data = audiosamples->bufferStart;
						}
/*
					audiobytes=audiosamples->bytesUsed;
					if (flg&8 && playsound && audiofound) 
						{
						// play with sound
						// sync with framerate here
						//while (!tfflag) Sleep(0);
						//tfflag=0;
						// copy the audio
 						if (audiosamples->bytesUsed>BUFFER_SIZE>>2) 
							{
							// wait for swap buffer
							while (!(wav_hdr[cabuf].dwFlags & WHDR_DONE)) Sleep(0);
							if (audiosamples->bytesUsed>BUFFER_SIZE) 
								{
								// buffer overrun
								//MessageBeep(MB_OK);
								audiosamples->bytesUsed=BUFFER_SIZE;
								}
							memcpy(buffers[cabuf],audiosamples->bufferStart,audiosamples->bytesUsed);
							wav_hdr[cabuf].dwBufferLength=audiosamples->bytesUsed;
							//waveOutWrite( hWaveOut, &wav_hdr[cabuf], sizeof(wav_hdr[cabuf]) );
							audiosamples->bytesUsed=0;
							audiosamples->data = audiosamples->bufferStart;
							if (cabuf) 
								{
								cabuf=0;
								}
							else 
								{
								cabuf=1;
								}
							}
						}
						*/
					}
				}
			else 
				{
				// kill the audio
				if(audiosamples)
					{
					audiosamples->bytesUsed=0;
					audiosamples->data = audiosamples->bufferStart;
					}
				}
						
            // update lastKnownGoodPos at keyframe hit
            pictype=avRead->getFrameType();
            if (pictype==FRAME_I_TYPE || pictype==FRAME_P_TYPE) {
                *lastKnownGoodPos=tempPos;
                *frameOffset=0;
            }
            else {
		        (*frameOffset)++;
			}

			if (flg&4) {
			// check for end of range
				if (tempPos>=settings->endingFilePos && *frameOffset>settings->endingFileFrame) {
 				    // jump to next cut
                    rangemark++;
                    if (rangemark>=MAX_RANGES) return (true);
                    for (;rangemark<MAX_RANGES;rangemark++) {
                        if (!settings->rangelist[rangemark].valid) continue;
                        break;
                    }
                    if (rangemark>=MAX_RANGES) {
                        rangemark=0;
                        return (true);
                    }
                 
                    // get next segment
                    settings->startingFilePos=settings->rangelist[rangemark].startingFilePos;
                    settings->startingFileFrame=settings->rangelist[rangemark].startingFileFrame;
                    settings->endingFilePos=settings->rangelist[rangemark].endingFilePos;
                    settings->endingFileFrame=settings->rangelist[rangemark].endingFileFrame;
                    // and adjust to frame 
                    avRead->seekPos(settings->startingFilePos);
				    for (xframe=0; xframe<settings->startingFileFrame; xframe++) {
				        if (!avRead->decodeFrame()) break;
				    }
				    *lastKnownGoodPos=settings->startingFilePos;
				    tempPos=settings->startingFilePos;
				    *frameOffset=settings->startingFileFrame;

                    // update text + slider display
                    UpdateRangeSlider();
                    // update all text vars
                    ShowAll();
                    // mark cut as red
                    cutflg=1;
				}
			}
						
        	// mark ending file pos as green
		    if ((*lastKnownGoodPos==settings->endingFilePos) && ((*frameOffset)==settings->endingFileFrame)) {
		        if (!cutflg) {
				    cutflg=2;
                }
            }

            // mark starting file position as blue
		    if ((*lastKnownGoodPos==settings->startingFilePos) && ((*frameOffset)==settings->startingFileFrame)) {
		        if (!cutflg) {
				    cutflg=3;
                }
            }

            // show pts jitter
			if (audiofound) checkpts(frame->hardPts,audiosamples->pts,avRead->getFrameType(),1);

			// suppress postprocessor if doing sound
			if (!playsound) 
				{
				endingFrame=frame;
				//endingFrame = postProcess->processFrame(frame);
				}
			else
				{
				endingFrame=frame;
				}		
			// in playing mode hide cropping rectangle
			if (flg&2) {
			    globals->outputVideo->displayFrame(endingFrame);
			}
			else {
				displayCropFrame(endingFrame);
            }
                       
            framecount++;
            if (!(flg&1) || !(framecount&0x001f)) {
                // update slider every 32 frames only
				sliderPos = computeSliderPostion(tempPos, fileLen);
				SendMessage(GetDlgItem(selectRangehWnd,VidomiSelectRangeSlider),TBM_SETPOS,TRUE,(LPARAM) sliderPos);
			}
    		if (1) {				    
	    		// update frame pos every frame
		        showPosition(0,*lastKnownGoodPos,*frameOffset,VidomiSelectRangeCurrentByteText);
		    }
		}
		else {
			// was probably a bad position
			MessageBeep(MB_OK);
			return (true);
		}
		return (false);
	}
    return (true);
}


// update text + slider display
void selectRangeClass::UpdateRangeSlider(void) {
int sliderPos;
RECT trect,drect,threct;
short count,pos;
HBRUSH greybrush;
HDC hDC;
__int64 fileLen;
double tlen;
char text[4096];

    fileLen = avRead->getLength();
	if (settings->endingFilePos == 0x7fffffffffffffff) {
	    settings->endingFilePos = fileLen;
	}
	sliderPos = computeSliderPostion(settings->startingFilePos,fileLen);
	SendMessage(GetDlgItem(selectRangehWnd,VidomiSelectRangeSlider),TBM_SETSELSTART, FALSE,(LPARAM) sliderPos);		
	sliderPos = computeSliderPostion(settings->endingFilePos,fileLen);
	SendMessage(GetDlgItem(selectRangehWnd,VidomiSelectRangeSlider),TBM_SETSELEND, TRUE,(LPARAM) sliderPos);		
	globals->translate->translate(text, "VidomiRangeSlected");
	strcat(text," %I64d");
	showPosition(text,settings->endingFilePos - settings->startingFilePos,0,VidomiSelectRangeTotalSelectedByteText);

    // draw range trackbars
    hDC = GetDC(selectRangehWnd);
    greybrush=CreateSolidBrush(0x00e0e0e0);  // gray
	// get size of trackbar
	SendMessage(GetDlgItem(selectRangehWnd,VidomiSelectRangeSlider),TBM_GETCHANNELRECT, 0,(LPARAM)&trect);
	// get thumb size
	SendMessage(GetDlgItem(selectRangehWnd,VidomiSelectRangeSlider),TBM_GETTHUMBRECT, 0,(LPARAM)&threct);

#define BORDER 3    
    trect.right-=BORDER;
    trect.left+=BORDER;
    trect.top+=BORDER;
    trect.bottom-=BORDER;	
    tlen=trect.right-trect.left;
    drect.top=trect.top;
    drect.bottom=trect.bottom;
    for (count=0; count<MAX_RANGES; count++) {
        if (settings->rangelist[count].valid) {   
		   drect.left= (long) (trect.left+(tlen/((double)fileLen/(double)settings->rangelist[count].startingFilePos)));
		   drect.right=(long)(trect.left+(tlen/((double)fileLen/(double)settings->rangelist[count].endingFilePos)));
		   if (drect.right<threct.left || drect.left>threct.right) {
    	    // no overlap draw range rect	
    		   if (count!=rangemark) {
		            FillRect(hDC,&drect,greybrush);
               }
		   }
		   else {
		   // overlapped, draw 2 splitted rects
    		   if (count!=rangemark) {
    		        pos= (short) (drect.right);
    		        drect.right=threct.left;
    		        if (drect.left<drect.right) {
		             FillRect(hDC,&drect,greybrush);
		            }
    		        drect.left=threct.right;
    		        drect.right=pos;
    		        if (drect.left<drect.right) {
		             FillRect(hDC,&drect,greybrush);
		            }
               }		   
		   }
		   
        }
    }
    DeleteObject(greybrush);
    ReleaseDC(selectRangehWnd,hDC);

    showCutNr();
 
}

// draw video frame + cropping window
void selectRangeClass::displayCropFrame(FRAMEDATA * frame) {
HDC hDC;
RECT rec;
HBRUSH nullbrush;
int tempTop;
int tempBot;


   	globals->outputVideo->displayFrame(frame);

	if (!settings->cropTop && !settings->cropBottom && !settings->cropLeft && !settings->cropRight) 
		{
		return;
		}		

	hDC = GetDC(globals->outputVideo->outputhWnd);
  
	tempTop = settings->cropTop;
	tempBot = settings->cropBottom;

    // show crop 
	if(settings->hyperCrop)
		{
		tempTop = 0;
		tempBot = 0;
		}

	rec.top=(int)((float)tempTop * cropScaleY);
	rec.bottom=outputHeight - (int)((float)tempBot * cropScaleY);
	rec.left=(int)((float)settings->cropLeft * cropScaleX);
	rec.right=outputWidth - (int)((float)settings->cropRight * cropScaleX);
	nullbrush=CreateSolidBrush(0x00ffffff);
	FrameRect(hDC,&rec,nullbrush);
	DeleteObject(nullbrush);

 	ReleaseDC(globals->outputVideo->outputhWnd,hDC);
}

// show cur nr mark invalid with *
void selectRangeClass::showCutNr(void) {
char statusText[12];
char valid;
    if (settings->rangelist[rangemark].valid) valid=' ';
    else valid='*';
    // mark invalid 
	sprintf(statusText,"%d%c", rangemark+1,valid);
	SetWindowText(GetDlgItem(selectRangehWnd,ShowMark),statusText);
}

// update all display vars
void selectRangeClass::ShowAll(void) {
char text[4096];
	globals->translate->translate(text, "VidomiRangeSlected");
	strcat(text," %I64d");
    showPosition(text,settings->endingFilePos - settings->startingFilePos,0,VidomiSelectRangeTotalSelectedByteText);
	showPosition(0,settings->startingFilePos,settings->startingFileFrame,VidomiSelectRangeStartByteText);
    showPosition(0,settings->endingFilePos,settings->endingFileFrame,VidomiSelectRangeEndByteText);
    showTotal();
    showCutNr();
}

// show file position (show time here, if average bytes per frame is known)
void selectRangeClass::showPosition(char *fstr,__int64 fpos,int frame,int bnum) {
char statusText[128];
short hours,mins,secs;
long tsecs;
char text[4096];

 if (!tdisplay || !BpS) {
    if (!fstr) sprintf(statusText,"%I64d+%d",fpos,frame);
    else sprintf(statusText,fstr,fpos,frame);
 }
 else {
     tsecs= (long)(fpos/BpS);
     hours=tsecs/3600;
     tsecs=tsecs%3600;
     mins=tsecs/60;
     secs=tsecs%60;
    if (!fstr) {
     sprintf(statusText,"%02d:%02d:%02d-%d",hours,mins,secs,frame);
    }
    else {
	globals->translate->translate(text, "VidomiRangeSlected");
	strcat(text," %02d:%02d:%02d");
     sprintf(statusText,text,hours,mins,secs);
    }
 }

	SetWindowText(GetDlgItem(selectRangehWnd,bnum),statusText);				
}

// show total time
void selectRangeClass::showTotal(void) {
char statusText[128];
char count,cuts=0;
short hours,mins,secs;
long tsecs;
__int64 tlen=0;
char text[4096];

// Update total time
    for (count=0; count<MAX_RANGES; count++) {
     if (settings->rangelist[count].valid) {
 	  if (settings->rangelist[count].endingFilePos == 0x7fffffffffffffff) {
	    settings->rangelist[count].endingFilePos = fileLen;
	  }
      tlen+=settings->rangelist[count].endingFilePos-settings->rangelist[count].startingFilePos;
      cuts++;
     }
    }
    if (!tdisplay || !BpS) {
	globals->translate->translate(text, "VidomiRangeTotal");
	strcat(text," %d - %I64d");
     sprintf(statusText,text ,cuts,tlen);
    }
    else {
     tsecs=(long)(tlen/BpS);
     hours=tsecs/3600;
     tsecs=tsecs%3600;
     mins=tsecs/60;
     secs=tsecs%60;
	globals->translate->translate(text, "VidomiRangeTotal");
	strcat(text," %d - %02d:%02d:%02d");
     sprintf(statusText,text,cuts,hours,mins,secs);
	}
	SetWindowText(GetDlgItem(selectRangehWnd,VidomiSelectRangeTotalTimeText),statusText);				
}

// play movie for about 1 second frames and determine bytes used
int selectRangeClass::GetBytesperSecond(void) {
char count,fps,maxfrm;
__int64 fpos;

 fps= (char)(avRead->getFramerate());

#if 0==1
// seek to the middle of the movie 
 avRead->seekPos(avRead->getLength()>>1);
 fpos=avRead->getCurPos();
 avRead->seekPos(fpos);
 fpos=avRead->getCurPos();
#else
 fpos=0;
 avRead->seekPos(fpos);
#endif

 // and take a 1 second number of frames
 maxfrm=0;
 for (count=0; count<fps; count++) {
  while (!avRead->decodeFrame()) {
   maxfrm++;
   if (maxfrm>100) return 0;
  }
 }
 return ((int)(avRead->getCurPos()-fpos));
}


// callback for frame timer
void CALLBACK lpTimeProc(UINT uTimerID, UINT uMsg, DWORD dwUser, DWORD dw1, DWORD dw2) {
    tframe++;
    tfflag=1;
}

// pts analyzer vars 
#define PTSMASIZE 75
long ptsmax,ptsmin,ptsdelta_array[PTSMASIZE];
short pts1flg,ptscount;
__int64 ptsaccum;
//extern char cut_changed;
char cut_changed;

// calc pts stats, 3 second gliding average + min,max
// if flg=0 init vars, else calc
// output to paramstr 1 + 2
// gets audiopts,videopts,frametype and flg
void checkpts(int vpts,int apts,char type, char flg) {
long ptsdelta;
char tindex[4]={'U','I','P','B'};

    if (!flg) {
        ptsaccum=0;
        ptsmax=0;
        ptsmin=0x7fffffff;
        for (ptscount=0;ptscount<PTSMASIZE;ptscount++) ptsdelta_array[ptscount]=0;
        ptscount=0;
        pts1flg=0;
        return;
    }

	ptsdelta=(vpts-apts);

	// gliding average of pts delta
	ptsaccum-=ptsdelta_array[ptscount]; // -oldest
	ptsdelta_array[ptscount]=ptsdelta;  // replaced oldest  
	ptsaccum+=ptsdelta;    // + newest
	ptscount++;
	if (ptscount>=PTSMASIZE) ptscount=0;
	if (ptsdelta>ptsmax) {
		ptsmax=ptsdelta;
	}
	if (ptsdelta<ptsmin) {
		ptsmin=ptsdelta;
	}
					     
					     
	if (cut_changed) {
        logPrintf("pts-delta at cut: %ld\n",(long)(ptsdelta/90));
	} 
					   
	if (showpts) {
	// param vars for diagnostic display
	    type=tindex[type];
        sprintf(pstr1,"FT=%c  v-pts: %ld a-pts: %ld diff: %ld",type,(long)(vpts/90),(long)(apts/90),(long)(ptsdelta/90));
        sprintf(pstr2,"avg-pts: %ld min-pts: %ld max-pts: %ld",(long)((ptsaccum/PTSMASIZE)/90),(long)(ptsmin/90),(long)(ptsmax/90));
        //sprintf(pstr2,"audiobytes: %ld",audiobytes);
        
        logPrintf("FT=%c v-pts: %ld a-pts: %ld diff(ms): %ld\n",type,(long)vpts,(long)apts,(long)(ptsdelta/90));
    }
}

#define TESTFRAMES 250
// test av sync by scanning a portion of the movie from start and near the end
void selectRangeClass::TestavSync(void) {
int filePos;
short frames; 
FRAMEDATA * video;
AUDIODATA *	audio;
double ptsdelta,sumx,sumx2,count,avg1,std1,avg2,std2;
char str1[128];

 if (!audiofound) return;
 
 sumx=0;
 sumx2=0;
 count=0;
 avRead->seekPos(0);
// average 250 testframes
 for (frames=0; frames<TESTFRAMES; frames++) {
	if (avRead->decodeFrame()) {
	    video = avRead->getFrameData();
	    audio = avRead->getAudioData(0);
	    ptsdelta=video->hardPts-audio->pts;
	    sumx+=ptsdelta;
	    sumx2+=ptsdelta*ptsdelta;
        count++;
		audio->bytesUsed=0;
		audio->data = audio->bufferStart;
	}
 }
 
 if (!count) return;
 
 avg1=sumx/count;
 std1=(sumx2-((avg1*avg1)*count))/(count-1);
 if (std1>0) std1=sqrt(std1);
 else std1=0;
 
 sumx=0;
 sumx2=0;
 count=0;
 filePos=0;
 avRead->seekPos((avRead->getLength()/10)*9);
// average 250 testframes
 for (frames=0; frames<TESTFRAMES; frames++) {
	if (avRead->decodeFrame()) {
	    video = avRead->getFrameData();
	    audio = avRead->getAudioData(0);
	    ptsdelta=video->hardPts-audio->pts;
	    sumx+=ptsdelta;
	    sumx2+=ptsdelta*ptsdelta;
        count++;
		audio->bytesUsed=0;
		audio->data = audio->bufferStart;
	}
 }
 
 if (!count) return;
 
 avg2=sumx/count;
 std2=(sumx2-((avg2*avg2)*count))/(count-1);
 if (std2>0) std2=sqrt(std2);
 else std2=0;

 sprintf(str1,"AVG1: %.0f  STD1: %.0f <-> AVG2: %.0f  STD2: %.0f",floor(avg1/90),floor(std1/90),floor(avg2/90),floor(std2/90));

 vidomiErrorBox(selectRangehWnd,str1,"AV-SyncTest",MB_OK);

}




