// *****************************************************************************
//	Vidomi - Video Encoder
//
//	Copyright (C) 2001 Vidomi, Inc.
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

// *****************************************************************************
// *****************************************************************************
// selectRange class
// *****************************************************************************
#ifndef selectrange_h
#define selectrange_h

#define VIDOMI_WHEEL_DELTA 120

#define SELECT_RANGE_PANEL_SIZE 96
#define BUTTON_BORDER_SIZE 4
#define BUTTON_SET_START_WIDTH 26
#define BUTTON_SET_END_WIDTH 26
#define BUTTON_FRAME_ADVANCE_WIDTH 26
#define BUTTON_GO_FIRST_WIDTH 26
#define BUTTON_GO_LAST_WIDTH 26
#define BUTTON_GO_START_WIDTH 26
#define BUTTON_GO_END_WIDTH 26
#define BUTTON_GO_PREV_WIDTH 26
#define BUTTON_GO_NEXT_WIDTH 26

#define BUTTON_PANEL_WIDTH (BUTTON_SET_START_WIDTH+\
							BUTTON_SET_END_WIDTH+\
							BUTTON_FRAME_ADVANCE_WIDTH+\
							BUTTON_GO_FIRST_WIDTH+\
							BUTTON_GO_LAST_WIDTH+\
							BUTTON_GO_START_WIDTH+\
							BUTTON_GO_END_WIDTH+\
							BUTTON_GO_PREV_WIDTH+\
							BUTTON_GO_NEXT_WIDTH)

enum {
	VidomiSelectRangeDoneButton = 500,
		VidomiSelectRangeSlider,
		VidomiSelectRangeFrameAdvance,
		VidomiSelectRangeSetStart,
		VidomiSelectRangeSetEnd,
		VidomiSelectRangeGoFirst,
		VidomiSelectRangeGoLast,
		VidomiSelectRangeGoStart,
		VidomiSelectRangeGoEnd,
		VidomiSelectRangeGoPrev,
		VidomiSelectRangeGoNext,
		VidomiSelectRangeTextStatic,
		VidomiSelectRangeStartByteText,
		VidomiSelectRangeEndByteText,
		VidomiSelectRangeCurrentByteText,
		VidomiSelectRangeTotalSelectedByteText,
		VidomiSelectRangeTotalTimeText,
		VidomiSelectRangeTerminate,
		VidomiSelectRangeCropLeftp,
		VidomiSelectRangeCropLeftm,
		VidomiSelectRangeCropRightp,
		VidomiSelectRangeCropRightm,
		VidomiSelectRangeCropTopp,
		VidomiSelectRangeCropTopm,
		VidomiSelectRangeCropBottomp,
		VidomiSelectRangeCropBottomm,
		VidomiSelectRangeMarkp,
		VidomiSelectRangeMarkm,
		VidomiSelectRangeReset,
		VidomiSelectRangeClear,
		ShowCropTop,
		ShowCropBottom,
		ShowCropLeft,
		ShowCropRight,
		ShowCropRes,
		ShowMark,
		VidomiSelectSound,

};

#define VidomiSelectMouseclick WM_USER+1

// Select Thread Commands
enum {

	selectCommandNoOp=0,
	selectCommandSeek,
	selectCommandFrameAdvance,
	selectCommandSetStart,
	selectCommandSetEnd,
	selectCommandInitSlider,
	selectCommandGoStart,
	selectCommandGoEnd,
	selectCommandGoPrev,
	selectCommandGoNext,
	selectCommandDie,

	selectCommandCropTopp,
	selectCommandCropBottomp,
	selectCommandCropLeftp,
	selectCommandCropRightp,
	
	selectCommandCropTopm,
	selectCommandCropBottomm,
	selectCommandCropLeftm,
	selectCommandCropRightm,
    selectCommandMarkp,
    selectCommandMarkm,
    selectCommandRangeReset,
    selectCommandRangeClear,
    selectCommandRangeInsert,
    selectCommandRangeTotalTimeText,

	SelectUpdateCrop,
	selectCommandPlay,
	selectCommandselpic,
	selectCommandRangeTab,
	selectCommandTestAV,
	

} ;

enum {

	selectStateIdle=0,
};

enum {

	selectStatusOk=0,
	selectStatusError,
	selectStatusDead
};

struct PICSEQ {
__int64 lastKnownGoodPos;
int frameOffset;
short xpos;
short ypos;
};


class selectRangeClass 
{

	public:
									selectRangeClass();
									~selectRangeClass();
		bool						bringUpSelectRange(HINSTANCE hInst, CONVERTCONFIG * convertConfigIn);
		static DWORD WINAPI			selectRangeThread(LPVOID lParam);
		BOOL static CALLBACK		selectRangeMessageHandler(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
		HWND volatile				selectRangehWnd;
        short                       mxpos,mypos;
        __int64                     GetPinInfo(char *ifile);

        
	private:
		bool						registerWindowClass(HINSTANCE hInst,char * className);
		BOOL						selectRangeMessageHandler1(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
		bool						selectRange();
		int							computeSliderPostion(__int64 curPos, __int64 fileLen);
        void                        UpdateCrop(CONVERTCONFIG *settings);
		bool						displayNextFrame(__int64 fileLen,__int64 *lastKnownGoodPos,int *frameOffset,char flg);
		bool						avplay(__int64 fileLen,__int64 *lastKnownGoodPos,int *frameOffset);
		void                        UpdateRangeSlider(void);
		void                        displayCropFrame(FRAMEDATA * frame);
		void                        showCutNr(void);
        void                        showPosition(char *fstr,__int64 fpos,int frame,int bnum);
        int                         GetBytesperSecond(void);
        void                        showTotal(void);
        __int64                     fileLen;
        int                         BpS;
		avReadClass *				avRead;
		postProcessClass *			postProcess;
		FRAMEDATA *					frame;
		int							inputWidth;
		int							inputHeight;
		float						inputFramerate;
		int							outputWidth;
		int							outputHeight;
		float						outputFramerate;
		double						aspectRatio;
		CONVERTCONFIG *				settings;
		DWORD						threadId;
		HANDLE						threadHandle;
//		HWND volatile				selectRangehWnd;
		WNDCLASS					windCls;
		HFONT						font;
		volatile int				selectCommand;
		volatile int				selectData;
		volatile int				selectStatus;
		CRITICAL_SECTION			selectLock;
		volatile int				selectState;
		HICON						iconSetStart;
		HICON						iconSetEnd;
		HICON						iconFrameAdvance;
		HICON						iconGoFirst;
		HICON						iconGoLast;
		HICON						iconGoStart;
		HICON						iconGoEnd;
		HICON						iconGoPrev;
		HICON						iconGoNext;
		HICON						iconGoPrevFRame;
		HICON						iconGoPlay;
		HICON						iconGoStop;
		bool						aviMode;
		volatile int				playing;
		HWND                        PlayWnd;
		short                       tdisplay;
		short						picsequence;
		short						picseqx,picseqy;
		struct PICSEQ               picseqs[50];
        short                       pxsiz;
        short                       pysiz;
        short                       picseqshown;
        __int64                     lastKnownGoodPos;
        int                         frameOffset;
        short                       picsnum;
        void                        SelectPic(void);
        void                        TestavSync(void);
        void                        ShowAll(void);
		int							sliderRange;
		float						cropScaleX;
		float						cropScaleY;
		outputAudioClass *			outputAudio;
		bool						audioFirstTime;

};


#endif