// *****************************************************************************
//
//
// slavewindow.cpp
// 
//
// *****************************************************************************

#include "../en.h"

extern GLOBALS * globals;

// *****************************************************************************
// slaveWindowClass::slaveWindowClass()
//
// window class constructor
// *****************************************************************************
slaveWindowClass::slaveWindowClass()
{
	
}

// *****************************************************************************
// slaveWindowClass::~slaveWindowClass()
//
// window class destructor
// *****************************************************************************
slaveWindowClass::~slaveWindowClass()
{

	DestroyWindow(globals->hWnd);
	if(!globals->hideSlaveIcon)
		{
		deleteTaskBarIcon();
		}

}

// *****************************************************************************
// slaveWindowClass::createWindow()
//
//
// *****************************************************************************
bool slaveWindowClass::createWindow(HINSTANCE hInst)
{

	registerWindowClass(hInst,"vidomiSlaveWindow");
	
	globals->hWnd = CreateWindowEx(0, "vidomiSlaveWindow", "Vidomi Encode Slave", WS_TILEDWINDOW,
							0, 0, 
							128, 128, NULL, NULL, hInst, NULL );

	ShowWindow(globals->hWnd, SW_HIDE);
	
	if(!globals->hideSlaveIcon)
		{
		addTaskBarIcon();
		}

	return(true);
}

// *****************************************************************************
// slaveWindowClass::registerWindowClass()
//
//
// *****************************************************************************
bool slaveWindowClass::registerWindowClass(HINSTANCE hInst,char * className)
{
	//Main Window
	windCls.style         = CS_HREDRAW | CS_VREDRAW;
    windCls.lpfnWndProc   = (WNDPROC)windowMessageHandler;
    windCls.cbClsExtra    = 0;
    windCls.cbWndExtra    = 0;
    windCls.hInstance     = hInst;          
    windCls.hIcon         = NULL;
    windCls.hCursor       = LoadCursor(hInst, IDC_ARROW);
    windCls.hbrBackground = HBRUSH(COLOR_WINDOW+1);
    windCls.lpszMenuName  = NULL; 
	windCls.lpszClassName = className;
	
    if (!RegisterClass( &windCls))
		{
        return FALSE;
		}

	return TRUE;
}
// *****************************************************************************
// slaveWindowClass::windowMessageHandler()
//
//
// *****************************************************************************
BOOL CALLBACK slaveWindowClass::windowMessageHandler(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{

	return(globals->slaveWindow->windowMessageHandler1(hWnd,message,wParam,lParam));


}
// *****************************************************************************
// windowClass::windowMessageHandler1()
//
//
// *****************************************************************************
BOOL slaveWindowClass::windowMessageHandler1(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	POINT          curPos;
	unsigned short commandId;
	unsigned short commandEvent;
	
	switch(message)
		{
		case WM_DESTROY:
			PostQuitMessage(0);
			return(FALSE);


		case WM_COMMAND:
            commandId    = LOWORD(wParam); // Remember, these are...
			commandEvent = HIWORD(wParam); // ...different for Win32!
			//Parse the menu selections:
			switch (commandId) 
				{
				case slaveEncodeOptions:
					if(!globals->optionsUp)
						{
						globals->optionsUp = true;
						globals->slaveOptions->bringUpOptions(globals->hInst);
						}
					break;

				case slaveEncodeClose:
					PostQuitMessage(0);
					break;

				default:
					break;
				}
			break;
		case WM_TASKBARNOTIFY:
			if((UINT) lParam == WM_RBUTTONDOWN)
				{
				GetCursorPos(&curPos);	
				rightClickMenu(curPos.x,curPos.y,hWnd);
				return(FALSE);
				}
			else
				{
				if(clickMenu)
					{
					DestroyMenu(clickMenu);
					clickMenu = NULL;
					}
				}

		default:
			return (DefWindowProc(hWnd, message, wParam, lParam));
		}
	return(TRUE);
}

// *****************************************************************************
// windowClass::addTaskBarIcon()
//
//
// *****************************************************************************
void slaveWindowClass::addTaskBarIcon()
{
    NOTIFYICONDATA tnid; 	
	
    tnid.cbSize = sizeof(NOTIFYICONDATA); 
    tnid.hWnd = globals->hWnd; 
    tnid.uID = 101;									//app defined notify ID
    tnid.uFlags = NIF_MESSAGE | NIF_ICON | NIF_TIP; 
    tnid.uCallbackMessage = WM_TASKBARNOTIFY; 
	tnid.hIcon = LoadIcon(globals->hInst, MAKEINTRESOURCE(VidomiIcon));

    lstrcpyn(tnid.szTip, "Vidomi Encoding Slave", sizeof(tnid.szTip)); 
 
    Shell_NotifyIcon(NIM_ADD, &tnid);  
}

// *****************************************************************************
// windowClass::deleteTaskBarIcon()
//
//
// *****************************************************************************
void slaveWindowClass::deleteTaskBarIcon()
{ 
	NOTIFYICONDATA tnid; 
 
	tnid.cbSize = sizeof(NOTIFYICONDATA); 
	tnid.hWnd = globals->hWnd; 
	tnid.uID = 101; 
		 
	Shell_NotifyIcon(NIM_DELETE, &tnid); 
}


// *****************************************************************************
// windowClass::rightClickMenu()
//
//
// *****************************************************************************
void slaveWindowClass::rightClickMenu(int xPos,int yPos,HWND hwnd)
{

	clickMenu = CreatePopupMenu();

	AppendMenu(clickMenu,MF_STRING,slaveEncodeOptions,"Options");
	AppendMenu(clickMenu,MF_SEPARATOR,0,NULL);
	AppendMenu(clickMenu,MF_STRING,slaveEncodeClose,"Close");

	globals->translate->translateMenu(clickMenu);
	
	TrackPopupMenu(clickMenu,TPM_LEFTALIGN | TPM_RIGHTBUTTON,xPos,yPos,0,hwnd,NULL);
	
	DestroyMenu(clickMenu);
	clickMenu = NULL;

}