// *****************************************************************************
//	Vidomi - Video Encoder
//
//	Copyright (C) 2001 Vidomi, Inc.
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

// *****************************************************************************
// *****************************************************************************
// subtitles class
// *****************************************************************************
#ifndef subtitles_h
#define subtitles_h

typedef struct {
	unsigned char *		allocStart;
	unsigned char *		bufferStart;
	int					bufferSize;
	unsigned char *		data;
	int					width;
	int					height;
	bool				display;
	bool				firstDisplay;
} SUBTITLEFRAMEDATA;

class subtitlesClass 
{

	public:
									subtitlesClass();
									~subtitlesClass();
			void					init(float inFramerate,float outFramerate);
			void					end();
			bool					processSubtitleData(int channelIndex,CONVERTCONFIG * settings,SUBTITLEDATA * sub);
			void					channelConfigure(int channelIndex,int subMode, bool half, char * filename);


	private:
			bool					parseSubtitleControl(int channelIndex,CONVERTCONFIG * settings,SUBTITLEDATA * sub);
			bool					preprocessSubtitleData(int channelIndex, SUBTITLEDATA * sub, SUBTITLEFRAMEDATA * subtitleFrame);
			bool					renderSubtitle(SUBTITLEDATA * sub, SUBTITLEFRAMEDATA * subtitleFrame);
			void					renderLineRgb32();
			int						getBits();

			float					inputFramerate;
			float					outputFramerate;
			float					rateChange;
			unsigned short			subtitleTimer[MAX_SUBTITLE_CHANNELS];
			unsigned char			subtitlePalette[MAX_SUBTITLE_CHANNELS][4];					
			unsigned char			subtitleAlpha[MAX_SUBTITLE_CHANNELS][4];
			unsigned short			subtitleLeftPixel[MAX_SUBTITLE_CHANNELS];
			unsigned short			subtitleRightPixel[MAX_SUBTITLE_CHANNELS];
			unsigned short			subtitleTopPixel[MAX_SUBTITLE_CHANNELS];
			unsigned short			subtitleBottomPixel[MAX_SUBTITLE_CHANNELS];
			unsigned short			subtitleEvenLineStart[MAX_SUBTITLE_CHANNELS];
			unsigned short			subtitleOddLineStart[MAX_SUBTITLE_CHANNELS];
			unsigned short			subtitleType[MAX_SUBTITLE_CHANNELS];
			char					subtitleFilename[MAX_SUBTITLE_CHANNELS][MAX_PATH];
			bool					subtitlePreprocess[MAX_SUBTITLE_CHANNELS];
			unsigned char			subtitleRemap[MAX_SUBTITLE_CHANNELS][4];
			unsigned int			colorTable[4];
			unsigned char			renderSubtitlePalette[4];					
			unsigned char			renderSubtitleAlpha[4];
			unsigned int *			current;
			int						subtitleWidth;
			int						subtitleHeight;
			int						stride;
			int						subtitleField;
			int						lineCounter;
			unsigned char *			dataPtr[2];
			bool					dataNibble[2];
			int						dataSize[2];						
			unsigned int *			outputPtr;


};



#endif