// *****************************************************************************
//	Vidomi - Video Encoder
//
//	Copyright (C) 2001 Vidomi, Inc.
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

// *****************************************************************************
// *****************************************************************************
//
//
// Window.cpp
// 
//
// *****************************************************************************

#include "en.h"

char * vidomiCfgText = "All\0*.*\0Vidomi Config Files\0*.vidomi;\0\0";

static char * inputText = "All\0*.*\0MPEG Files\0"
		"*.mp2;*.mpg;*.vob;*.m1v;*.m2v;*.mpe;*.mpeg;*.mv2;*.mpv;*.ts;*.trp;*.tp;*.trs;*.tps"
		";*.0000;*.0001;*.0002;*.0003;*.0004;*.0005;*.0006;*.0007;*.0008;*.0009"
		";*.0010;*.0011;*.0012;*.0013;*.0014;*.0015;*.0016;*.0017;*.0018;*.0019"
		";*.0020;*.0021;*.0022;*.0023;*.0024;*.0025;*.0026;*.0027;*.0028;*.0029"
		";*.0030;*.0031;*.0032;*.0033;*.0034;*.0035;*.0036;*.0037;*.0038;*.0039"
		";*.0040;*.0041;*.0042;*.0043;*.0044;*.0045;*.0046;*.0047;*.0048;*.0049"
		";*.0050;*.0051;*.0052;*.0053;*.0054;*.0055;*.0056;*.0057;*.0058;*.0059"
		";*.0060;*.0061;*.0062;*.0063;*.0064;*.0065;*.0066;*.0067;*.0068;*.0069"
		";*.0070;*.0071;*.0072;*.0073;*.0074;*.0075;*.0076;*.0077;*.0078;*.0079"
		";*.0080;*.0081;*.0082;*.0083;*.0084;*.0085;*.0086;*.0087;*.0088;*.0089"
		";*.0090;*.0091;*.0092;*.0093;*.0094;*.0095;*.0096;*.0097;*.0098;*.0099"
		";*.0100;*.0101;*.0102;*.0103;*.0104;*.0105;*.0106;*.0107;*.0108;*.0109"
		";*.0110;*.0111;*.0112;*.0113;*.0114;*.0115;*.0116;*.0117;*.0118;*.0119"
		";*.0120;*.0121;*.0122;*.0123;*.0124;*.0125;*.0126;*.0127;*.0128;*.0129\0"
		"Lst Files\0*.lst\0Vidomi Video Files\0*.avi;*.vid;*.svid;*.divx;*.xvid\0Avi Files\0*.avi\0"
		"IFO Files\0*.ifo\0\0";

static char * outputText = "All\0*.*\0Vidomi Video Files\0*.avi;*.vid;*.svid;*.divx;*.xvid\0Avi Files\0*.avi\0\0";

extern GLOBALS * globals;

// *****************************************************************************
// windowClass::windowClass()
//
// window class constructor
// *****************************************************************************
windowClass::windowClass()
{
	mainhWnd = NULL;
	savePosition = false;
}

// *****************************************************************************
// windowClass::~windowClass()
//
// window class destructor
// *****************************************************************************
windowClass::~windowClass()
{
	/*
	if(encoderWindow)
		delete encoderWindow;
		*/
	if(mainhWnd)
		DestroyWindow(mainhWnd);

}

// *****************************************************************************
// windowClass::createWindow()
//
//
// *****************************************************************************
bool windowClass::createWindow(HINSTANCE hInst)
{

	savePosition = false;

	skin = new skinsClass();
	logPrintf("skinClass created.\n");
	if(!skin->loadSkin(globals->currentSkin,"[encoderfront]"))
		{
		if(!skin->loadSkin("..\\installer\\skins\\defaultskin.vsk","[encoderfront]"))
			{	
			return(false);
			}
		}

	mainhWnd = skin->createWindow(hInst, "Vidomi Encoder", "VidomiMainEncoderWindow", (WNDPROC) windowMessageHandler);
/*
	registerWindowClass(hInst,"VidomiMainEncoderWindow");
	
	mainhWnd = CreateWindowEx(0, "VidomiMainEncoderWindow", "Vidomi Encoder", WS_OVERLAPPED | WS_CLIPCHILDREN | WS_SYSMENU | WS_MINIMIZEBOX ,
							0, 0, 
							40, 40, NULL, NULL, hInst, NULL );

	globals->translate->translate(text, "VidomiMain");
	SetWindowText(mainhWnd, text);			
*/
	globals->hWnd = mainhWnd;

	if (!globals->hWnd)
		{
		logPrintf("Failed To created Primary Window\n");
        return(false);
		}

	if(globals->vidomiSwitcherhWnd)
		{
		PostMessage(globals->vidomiSwitcherhWnd,VidomiEncoderMessageHwnd,0,(LPARAM)mainhWnd); 
		}

	mainMenuMain = LoadMenu(hInst,MAKEINTRESOURCE(VidomiMainMenu));
	globals->translate->translateMenu(mainMenuMain);

	mainMenu = GetSubMenu(mainMenuMain, 0);
	optionsMenu = GetSubMenu(mainMenu, 5);
	fileMenu = GetSubMenu(mainMenu, 2);
	jobControlMenu = GetSubMenu(mainMenu, 4);

/*
	SetMenu(mainhWnd,mainMenu);

  	encoderWindow = new encoderWindowClass();

	encoderhWnd = encoderWindow->createWindow(hInst);
*/
	fullscreen =false;

	if(globals->vidomiMode==MODE_ENCODER)
		encoderMode();

	savePosition = true;

	globals->jobList[globals->jobIndex].outputSet = false;
	
	DragAcceptFiles(globals->hWnd, TRUE); 

	return(true);
}

// *****************************************************************************
// windowClass::encoderMode()
//
//
// *****************************************************************************
void windowClass::encoderMode(void)
{
	RECT win;
	int width;
	int height;
	int fullHeight;
	int fullWidth;

	fullHeight = GetSystemMetrics(SM_CYSCREEN);
	fullWidth = GetSystemMetrics(SM_CXSCREEN);

	if((globals->windowLeft > fullWidth) || globals->windowLeft < 0)
		globals->windowLeft = 320;

	if((globals->windowTop > fullHeight) || globals->windowTop < 0)
		globals->windowTop = 240;


	GetWindowRect(globals->hWnd, &win);
	width = win.right - win.left;
	height = win.bottom - win.top;
	MoveWindow(globals->hWnd, globals->windowLeft, globals->windowTop, width, height, TRUE);
	skin->showWindow();

	//Configure For Encoder Mode
	
	/*
	GetWindowRect(globals->hWnd, &Win);
	GetWindowRect(encoderhWnd, &Dlg);
	GetClientRect(globals->hWnd, &Client);

	width = (Win.right - Win.left) - (Client.right - Client.left) + (Dlg.right - Dlg.left);
	height = (Win.bottom - Win.top) - (Client.bottom - Client.top) + (Dlg.bottom - Dlg.top);

	MoveWindow(globals->hWnd, globals->windowLeft, globals->windowTop, width, height, TRUE);

	encoderWindow->showWindow();

	ShowWindow(globals->hWnd, SW_SHOW);
	SetWindowPos(globals->hWnd,HWND_TOP,0,0,0,0,SWP_NOMOVE | SWP_NOSIZE);
	SetFocus(globals->hWnd);
	UpdateWindow(globals->hWnd);
	*/
}

// *****************************************************************************
// windowClass::disable()
//
//
// *****************************************************************************
void windowClass::disable(void)
{
	skin->hideWindow();

/*
	encoderWindow->hideWindow();

	ShowWindow(globals->hWnd, SW_HIDE);
	UpdateWindow(globals->hWnd);
*/
}
// *****************************************************************************
// windowClass::registerWindowClass()
//
//
// *****************************************************************************
bool windowClass::registerWindowClass(HINSTANCE hInst,char * className)
{
	//Main Window
	windCls.style         = CS_HREDRAW | CS_VREDRAW;
    windCls.lpfnWndProc   = (WNDPROC)windowMessageHandler;
    windCls.cbClsExtra    = 0;
    windCls.cbWndExtra    = 0;
    windCls.hInstance     = hInst;          
    windCls.hIcon         = LoadIcon(hInst, MAKEINTRESOURCE(VidomiIcon));
    windCls.hCursor       = LoadCursor(hInst, IDC_ARROW);
    windCls.hbrBackground = HBRUSH(0);
    windCls.lpszMenuName  = NULL; 
	windCls.lpszClassName = className;
	
    if (!RegisterClass( &windCls))
		{
		logPrintf("Failed To create window Class\n");
        return FALSE;
		}

	return TRUE;
}

// *****************************************************************************
// windowClass::windowMessageHandler()
//
//
// *****************************************************************************
BOOL CALLBACK windowClass::windowMessageHandler(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{

	return(globals->window->windowMessageHandler1(hWnd,message,wParam,lParam));


}
// *****************************************************************************
// windowClass::windowMessageHandler1()
//
//
// *****************************************************************************
BOOL windowClass::windowMessageHandler1(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	registryClass * registry;
	HKEY regKey;
	DWORD regReturn;
	unsigned short commandId;
	unsigned short commandEvent;
	RECT win;
	char * tempStr;
	OPENFILENAME ofn;
	char filename[MAX_PATH];
	int fullHeight;
	int fullWidth;
	char ending[5];
	char * ptrStr;
	int offset;
	int pathlen;
	int numfiles;
	char *filesort[256];
	int i;
	int j;
	char * temp;
	char path[MAX_PATH];
	char outputName[MAX_PATH];
	char * ptr;
	ULARGE_INTEGER freeBytesAvailableToCaller;
	ULARGE_INTEGER totalNumberOfBytes;
	ULARGE_INTEGER totalNumberOfFreeBytes;
	char tempName[MAX_PATH];
	unsigned __int64 spaceRequired;
	POINT mousePos;
	RECT button;
	int skinReturn; 
	int	currentPos;

	if(skinReturn = skin->skinMessageHandler(hWnd, message, wParam, lParam))
		{
		return(skinReturn);
		}

	switch(message)
		{
		case WM_RBUTTONDOWN :
			GetCursorPos(&mousePos);
			TrackPopupMenu(mainMenu,TPM_LEFTALIGN | TPM_RIGHTBUTTON,mousePos.x,mousePos.y,0,hWnd,NULL);	
			break;

		case WM_MOVE :
			if(savePosition)
				{
				GetWindowRect(hWnd, &win);
				globals->windowLeft = win.left;
				globals->windowTop = win.top;    
				}
			return(FALSE);

		case WM_DROPFILES :
			doDrop(wParam);
			break;

		case WM_DESTROY:
			if(globals->vidomiMode==MODE_ENCODER)
				{
				GetWindowRect(hWnd, &win);
				globals->windowLeft = win.left;
				globals->windowTop = win.top;    

				registry = new registryClass();
				regReturn = registry->openCreateReg(&regKey,REGISTRY_PROGRAM_NAME);
				if(regReturn)
					{
					registry->setRegVal(regKey, "windowTop" , globals->windowTop);
					registry->setRegVal(regKey, "windowLeft" , globals->windowLeft);
					registry->setRegVal(regKey, "outputTop" , globals->outputTop);
					registry->setRegVal(regKey, "outputLeft" , globals->outputLeft);
					}

				registry->closeReg(regKey);
				delete registry;
				}

			SendMessage(globals->vidomiSwitcherhWnd,VidomiEncoderMessageTerminate,0,0); 
			PostQuitMessage(0);
			return(FALSE);

		case VidomiExternalMessageMinimize:
			ShowWindow(hWnd,SW_MINIMIZE);
			break;

		case VidomiExternalMessageClose:
		case WM_CLOSE:
			if(!globals->optionsUp)
				{
				if(globals->converting)
					{
					char messTitle[4096];
					char messText[4096];
					globals->translate->translate(messText, "VidomiMessage33");
					globals->translate->translate(messTitle, "VidomiMessage33Title");

					if(vidomiErrorBox(hWnd,messText,messTitle,MB_YESNO)==IDYES)
						{
						char messTitle[4096];
						char messText[4096];
						globals->translate->translate(messText, "VidomiMessage36");
						globals->translate->translate(messTitle, "VidomiMessage36Title");

						if(vidomiErrorBox(hWnd,messText,messTitle,MB_YESNO)==IDYES)
							{
							globals->netConversion->abort(-1);
							}
						globals->netConversion->setForcedAbortConversion();
						PostQuitMessage(0);
						//DestroyWindow(hWnd);
						}
					}
				else
					{
					PostQuitMessage(0);
					//DestroyWindow(hWnd);
					}	
				}
			break;

		case VidomiEncoderMessageTerminate:
			PostQuitMessage(0);
			return(FALSE);

		case VidomiEncoderMessageActivate:
			if(globals->vidomiMode!=MODE_ENCODER)
				{
				registry = new registryClass();

				regReturn = registry->openCreateReg(&regKey,REGISTRY_PROGRAM_NAME);
				if(regReturn)
					{
					registry->getSetRegVal(regKey, "windowTop" , &globals->windowTop);
					registry->getSetRegVal(regKey, "windowLeft" , &globals->windowLeft);
					registry->getSetRegVal(regKey, "outputTop" , &globals->outputTop);
					registry->getSetRegVal(regKey, "outputLeft" , &globals->outputLeft);
					registry->getSetRegStr(regKey, "playFilename" , globals->playFilename, MAX_PATH);
					registry->getSetRegBool(regKey, "contactVidomi" , &globals->contactVidomi);
					registry->getSetRegVal(regKey, "optionsLogOutput" , &globals->optionsLogOutput);
					}

				registry->closeReg(regKey);
				delete registry;

				fullHeight = GetSystemMetrics(SM_CYSCREEN);
				fullWidth = GetSystemMetrics(SM_CXSCREEN);

				if((globals->outputLeft > fullWidth) || globals->outputLeft < 0)
					globals->outputLeft = 320;

				if((globals->outputTop > fullHeight) || globals->outputTop < 0)
					globals->outputTop = 240;

				if((globals->windowLeft > fullWidth) || globals->windowLeft < 0)
					globals->windowLeft = 320;

				if((globals->windowTop > fullHeight) || globals->windowTop < 0)
					globals->windowTop = 240;

				encoderMode();
				globals->vidomiMode=MODE_ENCODER;
				}
			return(FALSE);

		case VidomiEncoderMessageDeactivate:
			if(globals->vidomiMode==MODE_ENCODER)
				{
				disable();
				globals->vidomiMode=MODE_DISABLED;
				}
			return(FALSE);

		case VidomiExternalMessageMode:
			if(globals->vidomiMode==MODE_ENCODER)
				{
				registry = new registryClass();
				regReturn = registry->openCreateReg(&regKey,REGISTRY_PROGRAM_NAME);
				if(regReturn)
					{
					registry->setRegVal(regKey, "windowTop" , globals->windowTop);
					registry->setRegVal(regKey, "windowLeft" , globals->windowLeft);
					registry->setRegVal(regKey, "outputTop" , globals->outputTop);
					registry->setRegVal(regKey, "outputLeft" , globals->outputLeft);
					registry->setRegStr(regKey, "playFilename" , globals->playFilename);
					registry->setRegBool(regKey, "contactVidomi" , globals->contactVidomi);
					registry->setRegVal(regKey, "optionsLogOutput" , globals->optionsLogOutput);
					}

				registry->closeReg(regKey);
				delete registry;

				SendMessage(globals->vidomiSwitcherhWnd,VidomiEncoderMessageDeactivate,0,0); 
				disable();
				globals->vidomiMode=MODE_DISABLED;
				}
			break;

		case VidomiExternalMessageMenuOptions :
			//GetCursorPos(&mousePos);
			skin->getGizmoPos("menuoptions", &button);
			GetWindowRect(hWnd, &win);
			TrackPopupMenu(optionsMenu,TPM_LEFTALIGN | TPM_RIGHTBUTTON,win.left + button.left,win.top + button.bottom,0,hWnd,NULL);	
			break;

		case VidomiExternalMessageMenuFile :
			skin->getGizmoPos("menufile", &button);
			GetWindowRect(hWnd, &win);
			TrackPopupMenu(fileMenu,TPM_LEFTALIGN | TPM_RIGHTBUTTON,win.left + button.left,win.top + button.bottom,0,hWnd,NULL);	
			break;

		case VidomiExternalMessageMenuJobControl :
			skin->getGizmoPos("menujobcontrol", &button);
			GetWindowRect(hWnd, &win);
			TrackPopupMenu(jobControlMenu,TPM_LEFTALIGN | TPM_RIGHTBUTTON,win.left + button.left,win.top + button.bottom,0,hWnd,NULL);	
			break;

		case VidomiExternalMessageViewOutput :
			if(globals->converting)
				{
				if(globals->outputVideo->windowVisible())
					{
					globals->outputVideo->hideOutputWindow();
					}
				else
					{
					globals->outputVideo->showOutputWindow();
					}
				}
			break;

		case VidomiExternalMessageViewStatistics :
			if(globals->converting)
				{
				if(globals->outputStats->windowVisible())
					{
					globals->outputStats->hideOutputWindow();
					}
				else
					{
					globals->outputStats->showOutputWindow();
					}
				}
			break;

		case VidomiExternalMessageViewControl :
			if(globals->converting)
				{
				if(globals->encodeControl->windowVisible())
					{
					globals->encodeControl->hideWindow();
					}
				else
					{
					globals->encodeControl->showWindow();				
					}
				}
			break;

		case VidomiExternalMessageAddInput:
			memset(filename,0,MAX_PATH);
			memset(&ofn, 0 , sizeof(OPENFILENAME));
			ofn.lStructSize = sizeof(OPENFILENAME);
			ofn.hwndOwner = hWnd;
			ofn.hInstance = globals->hInst;
			ofn.lpstrFile = filename;
			ofn.nMaxFile = MAX_PATH;
			ofn.lpstrFilter = inputText;
			ofn.nFilterIndex = globals->browseSourceDefaultType;
			ofn.lpstrFileTitle = NULL;
			ofn.nMaxFileTitle = 0;
			ofn.lpstrInitialDir = globals->browseSourcePath;
			ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST | OFN_ALLOWMULTISELECT | OFN_EXPLORER | OFN_ENABLESIZING;
			if(GetOpenFileName(&ofn)!= FALSE)
				{
				EnableMenuItem(mainMenu,VidomiMainMenuSelectRange,MF_BYCOMMAND | MF_ENABLED);

				globals->convertConfig->endingFilePos = 0;
				globals->convertConfig->endingFileFrame = 0;
				globals->convertConfig->endingFilePos = 0x7fffffffffffffff;
				globals->convertConfig->endingFileFrame = 0;
				_getcwd(globals->browseSourcePath,MAX_PATH);

				if(globals->browseSourcePath[strlen(globals->browseSourcePath)-1]=='\\')
					{
					globals->browseSourcePath[strlen(globals->browseSourcePath)-1]=0;
					}

				globals->browseSourceDefaultType = ofn.nFilterIndex;
				ending[0]=0;
				if(strlen(filename)>3)
					{
					strcpy(ending,&filename[strlen(filename)-4]);
					}

				if(!_stricmp(ending,".ifo"))
					{
					// Do IFO
					addFromIfoFile(filename);
					ptrStr = strrchr(filename,'_');
					if(ptrStr)
						{
						*ptrStr = 0;
						}
					}
				else
					{
					if(!_stricmp(ending,".lst"))
						{
						//Do .lst Add
						addFromLstFile(filename);
						}
					else
						{
						// Do single file add
						offset = ofn.nFileOffset;
						pathlen = offset;
						if (filename[pathlen - 1] == '\0')
							filename[pathlen - 1] = '\\';

						numfiles = 0;
						while (filename[offset] != '\0' && numfiles < 256)
							{
							filesort[numfiles] = filename + offset;
							numfiles++;
							offset += strlen(filename + offset) + 1;
							}

						for (i = 0; i < numfiles - 1; i++)
							{
							for (j = i + 1; j < numfiles; j++)
								{
								if (_stricmp(filesort[i], filesort[j]) > 0)
									{
									temp = filesort[i];
									filesort[i] = filesort[j];
									filesort[j] = temp;
									}
								}
							}

						for (i = 0; i < numfiles; i++)
							{
							strcpy(path, filename);
							strcpy(path + pathlen, filesort[i]);
							addFileToList(path);
							}
						}
					}

				if(!globals->jobList[globals->jobIndex].outputSet)
					{
					strcpy(outputName,filename);
					ptrStr = strrchr(outputName,'\\');
					if(!ptrStr)
						{
						ptrStr = outputName;
						}
					ptr = strrchr(outputName,'.');
					if(ptr)
						{
						*ptr = 0;
						}
					strcpy(filename,globals->browseDestPath);
					strcat(filename,ptrStr);
					strcat(filename,&globals->convertConfig->outputTail[0]);
					strcpy(globals->convertConfig->outputFilename,filename);
					//skin->setText("outputnametext",globals->convertConfig->outputFilename);
					//SetWindowText(GetDlgItem(dialoghWnd, VidomiMainOutputName),globals->convertConfig->outputFilename);
					globals->jobList[globals->jobIndex].outputSet = true;
					globals->job->refresh();
					}
				else
					{
					skin->setSliderPos("inputnameslider", 0);
					}
				}
			break;

		case VidomiExternalMessageClearInput:
			strcpy(globals->jobList[globals->jobIndex].convertConfig->outputFilename,"");
			skin->setText("outputnametext",globals->convertConfig->outputFilename);
			//SetWindowText(GetDlgItem(globals->window->encoderhWnd, VidomiMainOutputName), globals->convertConfig->outputFilename);
			globals->jobList[globals->jobIndex].convertConfig->inputFilenameIndex = 0;
			globals->jobList[globals->jobIndex].inputValidated=false;
			globals->jobList[globals->jobIndex].cropScanDone=false;
			globals->jobList[globals->jobIndex].outputSet = false;

			skin->comboBoxReset("inputnametext");
			skin->setSliderPos("inputnameslider", 0);
			//SendDlgItemMessage(dialoghWnd,VidomiMainInputList, LB_RESETCONTENT  , (WPARAM)0, (LPARAM) 0); 									
			//SendDlgItemMessage(dialoghWnd,VidomiMainAudioTrack, CB_RESETCONTENT , 0, 0);
			//EnableWindow(GetDlgItem(dialoghWnd,VidomiMainAudioTrack), FALSE);
			EnableMenuItem(mainMenu,VidomiMainMenuSelectRange,MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
			EnableMenuItem(mainMenu,VidomiMainMenuBatchAddToJobList,MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
			EnableMenuItem(mainMenu,VidomiMainMenuVideoOptions,MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
			EnableMenuItem(mainMenu,VidomiMainMenuAdvancedVideoOptions,MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
			EnableMenuItem(mainMenu,VidomiMainMenuAudioOptions,MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
			EnableMenuItem(mainMenu,VidomiMainMenuSubtitleOptions,MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
			EnableMenuItem(mainMenu,VidomiMainMenuSubtitleOptions,MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
			EnableMenuItem(mainMenu,VidomiMainMenuChapterOptions,MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
			EnableMenuItem(mainMenu,VidomiMainMenuOutputSizeOptions,MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
			EnableMenuItem(mainMenu,VidomiMainMenuNetworkOptions,MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
			globals->job->updateJobWindow();
			break;


		case VidomiExternalMessageBrowseOutput:
			strcpy(filename,"");
			memset(&ofn, 0 , sizeof(OPENFILENAME));
			ofn.lStructSize = sizeof(OPENFILENAME);
			ofn.hwndOwner = hWnd;
			ofn.hInstance = globals->hInst;
			ofn.lpstrFile = filename;
			ofn.nMaxFile = MAX_PATH;
			ofn.lpstrFilter = outputText;
			ofn.nFilterIndex = globals->browseDestDefaultType;
			ofn.lpstrFileTitle = NULL;
			ofn.nMaxFileTitle = 0;
			ofn.lpstrInitialDir = globals->browseDestPath;
			ofn.Flags = OFN_PATHMUSTEXIST ;
			if(GetSaveFileName(&ofn) != FALSE)
				{
				_getcwd(globals->browseDestPath,MAX_PATH);
				if(globals->browseDestPath[strlen(globals->browseDestPath)-1]=='\\')
					{
					globals->browseDestPath[strlen(globals->browseDestPath)-1]=0;
					}
				globals->browseDestDefaultType = ofn.nFilterIndex;
				strcpy(globals->convertConfig->outputFilename,filename);
				skin->setText("outputnametext",globals->convertConfig->outputFilename);
				//SetWindowText(GetDlgItem(dialoghWnd, VidomiMainOutputName),globals->convertConfig->outputFilename);
				globals->jobList[globals->jobIndex].outputSet = true;

				//if(globals->jobList[globals->jobIndex].outputSet)
					//EnableWindow(GetDlgItem(dialoghWnd,VidomiMainStartConversion), TRUE);
				}

			globals->job->updateJobWindow();
			globals->job->refresh();
			break;

		case VidomiExternalMessageStartConversion:
			if(globals->converting==false)
				{
				globals->window->skin->getText("outputnametext",globals->convertConfig->outputFilename , MAX_PATH);
				if(globals->jobList[globals->jobCount].outputSet)
					{
					strcpy(tempName,globals->jobList[globals->jobCount].convertConfig->outputFilename);
					ptr = strrchr(tempName,'\\');
					if(ptr)
						{
						*ptr =0;
						if(strcmp(tempName,globals->browseDestPath))
							{
							strcpy(globals->browseDestPath,tempName);
							}
						}
					spaceRequired = (unsigned __int64)(1024 * 1024 * 1024);
					spaceRequired *=2;

					GetDiskFreeSpaceEx(tempName, &freeBytesAvailableToCaller, &totalNumberOfBytes, &totalNumberOfFreeBytes);
					if(freeBytesAvailableToCaller.QuadPart < spaceRequired)
						{
						char messTitle[4096];
						char messText[4096];
						globals->translate->translate(messText, "VidomiMessage18");
						globals->translate->translate(messTitle, "VidomiMessage18Title");


						if(vidomiErrorBox(globals->hWnd,messText, messTitle, MB_ICONWARNING | MB_YESNO | MB_APPLMODAL )==IDNO)
							{
							break;
							}
						}
					}
				globals->converting = true;
				skin->setGizmoMultiState("startstopencoding",1);
				if(globals->jobList[globals->jobCount].outputSet && globals->jobList[globals->jobCount].inputValidated)
					{
					globals->jobIndex = globals->jobCount;
					globals->job->addToJobList();
					globals->job->setJobIndex(globals->jobIndex);
					}
				globals->job->hideWindow();
				globals->encodeControl->resetWindowState();
				globals->netConversion->startNetConversion();
				
				//globals->translate->translate(text, "VidomiMainStopConversion");
				//SetWindowText(GetDlgItem(dialoghWnd, VidomiMainStartConversion), text);
				disableEncodeOptionWindows();
				}					
			else
				{						
				globals->netConversion->abort(-1);
				}

			break;

		case VidomiExternalMessageInputSlider:
			switch(LOWORD(wParam))
				{	
				case SB_THUMBPOSITION :
					currentPos = HIWORD(wParam);
					// Set the current input list position
					//play->sendSeekPos(currentPos);
					skin->setComboBoxScrollPos("inputnametext", currentPos);
					break;	
				case SB_PAGEUP :
					currentPos = HIWORD(wParam);
					// Set the current input list position
					//play->sendSeekPos(currentPos);				
					skin->setComboBoxScrollPos("inputnametext", currentPos);
					break;					
				case SB_PAGEDOWN :
					currentPos = HIWORD(wParam);
					// Set the current input list position
					//play->sendSeekPos(currentPos);				
					skin->setComboBoxScrollPos("inputnametext", currentPos);
					break;						
				}
			break;

		case WM_COMMAND:
            commandId    = LOWORD(wParam); // Remember, these are...
			commandEvent = HIWORD(wParam); // ...different for Win32!
			//Parse the menu selections:
			switch (commandId) 
				{
				case SKIN_EDIT_CONTROL_MESSAGE:
					globals->window->skin->getText("outputnametext",globals->convertConfig->outputFilename , MAX_PATH);
					if(*globals->convertConfig->outputFilename)
						{
						globals->jobList[globals->jobIndex].outputSet=true;
						}
					else
						{
						globals->jobList[globals->jobIndex].outputSet=false;
						}
					globals->job->updateJobWindow();
					break;

				case VidomiMainMenuViewJobControlWindow :
					globals->job->showWindow();
					break;

				case VidomiMainMenuVideoOptions:
					if(!globals->optionsUp)
						{
						if(globals->vidomiMode==MODE_ENCODER)
							{
							globals->optionsVideo->bringUpOptions(globals->hInst,globals->convertConfig,globals->gatherResults);
							globals->optionsUp = true;
							}
						}
					break;

				case VidomiMainMenuOutputSizeOptions:
					if(!globals->optionsUp)
						{
						if(globals->vidomiMode==MODE_ENCODER)
							{
							globals->optionsOutputSize->bringUpOptions(globals->hInst,globals->convertConfig,globals->gatherResults);
							globals->optionsUp = true;
							}
						}
					break;

				case VidomiMainMenuAdvancedVideoOptions:
					if(!globals->optionsUp)
						{
						if(globals->vidomiMode==MODE_ENCODER)
							{
							globals->optionsAdvancedVideo->bringUpOptions(globals->hInst,globals->convertConfig);
							globals->optionsUp = true;
							}
						}
					break;

				case VidomiKey_SpecialOptions :
					if(!globals->optionsUp)
						{
						if(globals->vidomiMode==MODE_ENCODER)
							{
							globals->optionsSpecial->bringUpOptions(globals->hInst,globals->convertConfig);
							globals->optionsUp = true;
							}
						}
					break;

				case VidomiMainMenuAudioOptions:
					if(!globals->optionsUp)
						{
						if(globals->vidomiMode==MODE_ENCODER)
							{
							globals->optionsAudio->bringUpOptions(globals->hInst,globals->convertConfig,globals->gatherResults);
							globals->optionsUp = true;
							}
						}
					break;

				case VidomiMainMenuSubtitleOptions:
					if(!globals->optionsUp)
						{
						if(globals->vidomiMode==MODE_ENCODER)
							{
							globals->optionsSubtitle->bringUpOptions(globals->hInst,globals->convertConfig,globals->gatherResults);
							globals->optionsUp = true;
							}
						}
					break;

				case VidomiMainMenuChapterOptions:
					if(!globals->optionsUp)
						{
						if(globals->vidomiMode==MODE_ENCODER)
							{
							globals->optionsChapters->bringUpOptions(globals->hInst,globals->convertConfig,globals->gatherResults);
							globals->optionsUp = true;
							}
						}
					break;

				case VidomiMainMenuNetworkOptions:
					if(!globals->optionsUp)
						{
						if(globals->vidomiMode==MODE_ENCODER)
							{
							globals->optionsNetwork->bringUpOptions(globals->hInst,globals->convertConfig,globals->gatherResults);
							globals->optionsUp = true;
							}
						}
					break;

				case VidomiMainMenuGeneralOptions:
					if(!globals->optionsUp)
						{
						if(globals->vidomiMode==MODE_ENCODER)
							{
							globals->optionsGeneral->bringUpOptions(globals->hInst,globals->convertConfig);
							globals->optionsUp = true;
							}
						}
					break;


				case VidomiMainMenuSelectRange:
					if(!globals->optionsUp)
						{
						if(globals->vidomiMode==MODE_ENCODER && globals->convertConfig->inputFilenameIndex)
							{
							globals->selectRange->bringUpSelectRange(globals->hInst,globals->convertConfig);
							globals->optionsUp = true;
							}
						}
					break;

				case VidomiMainMenuAbout:
					tempStr = new char [1024];
					char messTempText[4096];
					char messTitle[4096];
					char messText[4096];
					globals->translate->translate(messTempText, "VidomiAbout1");
					globals->translate->translate(messText, "VidomiAbout2");
					strcat(messTempText,"\n");
					strcat(messTempText,messText);
					globals->translate->translate(messText, "VidomiAbout3");
					strcat(messTempText,"\n");
					strcat(messTempText,messText);
					globals->translate->translate(messText, "VidomiAbout4");
					strcat(messTempText,"\n");
					strcat(messTempText,messText);

					globals->translate->translate(messTitle, "VidomiAboutTitle");

					sprintf(messText,messTempText, VERSION, VERSION);
					MessageBox(hWnd,messText,messTitle,MB_OK);					
					delete [] tempStr;
					break;

				case VidomiMainMenuBatchAddToJobList:
					if(!globals->optionsUp)
						{
						globals->job->addToJobList();
						globals->job->setJobIndex(globals->jobCount);
						}
					break;

				case VidomiMainMenuBatchClearJobList:
					if(!globals->optionsUp)
						{
						globals->job->resetJobList();
						globals->jobList[0].outputSet = false;
						globals->jobList[0].inputValidated = false;
						globals->job->setJobIndex(globals->jobCount);
						}
					break;

				case VidomiMainMenuSaveSettings:
					if(!globals->optionsUp)
						{
						strcpy(filename,"");
						memset(&ofn, 0 , sizeof(OPENFILENAME));
						ofn.lStructSize = sizeof(OPENFILENAME);
						ofn.hwndOwner = hWnd;
						ofn.hInstance = globals->hInst;
						ofn.lpstrFile = filename;
						ofn.nMaxFile = MAX_PATH;
						ofn.lpstrFilter = vidomiCfgText;
						ofn.nFilterIndex = globals->browseSettingsDefaultType;
						ofn.lpstrFileTitle = NULL;
						ofn.nMaxFileTitle = 0;
						ofn.lpstrInitialDir = globals->browseSettingsPath;
						ofn.Flags = OFN_PATHMUSTEXIST ;
						if(GetSaveFileName(&ofn) != FALSE)
							{
							_getcwd(globals->browseSettingsPath,MAX_PATH);
							globals->browseSettingsDefaultType = ofn.nFilterIndex;
						
							if(!strstr(filename,".vidomi"))
								{
								strcat(filename,".vidomi");
								}
							globals->settings->saveSettingsFile(filename);
							}
						}
					break;

				case VidomiMainMenuLoadSettings:
					if(!globals->optionsUp)
						{
						strcpy(filename,"");
						memset(&ofn, 0 , sizeof(OPENFILENAME));
						ofn.lStructSize = sizeof(OPENFILENAME);
						ofn.hwndOwner = hWnd;
						ofn.hInstance = globals->hInst;
						ofn.lpstrFile = filename;
						ofn.nMaxFile = MAX_PATH;
						ofn.lpstrFilter = vidomiCfgText;
						ofn.nFilterIndex = globals->browseSettingsDefaultType;
						ofn.lpstrFileTitle = NULL;
						ofn.nMaxFileTitle = 0;
						ofn.lpstrInitialDir = globals->browseSettingsPath;
						ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;
						if(GetOpenFileName(&ofn) != FALSE)
							{
							_getcwd(globals->browseSettingsPath,MAX_PATH);
							globals->browseSettingsDefaultType = ofn.nFilterIndex;
							globals->settings->loadSettingsFile(filename);
							}
						}
					break;

				default:
					break;
				}
			break;
		default:
			return (DefWindowProc(hWnd, message, wParam, lParam));
		}

	return (TRUE);

}

// *****************************************************************************
// windowClass::addFromLstFile()
//
// open a .lst file and add all files listed. Files need to be on a single line
// seperatd by CR/LF
// *****************************************************************************
bool windowClass::addFromLstFile(char * filename)
{
	FILE * lstFile;
	char vobFilename[MAX_PATH];

	lstFile = fopen(filename, "r");
	if(!lstFile)
		return(false);
	for(;;)
		{
		if(fgets(vobFilename,MAX_PATH, lstFile)==NULL)
			break;
		//lop off the newline chars at the end
		vobFilename[strlen(vobFilename)-1]=0;
		if(!addFileToList(vobFilename))
			break;
		}
	fclose(lstFile);
	return(true);
}

// *****************************************************************************
// windowClass::addFromIfoFile()
//
// *****************************************************************************
bool windowClass::addFromIfoFile(char * filename)
{
	GATHERRESULTS fileInfo;						
	FILE * fileTest;
	char vobFilename[MAX_PATH];
	char baseFilename[MAX_PATH];
	char ifoFilename[MAX_PATH];
	char * ptr;
	int index;
	ifoClass * ifo;
	int i;

	strcpy(ifoFilename,filename);

	// Perform IFO read and check
	ifo = new ifoClass();
	
	if(!ifo->readIfo(ifoFilename,&fileInfo))
		{
		char messTitle[4096];
		char messText[4096];
		globals->translate->translate(messText, "VidomiMessage20");
		globals->translate->translate(messTitle, "VidomiMessage20Title");

		vidomiErrorBox(globals->hWnd,messText,messTitle,MB_OK | MB_ICONERROR);
		delete ifo;
		return(false);
		}
	
	delete ifo;
	
	enableEncodeOptionWindows();

	strcpy(baseFilename,ifoFilename);

	ptr = strrchr(baseFilename,'_');
	if(ptr)
		{
		*ptr = 0;
		}
	else
		{
		return(false);
		}

	for(index=1;index<99;index++)
		{
		sprintf(vobFilename,"%s_%d.vob",baseFilename,index);

		fileTest = fopen(vobFilename,"rb");

		if(!fileTest)
			{
			// Reached the end of the file list
			break;
			}
		fclose(fileTest);

		strcpy(globals->convertConfig->inputFilenames[globals->convertConfig->inputFilenameIndex],vobFilename);
		skin->comboBoxInsertString("inputnametext",vobFilename);
		//SendDlgItemMessage(dialoghWnd,VidomiMainInputList, LB_INSERTSTRING , (WPARAM)globals->convertConfig->inputFilenameIndex, (LPARAM) vobFilename); 									
		if(globals->convertConfig->inputFilenameIndex<MAX_INPUT_FILES)
			globals->convertConfig->inputFilenameIndex++;
		}

	memcpy(globals->gatherResults,&fileInfo,sizeof(GATHERRESULTS));
	globals->jobList[globals->jobIndex].inputValidated = true;

	configureSettings();

	// Once settings setup, transfer the chapter data found

	globals->convertConfig->numChapters = fileInfo.chaptersFound;

	if(fileInfo.chaptersFound)
		{
		for(i=0;i<fileInfo.chaptersFound;i++)
			{
			globals->convertConfig->chapterStartFramePos[i] = fileInfo.chapterStartFramePos[i];
			}
		}
	//UpdateWindow(dialoghWnd);

	return(true);
}

// *****************************************************************************
// windowClass::doneConverting()
//
//
// *****************************************************************************
void windowClass::doneConverting()
{
	enableEncodeOptionWindows();
	skin->setGizmoMultiState("startstopencoding",0);
//	globals->window->converting=false;
	globals->converting = false;

}

// *****************************************************************************
// windowClass::addFileToList()
//
// Add and validate a file
// *****************************************************************************
bool windowClass::addFileToList(char * filename)
{
	GATHERRESULTS fileInfo;						
	int i;

	if(globals->scanFile->scanFile(filename,globals->convertConfig->scanLength, globals->convertConfig->useInfoTxtFile, &fileInfo))
		{

		if(!globals->jobList[globals->jobIndex].inputValidated)
			{
			memcpy(globals->gatherResults,&fileInfo,sizeof(GATHERRESULTS));
			globals->jobList[globals->jobIndex].inputValidated = true;

			configureSettings();

			globals->convertConfig->numChapters = fileInfo.chaptersFound;

			if(fileInfo.chaptersFound)
				{
				for(i=0;i<fileInfo.chaptersFound;i++)
					{
					globals->convertConfig->chapterStartFramePos[i] = fileInfo.chapterStartFramePos[i];
					}
				}

			// If MPEG and Chroma is 420, then set encode type to YV12.
			if(globals->gatherResults->fileType ==  SCAN_FILE_TYPE_AVI)
				{
				globals->convertConfig->encodeColorSpace = rgb32Frame;
				}

			strcpy(globals->convertConfig->inputFilenames[globals->convertConfig->inputFilenameIndex],filename);
			//SetWindowText(GetDlgItem(globals->dialoghWnd, VidomiMainInputName),inputFilename);								
			skin->comboBoxInsertString("inputnametext",filename);
		
//			SendDlgItemMessage(dialoghWnd,VidomiMainInputList, LB_INSERTSTRING , (WPARAM)globals->convertConfig->inputFilenameIndex, (LPARAM) filename); 									
			if(globals->convertConfig->inputFilenameIndex<MAX_INPUT_FILES)
				globals->convertConfig->inputFilenameIndex++;

			enableEncodeOptionWindows();

			return(true);
			}
		else
			{
			//SendDlgItemMessage(dialoghWnd,VidomiMainInputList, LB_INSERTSTRING , (WPARAM)globals->convertConfig->inputFilenameIndex, (LPARAM) filename); 									
			skin->comboBoxInsertString("inputnametext",filename);
			strcpy(globals->convertConfig->inputFilenames[globals->convertConfig->inputFilenameIndex],filename);
			if(globals->convertConfig->inputFilenameIndex<MAX_INPUT_FILES)
				globals->convertConfig->inputFilenameIndex++;
			return(true);
			}
		}
	else
		{
		char messTitle[4096];
		char messText[4096];
		globals->translate->translate(messText, "VidomiMessage19");
		globals->translate->translate(messTitle, "VidomiMessage19Title");

		vidomiErrorBox(globals->hWnd,messText,messTitle,MB_OK | MB_ICONERROR);
		return(false);
		}

}

// *****************************************************************************
// windowClass::configureSettings()
//
// *****************************************************************************
void windowClass::configureSettings()
{
	int i;

	for(i=0;i<MAX_AUDIO_CHANNELS;i++)
		{
		globals->convertConfig->processAudioSelected[i] = -1;
		}

	for(i=0;i<MAX_SUBTITLE_CHANNELS;i++)
		{
		globals->convertConfig->processSubtitleMode[i] = -1;
		globals->convertConfig->processSubtitleSelected[i] = 0;
		}

	for(i=0;i<MAX_CHAPTERS;i++)
		{
		globals->convertConfig->chapterName[i][0] = 0;
		globals->convertConfig->chapterStartFramePos[i] = 0;
		}

	if(globals->gatherResults->audioFound)
		{
		//EnableWindow(GetDlgItem(dialoghWnd,VidomiMainAudioTrack), TRUE);

		globals->convertConfig->processAudioSelected[0] = 0;
		
		//SendDlgItemMessage(dialoghWnd,VidomiMainAudioTrack, CB_RESETCONTENT , 0, 0);
		for(i=0;i<globals->gatherResults->audioFound;i++)
			{
			//ret = SendDlgItemMessage(dialoghWnd,VidomiMainAudioTrack, CB_ADDSTRING , (WPARAM)i , (LPARAM) &globals->gatherResults->audioName[i]); 									
			//SendDlgItemMessage(dialoghWnd,VidomiMainAudioTrack, CB_SETITEMDATA  , ret, i);
			}
		
		//SendDlgItemMessage(dialoghWnd,VidomiMainAudioTrack, CB_SETCURSEL  , 0, 0);
		//ret = SendDlgItemMessage(dialoghWnd,VidomiMainAudioTrack, CB_GETCURSEL  , 0, 0);
		//ret = SendDlgItemMessage(dialoghWnd,VidomiMainAudioTrack, CB_GETITEMDATA , ret, 0);
		//inputSamplerate = globals->gatherResults->audioRate[ret];
		//inputChannels = globals->gatherResults->audioChannels[ret];
		}
	else
		{
		//EnableWindow(GetDlgItem(dialoghWnd,VidomiMainAudioTrack), FALSE);
		}

}
// *****************************************************************************
// windowClass::doDrop(WPARAM wParam)
//
// *****************************************************************************
void windowClass::doDrop(WPARAM wParam)
{
	int iFiles, FileIndex;
	HDROP hDropInfo;
	char* cIndex;
	char filename[MAX_PATH];
	char outputName[MAX_PATH];
	char * ptr;
	char * ptrStr;
	
	hDropInfo = (HDROP) wParam;
	FileIndex = 0;

	// Get the number of files.
	iFiles = DragQueryFile (hDropInfo, (DWORD)(-1), (LPSTR)NULL, 0);
	do
	{
		DragQueryFile (hDropInfo, FileIndex, filename, sizeof (filename));
		cIndex = strchr(filename, '.');
		if(cIndex)
			{
			if(strcmp(cIndex, ".ifo") == 0)
				addFromIfoFile(filename);
			else
				if(strcmp(cIndex, ".lst") == 0)
					addFromLstFile(filename);
				else
					addFileToList(filename);
			}
		FileIndex++;
		globals->convertConfig->endingFilePos = 0;
		globals->convertConfig->endingFileFrame = 0;
		globals->convertConfig->endingFilePos = 0x7fffffffffffffff;
		globals->convertConfig->endingFileFrame = 0;
	}while (iFiles > FileIndex);

	EnableMenuItem(mainMenu,VidomiMainMenuSelectRange,MF_BYCOMMAND | MF_ENABLED);
	if(!globals->jobList[globals->jobIndex].outputSet)
		{
		strcpy(outputName,filename);
		ptrStr = strrchr(outputName,'\\');
		if(!ptrStr)
		{
			ptrStr = outputName;
		}
		ptr = strrchr(outputName,'.');
		if(ptr)
		{
			*ptr = 0;
		}
		strcpy(filename,globals->browseDestPath);
		strcat(filename,ptrStr);
		strcat(filename,&globals->convertConfig->outputTail[0]);
		strcpy(globals->convertConfig->outputFilename,filename);
		skin->setText("outputnametext",globals->convertConfig->outputFilename);
		//SetWindowText(GetDlgItem(dialoghWnd, VidomiMainOutputName),globals->convertConfig->outputFilename);
		globals->jobList[globals->jobIndex].outputSet = true;
		globals->job->refresh();
		}
	DragFinish(hDropInfo);

}

// *****************************************************************************
// windowClass::enableEncodeOptionWindows()
//
// *****************************************************************************
void windowClass::enableEncodeOptionWindows()
{

	//if(globals->gatherResults->audioFound)
	//	EnableWindow(GetDlgItem(dialoghWnd,VidomiMainAudioTrack), TRUE);

	EnableMenuItem(mainMenu,VidomiMainMenuOptions,MF_BYCOMMAND | MF_ENABLED);
	EnableMenuItem(mainMenu,VidomiMainMenuGeneralOptions,MF_BYCOMMAND | MF_ENABLED);
	EnableMenuItem(mainMenu,VidomiMainMenuOptions,MF_BYCOMMAND | MF_ENABLED);
	EnableMenuItem(mainMenu,VidomiMainMenuViewOutputWindow,MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
	EnableMenuItem(mainMenu,VidomiMainMenuViewStatsWindow,MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
	EnableMenuItem(mainMenu,VidomiMainMenuViewEncodeControlWindow,MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);

	EnableMenuItem(mainMenu,VidomiMainMenuMode,MF_BYCOMMAND | MF_ENABLED);
	EnableMenuItem(mainMenu,VidomiMainMenuLoadSettings,MF_BYCOMMAND | MF_ENABLED);
	EnableMenuItem(mainMenu,VidomiMainMenuSaveSettings,MF_BYCOMMAND | MF_ENABLED);
	EnableMenuItem(mainMenu,VidomiMainMenuSelectRange,MF_BYCOMMAND | MF_ENABLED);
	EnableMenuItem(mainMenu,VidomiMainMenuViewJobControlWindow,MF_BYCOMMAND | MF_ENABLED);
	EnableMenuItem(mainMenu,VidomiMainMenuBatchClearJobList,MF_BYCOMMAND | MF_ENABLED);


	EnableMenuItem(mainMenu,VidomiMainMenuBatchAddToJobList,MF_BYCOMMAND | MF_ENABLED);
	EnableMenuItem(mainMenu,VidomiMainMenuVideoOptions,MF_BYCOMMAND | MF_ENABLED);
	EnableMenuItem(mainMenu,VidomiMainMenuAdvancedVideoOptions,MF_BYCOMMAND | MF_ENABLED);
	EnableMenuItem(mainMenu,VidomiMainMenuAudioOptions,MF_BYCOMMAND | MF_ENABLED);
	EnableMenuItem(mainMenu,VidomiMainMenuOutputSizeOptions,MF_BYCOMMAND | MF_ENABLED);
	EnableMenuItem(mainMenu,VidomiMainMenuNetworkOptions,MF_BYCOMMAND | MF_ENABLED);


	if(globals->convertConfig->enhancedAvi)
		{
		EnableMenuItem(mainMenu,VidomiMainMenuSubtitleOptions,MF_BYCOMMAND | MF_ENABLED);
		EnableMenuItem(mainMenu,VidomiMainMenuChapterOptions,MF_BYCOMMAND | MF_ENABLED);
		}

//	DrawMenuBar(globals->window->mainhWnd);

}

// *****************************************************************************
// windowClass::disableEncodeOptionWindows()
//
// *****************************************************************************
void windowClass::disableEncodeOptionWindows()
{
	//EnableWindow(GetDlgItem(dialoghWnd,VidomiMainOutputBrowse), FALSE);
	//EnableWindow(GetDlgItem(dialoghWnd,VidomiMainInputAdd), FALSE);
	//EnableWindow(GetDlgItem(dialoghWnd,VidomiMainClearInputList), FALSE);
	//EnableWindow(GetDlgItem(dialoghWnd,VidomiMainAudioTrack), FALSE);
	EnableMenuItem(mainMenu,VidomiMainMenuOptions,MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
	EnableMenuItem(mainMenu,VidomiMainMenuVideoOptions,MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
	EnableMenuItem(mainMenu,VidomiMainMenuAdvancedVideoOptions,MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
	EnableMenuItem(mainMenu,VidomiMainMenuAudioOptions,MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
	EnableMenuItem(mainMenu,VidomiMainMenuGeneralOptions,MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
	EnableMenuItem(mainMenu,VidomiMainMenuMode,MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
	EnableMenuItem(mainMenu,VidomiMainMenuViewOutputWindow,MF_BYCOMMAND | MF_ENABLED);
	EnableMenuItem(mainMenu,VidomiMainMenuViewStatsWindow,MF_BYCOMMAND | MF_ENABLED);
	EnableMenuItem(mainMenu,VidomiMainMenuViewEncodeControlWindow,MF_BYCOMMAND | MF_ENABLED);
	EnableMenuItem(mainMenu,VidomiMainMenuLoadSettings,MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
	EnableMenuItem(mainMenu,VidomiMainMenuSaveSettings,MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
	EnableMenuItem(mainMenu,VidomiMainMenuSelectRange,MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
	EnableMenuItem(mainMenu,VidomiMainMenuViewJobControlWindow,MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
	EnableMenuItem(mainMenu,VidomiMainMenuBatchAddToJobList,MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
	EnableMenuItem(mainMenu,VidomiMainMenuBatchClearJobList,MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
	EnableMenuItem(mainMenu,VidomiMainMenuSubtitleOptions,MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
	EnableMenuItem(mainMenu,VidomiMainMenuChapterOptions,MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
	EnableMenuItem(mainMenu,VidomiMainMenuOutputSizeOptions,MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
	EnableMenuItem(mainMenu,VidomiMainMenuNetworkOptions,MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);

	//DrawMenuBar(globals->window->mainhWnd);

}
