// *****************************************************************************
//	Vidomi - Video Encoder
//
//	Copyright (C) 2001 Vidomi, Inc.
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

// *****************************************************************************
// *****************************************************************************
// window class
// *****************************************************************************
#ifndef window_h
#define window_h

//LRESULT CALLBACK windowMessageHandler(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);

#define MODE_ENCODER 0
#define MODE_DISABLED 1

//#define ABOUT_TEXT "Vidomi video converter Version %.3f, Copyright (c) 2001, Vidomi, Inc.  All rights reserved.\nVidomi Version %.3f includes encoder.exe which is licensed under the terms of the GNU GPL 2.0.\nVidomi includes divx codec 3.11. DivXNetworks Inc. claims a trademark on DivX.\nTo learn more, please visit www.vidomi.com"

#define VidomiEncoderMessageHwnd WM_USER+1
#define VidomiPlayerMessageHwnd WM_USER+2
#define VidomiEncoderMessageActivate WM_USER+3
#define VidomiPlayerMessageActivate WM_USER+4
#define VidomiEncoderMessageDeactivate WM_USER+5
#define VidomiPlayerMessageDeactivate WM_USER+6
#define VidomiEncoderMessageTerminate WM_USER+7
#define VidomiPlayerMessageTerminate WM_USER+8

#define VidomiSwitcherCopyDataMessagePostCommandLine 1

					
   class windowClass {

	public:
									windowClass();
									~windowClass();
			bool					createWindow(HINSTANCE hInst);
			void					configureWindow(void);
			BOOL static CALLBACK	windowMessageHandler(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
			BOOL					windowMessageHandler1(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
			HMENU					mainMenuMain;
			HMENU					mainMenu;
			HMENU					optionsMenu;
			HMENU					jobControlMenu;
			HMENU					fileMenu;
			HWND					mainhWnd;
			HWND					encoderhWnd;
			void					doneConverting();
			skinsClass *			skin;
	protected:
			bool					registerWindowClass(HINSTANCE hInst,char * className);
			void					encoderMode(void);
			void					disable(void);
			bool					addFromIfoFile(char * filename);
			bool					addFromLstFile(char * filename);
			bool					addFileToList(char * filename);
			void					configureSettings();
			void					doDrop(WPARAM wParam);
			void					disableEncodeOptionWindows();
			void					enableEncodeOptionWindows();

			WNDCLASS				windCls;

			
			bool					fullscreen;
			int						savePosition;

};

#endif