#ifndef xvidstate_h
#define xvidstate_h

#define CONFIG_KBPS 1000

/* registry stuff */
#define XVID_REG_KEY    HKEY_CURRENT_USER
#define XVID_REG_SUBKEY "Software\\GNU\\XviD"
#define XVID_REG_CLASS  "config"

#define XVID_WEBSITE    "http://www.xvid.org"

/* constants */
#define CONFIG_2PASS_1_FILE "\\video.stats"
#define CONFIG_2PASS_2_FILE "\\videogk.stats"

/* property sheets - sheets can be reordered here */
#define DLG_COUNT               5

#define DLG_MAIN                0
#define DLG_ADV                 1
#define DLG_DEBUG               2
#define DLG_CPU                 3
#define DLG_ABOUT               4

/* codec modes */
#define DLG_MODE_CBR                    0
#define DLG_MODE_VBR_QUAL               1
#define DLG_MODE_VBR_QUANT              2
#define DLG_MODE_2PASS_1                3
#define DLG_MODE_2PASS_2_EXT    4
#define DLG_MODE_2PASS_2_INT    5
#define DLG_MODE_NULL                   6

/* quantizer modes */
#define QUANT_MODE_H263                 0
#define QUANT_MODE_MPEG                 1
#define QUANT_MODE_CUSTOM               2

/* credits modes */
#define CREDITS_MODE_RATE               0
#define CREDITS_MODE_QUANT              1
#define CREDITS_MODE_SIZE               2

#define CREDITS_START                   1
#define CREDITS_END                             2


typedef struct
{
        int mode;
        int quality;
        int        quant;
        int rc_bitrate;
        int rc_reaction_delay_factor;
        int rc_averaging_period;
        int rc_buffer;

        int motion_search;
        int quant_type;
        int fourcc_used;
        int max_key_interval;
        int min_key_interval;
        int lum_masking;
        int interlacing;

        int min_iquant;
        int max_iquant;
        int min_pquant;
        int max_pquant;
        BYTE qmatrix_intra[64];
        BYTE qmatrix_inter[64];

        int desired_size;
        int keyframe_boost;
        int discard1pass;
        int dummy2pass;
        int curve_compression_high;
        int curve_compression_low;
        int use_alt_curve;
        int alt_curve_use_auto;
        int alt_curve_auto_str;
        int alt_curve_use_auto_bonus_bias;
        int alt_curve_bonus_bias;
        int alt_curve_type;
        int alt_curve_high_dist;
        int alt_curve_low_dist;
        int alt_curve_min_rel_qual;
        int twopass_max_bitrate;
        int twopass_max_overflow_improvement;
        int twopass_max_overflow_degradation;
        int bitrate_payback_delay;
        int bitrate_payback_method;
        int hinted_me;
        char hintfile[MAX_PATH];
        char stats1[MAX_PATH];
        char stats2[MAX_PATH];

        int credits_start;
        int credits_start_begin;
        int credits_start_end;
        int credits_end;
        int credits_end_begin;
        int credits_end_end;

        int credits_mode;
        int credits_rate;
        int credits_quant_i;
        int credits_quant_p;
        int credits_start_size;
        int credits_end_size;

//      char build[50];
        DWORD cpu;
        float fquant;
        BOOL save;
} XVIDSTATEUNUSED;




#endif

