// *****************************************************************************
//	Vidomi - Video Encoder
//
//	Copyright (C) 2001 Vidomi, Inc.
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

// *****************************************************************************
#ifndef NCODECOMMON_H
#define NCODECOMMON_H

#define MAX_AUDIO_CHANNELS 4
#define MAX_SUBTITLE_CHANNELS 4

typedef struct {
	unsigned char * allocStart;
	unsigned char * bufferStart;
	int				bufferSize;
	unsigned char * data;
	int				width;
	int				height;
	int				stride;
	int				bitDepth;
	int				type;
	int				valid;
	int				pts;			//presentation Time Stamp
	int				hardPts;		//presentation Time Stamp from MPEG 2 stream
	int				hardPtsFrame;
	BITMAPINFO	*	windowsBitmapInfo;
} FRAMEDATA;

enum {
	rgbFrame=0,
	yuy2Frame=1,
	yv12Frame=2,
	bgrFrame=3
} ;

typedef struct {
	unsigned char * bufferStart;
	int				headUsed;
	int				bufferSize;
	unsigned char * data;
	int				bytesUsed;
	int				pts;		//presentation Time Stamp
	int				type;
} AUDIODATA;

typedef struct {
	unsigned char *		bufferStart;
	int					bufferSize;
	unsigned char *		data;
	int					bytesUsed;
	int					complete;
	DIVXSUBTITLEHEADER	header;
	DIVXSUBTITLEFORMAT	format;
} SUBTITLEDATA;

enum {
	audioMpeg=0,
	audioAc3,
	audioPcm
} ;
enum {
	audioBufferMpegRaw=0,
	audioBufferMpegDecoded,
	audioBufferAc3Raw,
	audioBufferAc3Decoded,
	audioBufferPcm
} ;
#endif
