// *****************************************************************************
// divx class
// *****************************************************************************
#ifndef divxtype_h
#define divxtype_h

typedef struct { 
    WORD left; 
    WORD top; 
    WORD right; 
    WORD bottom; 
} DIVXWORDRECT; 

typedef struct {
    DWORD dwMicroSecPerFrame;
    DWORD dwMaxBytesPerSec;
    DWORD dwReserved1;
    DWORD dwFlags;
    DWORD dwTotalFrames;
    DWORD dwInitialFrames;
    DWORD dwStreams;
    DWORD dwSuggestedBufferSize;
    DWORD dwWidth;
    DWORD dwHeight;
    DWORD dwReserved[4];
} DIVXHEADER;

typedef struct {
	DWORD	fccType;
	DWORD	fccHandler;
	DWORD   dwFlags;        
	DWORD	dwCaps;
	WORD	dwPriority;
	WORD	dwLanguage;
	DWORD   dwScale;
	DWORD   dwRate; 
	DWORD   dwStart;
	DWORD   dwLength; 
	DWORD	dwInitialFrames;
	DWORD   dwSuggestedBufferSize;
	DWORD   dwQuality;
	DWORD   dwSampleSize;
	RECT    rcFrame;
	DWORD	dwEditCount;
	DWORD	dwFormatChangeCount;
	char	szName[64];
} DIVXSTREAMINFO;


typedef struct {
    FOURCC fccType;
    FOURCC fccHandler;
    DWORD  dwFlags;
    DWORD  dwPriority;
    DWORD  dwInitialFrames;
    DWORD  dwScale;
    DWORD  dwRate;
    DWORD  dwStart;
    DWORD  dwLength;
    DWORD  dwSuggestedBufferSize;
    DWORD  dwQuality;
    DWORD  dwSampleSize;
    DIVXWORDRECT rcFrame;
} DIVXSTREAMHEADER;

typedef struct {
	DWORD			startingFrame;		// Frame to start displaying subtitle on
	WORD			duration;			// Number of frames to display subtitle.
	WORD			left;				// Left pixel pos of subtitle
	WORD			top;				// Top Line of subtitle
	WORD			right;				// right pixel pos of subtitle
	WORD			bot;				// Bottom Line of subtitle
	WORD			evenStartPos;
	WORD			oddStartPos;
} DIVXSUBTITLEHEADER;

typedef struct {
	WORD			mode;
	BYTE			remap[4];			// The four palette remap values
	DWORD			palette[4];			// Index 0 - Background
										// Index 1 - Font
										// Index 2 - Outline
										// Index 3 - Antialias
} DIVXSUBTITLEFORMAT;

typedef struct {
	WORD			entrySize;				// Size in bytes of this chapters entry. Must be even number of bytes!
	DWORD			chapterStartPos;		// First chapter entry (Pos of chapter start)
	char			chapterName[1];			// Chapter name is a null terminated wide character string
											// NOTE: Other META data can potentially be placed in this structure
											// --mode is used to determine meta data type(s)
} DIVXSTREAMCHAPTERENTRY;

typedef struct {
	WORD					mode;					// Only mode valid is 0 for basic chapter entries
	WORD					numChapters;			// Number of Chapter entries
	DIVXSTREAMCHAPTERENTRY	chapterEntry[1];		// First chapter entry (Pos of chapter start)
													// NOTE: Other META data potentially placed after all chapter start entries
													// --mode is used to determine meta data type(s)
} DIVXSTREAMCHAPTERS;
typedef struct {
	char	name[64];
	char	zero;
} DIVXSTREAMNAME;

typedef struct { 
    char tag[4];
	DWORD flags;
	DWORD filePos;
	DWORD size;
} DIVXSINGLEINDEX; 

typedef struct { 
	DIVXSINGLEINDEX entry[1];	
} DIVXINDEX; 

typedef struct {
	double	framerate;
	int		width;
	int		height;
	char	szName[64];
} DIVXVIDEOINFO;


typedef struct {
	DWORD	name;
	DWORD	size;
} DIVXCHUNK;

#endif
