// *****************************************************************************
//	Vidomi - Video Encoder
//
//	Copyright (C) 2001 Vidomi, Inc.
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

// *****************************************************************************
// *****************************************************************************
//
// This is encoderslave.h
//
// *****************************************************************************

#ifndef encoderserver_h
#define encoderserver_h

#define MAX_SLAVE_JOBS 256

typedef struct 
	{
	HWND					hWnd;
	HINSTANCE				hInst;

	int						optionsLogOutput;
	char					optionsLogFilename[MAX_PATH];
	char					pathToExeDir[MAX_PATH];
	windowClass *			window;
	listenClass *			listen;
	netHelperClass *		netHelper;
	SLAVEJOBLIST *			slaveJobList;
	int						slaveJobListSize;
	int						slaveJobCounter;
	CRITICAL_SECTION		slaveJobListLock;
	visualLogClass *		visualLog;
	int						numSlaveEncodeMachines;
	SLAVEENCODEMACHINES *	slaveEncodeMachines;			
	serverLoopClass *		serverLoop;
	CONVERSIONSTATS *		slaveEncodeStats;
	CRITICAL_SECTION		slaveEncodeStatsLock;
	int						jobsBeingProcessed;
	int						slavesAvailable;
	int						jobsInQueue;
	} GLOBALS;

void configureGlobals(HINSTANCE hInst);

#endif
