// *****************************************************************************
//
//
// listen.cpp
// 
//
// *****************************************************************************

#include "es.h"

extern GLOBALS * globals;

// *****************************************************************************
// listenClass::listenClass()
//
// window class constructor
// *****************************************************************************
listenClass::listenClass()
{

	listenThreadHandle = NULL;
}

// *****************************************************************************
// listenClass::~listenClass()
//
// window class destructor
// *****************************************************************************
listenClass::~listenClass()
{

}

// *****************************************************************************
// listenClass::begin()
//
//
// *****************************************************************************
bool listenClass::begin()
{

	listenThreadHandle = CreateThread(NULL,0,	listenThread ,(LPVOID)this , 0 ,&listenThreadId);	

	return(true);
}

// *****************************************************************************
// listenClass::end()
//
//
// *****************************************************************************
void listenClass::end()
{

	if(listenThreadHandle)
		TerminateThread(listenThreadHandle,0);	//terminate the monitor thread

}

// *****************************************************************************
// listenClass::listenThread()
//
// Returns TRUE if success
// *****************************************************************************

DWORD WINAPI listenClass::listenThread(LPVOID lParam)
{
	listenClass * listen;
	int ret;

	listen = (listenClass *) lParam;
	
	ret = listen->listen();

	ExitThread(ret);   
	return(ret);
}



// *****************************************************************************
// listenClass::listen()
//
//
// *****************************************************************************
bool listenClass::listen()
{
	DWORD listenThreadId;
	HANDLE listenThreadHandle;
	LISTENCOMMAND * listenCommand;
	tcp = new tcpClass();
	
	slaveSocket = tcp->createSocket();

	if(slaveSocket<0)
		{
		MessageBox(NULL,"Failed to Create Socket","Encode Server Failed!",MB_OK | MB_ICONERROR);
		delete tcp;
		return(false);
		}

	if(!tcp->bindSocket(slaveSocket,JOB_SERVER_PORT_NUMBER,0))
		{
		MessageBox(NULL,"Failed to Bind To Socket","Encode Server Failed!",MB_OK | MB_ICONERROR);
		tcp->closeSocket(slaveSocket);
		delete tcp;
		return(false);
		}

	if(!tcp->setSocketListen(slaveSocket))
		{
		MessageBox(NULL,"Failed to Set Socket To Listen Mode","Encode Server Failed!",MB_OK | MB_ICONERROR);
		tcp->closeSocket(slaveSocket);
		delete tcp;
		return(false);
		}

	for(;;)
		{
		rSocket = tcp->acceptConnection(slaveSocket);

		if(rSocket!=-1)
			{
			globals->visualLog->logPrintf("Received Connection\n");

			// Alloc the command struct for the command
			listenCommand = new LISTENCOMMAND [1];

			// fill it with the needed info to communicate
			listenCommand->listen = this;
			listenCommand->rSocket = rSocket;
			listenCommand->tcp = tcp;

			//Create Thread to service command
			// Note: Currently we don't clean up zombies. It would be nice if we did. 
			// We would just need to track what we're allocating and do the free if XYZ time has passed.
			listenThreadHandle = CreateThread(NULL,0, parseCommandThread , listenCommand , 0 ,&listenThreadId);	
			}
		else
			{
			Sleep(10);
			}
		}

	tcp->closeSocket(slaveSocket);

	delete tcp;

	return(false);
}

// *****************************************************************************
// listenClass::parseCommandThread()
//
// Returns TRUE if success
// *****************************************************************************

DWORD WINAPI listenClass::parseCommandThread(LPVOID lParam)
{
	jobServerClass * jobServer;
	LISTENCOMMAND * listenCommand;

	listenCommand = (LISTENCOMMAND *) lParam;

	jobServer = new jobServerClass();
	while(jobServer->processCommand(listenCommand->tcp, listenCommand->rSocket));
	
	listenCommand->tcp->closeConnection(listenCommand->rSocket);

	delete jobServer;
	delete [] listenCommand;

	ExitThread(0);   
	return(0);
}