#ifndef netcommands_h
#define netcommands_h

// This file has all the shared master / slave communication defines

#define PORT_NUMBER 9984

#define makeNetFOURCC( ch0, ch1, ch2, ch3 ) \
	( (DWORD)(BYTE)(ch0) | ( (DWORD)(BYTE)(ch1) << 8 ) |	\
	( (DWORD)(BYTE)(ch2) << 16 ) | ( (DWORD)(BYTE)(ch3) << 24 ) )

#define netStartConversion			makeNetFOURCC('C', 'O', 'N', 'V')
#define netStatus					makeNetFOURCC('S', 'T', 'A', 'T')
#define netClose					makeNetFOURCC('C', 'L', 'O', 'S')
#define netError					makeNetFOURCC('E', 'R', 'O', 'R')
#define netAbort					makeNetFOURCC('A', 'B', 'R', 'T')
#define netPause					makeNetFOURCC('P', 'A', 'U', 'S')
#define netResume					makeNetFOURCC('R', 'S', 'U', 'M')
#define netSleep					makeNetFOURCC('S', 'L', 'E', 'P')
#define netThreadPriority			makeNetFOURCC('T', 'P', 'R', 'I')

#define NET_COMMAND_HEADER_SIZE 8

// Status Values
enum {
	netConversionStatusCommandFailed=0,
	netConversionStatusIdle,
	netConversionStatusWorking,
	netConversionStatusError,
	netConversionStatusDone
} ;

// This must be a flat structure
typedef struct {
	DWORD			command;		// FourCC command
	int				size;			// number of bytes that follow
	CONVERTCONFIG	settings;
	GATHERRESULTS	scan;

	// These are the codec settings in flat form. I Wish I made them flat about now..
	COMPVARS		settingsVideoFormatOut;
	BITMAPINFO		settingsVideoFormatOutLpbiOut;
	char			settingsVideoFormatOutLpState[VIDEO_STATE_DEFAULT_SIZE];
	COMPVARS		settingsVideoFormatOutP2;
	BITMAPINFO		settingsVideoFormatOutP2LpbiOut;
	char			settingsVideoFormatOutP2LpState[VIDEO_STATE_DEFAULT_SIZE];
	char			settingsAudioFormatOut[AUDIO_STATE_DEFAULT_SIZE];
} NETSTARTCONVERSION;

typedef struct {
	DWORD			command;		// FourCC command
	int				size;			// number of bytes that follow
} NETSTATUS;

typedef struct {
	int				status;
	CONVERSIONSTATS	conversionStats;
} NETSTATUSRETURN;

typedef struct {
	DWORD			command;		// FourCC command
	int				size;			// number of bytes that follow
} NETERROR;

typedef struct {
	char			errorText[8192];
} NETERRORRETURN;

typedef struct {
	DWORD			command;		// FourCC command
	int				size;			// number of bytes that follow
} NETABORT;

typedef struct {
	DWORD			command;		// FourCC command
	int				size;			// number of bytes that follow
} NETPAUSE;

typedef struct {
	DWORD			command;		// FourCC command
	int				size;			// number of bytes that follow
} NETRESUME;

typedef struct {
	DWORD			command;		// FourCC command
	int				size;			// number of bytes that follow
	int				sleepValue;
} NETSLEEP;

typedef struct {
	DWORD			command;		// FourCC command
	int				size;			// number of bytes that follow
	int				threadPriority;
} NETTHREADPRIORITY;

typedef struct {
	DWORD			command;		// FourCC command
	int				size;			// number of bytes that follow
} NETCLOSE;

#endif