// *****************************************************************************
//
//
// window.cpp
// 
//
// *****************************************************************************

#include "es.h"

extern GLOBALS * globals;

// *****************************************************************************
// windowClass::windowClass()
//
// window class constructor
// *****************************************************************************
windowClass::windowClass()
{
	windowhWnd = NULL;
	
}

// *****************************************************************************
// windowClass::~windowClass()
//
// window class destructor
// *****************************************************************************
windowClass::~windowClass()
{

	if(windowhWnd)
		{
		DestroyWindow(windowhWnd);
		}

}

// *****************************************************************************
// windowClass::createWindow()
//
//
// *****************************************************************************
bool windowClass::createWindow(HINSTANCE hInst)
{

	registerWindowClass(hInst,"vidomiServerWindow");
	
	globals->hWnd = CreateWindowEx(0, "vidomiServerWindow", "Vidomi Server", WS_TILEDWINDOW,
							0, 0, 
							500, 240, NULL, NULL, hInst, NULL );

	ShowWindow(globals->hWnd, SW_SHOW);
	return(true);
}

// *****************************************************************************
// windowClass::registerWindowClass()
//
//
// *****************************************************************************
bool windowClass::registerWindowClass(HINSTANCE hInst,char * className)
{
	//Main Window
	windCls.style         = CS_HREDRAW | CS_VREDRAW;
    windCls.lpfnWndProc   = (WNDPROC)windowMessageHandler;
    windCls.cbClsExtra    = 0;
    windCls.cbWndExtra    = 0;
    windCls.hInstance     = hInst;          
    windCls.hIcon         = LoadIcon(hInst, MAKEINTRESOURCE(VidomiIcon));
    windCls.hCursor       = LoadCursor(NULL, IDC_ARROW);
    windCls.hbrBackground = (HBRUSH) GetStockObject(BLACK_BRUSH);
    windCls.lpszMenuName  = NULL; 
	windCls.lpszClassName = className;
	
    if (!RegisterClass( &windCls))
		{
        return FALSE;
		}

	return TRUE;
}
// *****************************************************************************
// windowClass::windowMessageHandler()
//
//
// *****************************************************************************
BOOL CALLBACK windowClass::windowMessageHandler(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{

	return(globals->window->windowMessageHandler1(hWnd,message,wParam,lParam));


}
// *****************************************************************************
// windowClass::windowMessageHandler1()
//
//
// *****************************************************************************
BOOL windowClass::windowMessageHandler1(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	unsigned short commandId;
	unsigned short commandEvent;
	PAINTSTRUCT paint;
	HDC hDC;

	switch(message)
		{
		case WM_DESTROY:
			PostQuitMessage(0);
			return(FALSE);


		case WM_COMMAND:
            commandId    = LOWORD(wParam); // Remember, these are...
			commandEvent = HIWORD(wParam); // ...different for Win32!
			//Parse the menu selections:
			/*
			switch (commandId) 
				{
				default:
					break;
				}
				*/
			break;

		case WM_PAINT:
			hDC = BeginPaint(hWnd,&paint);
			globals->visualLog->paintWindow(hDC,&paint.rcPaint);
			EndPaint(hWnd,&paint);
			break;
 
		default:
			return (DefWindowProc(hWnd, message, wParam, lParam));
		}
	return(TRUE);
}

